Callback.picOrPhoto = function(btnId) {
    var list = [];
    var choice1 = {
        name: '拍照',
        action: 'getPic',
        otherFunctions: 'data-rel="1" data-router="previewImg"'
    };
    var choice2 = {
        name: '从手机相册选择',
        action: 'getPic',
        otherFunctions: 'data-rel="2" data-router="previewImg"'
    };
    list.push(choice1);
    list.push(choice2);
    Widget.popupMultipleChoice(list);
};

Callback.getPic = function(btnId) {
    var _btn = $('#' + btnId);
    var _rel = _btn.attr('data-rel') - 0;
    var _router = _btn.attr('data-router');
    Teletext.getPicture(_rel, Callback[_router], btnId);
};
var Teletext = {
    getPicture: function(status, onSuccess, btnId) {
        var popover = this._getPopover(btnId);
        var config = this.config(status, popover);
        onSuccess = (!onSuccess) ? this.onSuccess : onSuccess;
        navigator.camera.getPicture(onSuccess, this.onFail, config);
    },
    config: function(status, popover) {
        var destinationType = navigator.camera.DestinationType;
        var pictureSource = navigator.camera.PictureSourceType;
        var saveToPhotoAlbum = null;
        if (status == 1) {
            source = pictureSource.Camera;
            saveToPhotoAlbum = true;
        } else if (status == 2) {
            source = pictureSource.PHOTOLIBRARY;
            saveToPhotoAlbum = false;
        }
        var config = {
            quality: 50,
            destinationType: destinationType.FILE_URI,
            sourceType: source,
            correctOrientation: true,
            popoverOptions: popover,
            saveToPhotoAlbum: saveToPhotoAlbum
        };
        return config;
    },
    onSuccess: function() {

    },
    _getPopover: function(btnId) {
        var _btn = $('#' + btnId);
        var offset = _btn.offset();
        return new CameraPopoverOptions(
            offset.left, offset.top, _btn.outerWidth(), _btn.outerHeight(),
            Camera.PopoverArrowDirection.ARROW_DOWN);
    },
    onFail: function(message) {
        Util.log('Failed because: ' + message);
    }
};
Callback.previewImg = function(imageURL) {
    Widget.popupWrapperHide();
    /*var _bPic = $('#previewPic');
     _bPic.parent().addClass('ui-btn').attr('data-action', 'showChatImg');
     _bPic.addClass('picStyle').attr('src', imageURI);*/
    var data = {
        sessionId: Util.data('data.chatSessionId'),
        msgType: 'P'
    };
    Util.data('data.picOrAudioData',data);
    Util.data('data.chatImageOrAudioURL',imageURL);
    FSManager.upload({
        file: imageURL,
        url: MEDIA_URL + '/image',
        data: {
            app: 'mobileclinic'
        },
        onSuccess: 'picOrAudioUploadSuccess',
        onError: 'picOrAudioUploadError'
    });
};

Callback.picOrAudioUploadSuccess = function(r) {
    var json = JSON.parse(r.response);
    if (json.success) {
//Widget.popupLoading('上传中...');
        var data = Util.data('data.picOrAudioData');
// if(data.msgType === 'P') {
        data.fileId = json.data;
// }
        Views.chatView.uploadPicOrAudio(data);
    } else {
//Widget.popupLoadingClose();
        if (json.errMsg) Widget.popupToast(json.errMsg);
    }
};

Callback.picOrAudioUploadError = function(err) {
//FSManager.debugUploadOrDownloadError(err);
    Util.alert('文件上传失败:-(');
};