var DataExchange = {
	commonAjax: function (tip, type, options, hasData, dataStr) {
		if (tip) {
			if(typeof DataExchange[tip] === 'function'){
				DataExchange[tip]();
			}
//			else if($.trim(tip)){
//				Widget.popupLoading(tip);
//			}
		}
		var url = options.url, ajaxOps,webUrl;

		switch (options.RPC) {
			case 'A':
				webUrl = WEB_URL_A;
				break;
			case 'P':
				webUrl = WEB_URL_P;
				break;
			case 'S':
				webUrl = WEB_URL_S;
				break;
			default:
				webUrl = WEB_URL;
		}

		delete options.RPC;
		if(options.async == undefined){
			options.async = true;
		}
		ajaxOps = {
			url: webUrl + url,
			type: type,
			dataType: 'json',
			async: options.async
		};
		delete options.async;
		delete  options.url;
		if (hasData) {
			ajaxOps.data = dataStr ? options[dataStr] : options;
		}
		console.log("发送的数据");
		console.log(ajaxOps);
		return $.ajax( ajaxOps );
	},
    commonPost: function (tip, options, hasData, dataStr) {
        return this.commonAjax(tip, 'POST', options, hasData, dataStr).fail(this.ajaxFailureHandler).done(this.ajaxDoneHandler);
    },
    commonGet: function (tip, url) {
        return this.commonAjax(tip, 'get', { url: url }).fail(this.ajaxFailureHandler).done(this.ajaxDoneHandler);
    },
	commonGet1: function(tip, options, hasData, dataStr) {
		return this.commonAjax(tip, 'get', options, hasData, dataStr).fail(this.ajaxFailureHandler).done(this.ajaxDoneHandler);;
	},
    commonJson: function (url) {
        return $.getJSON(url);
    },
    commonText: function (url) {
        return $.get(url);
    },
    ajaxDoneHandler: function (json) {
        console.log("响应的数据");
        console.log(json);
        Widget.popupLoadingClose();
        if (!json.success) {
            Widget.popupToast(json.errMsg);
        }
    },

    ajaxFailureHandler: function (jqXHR, textStatus, errorThrown) {
        Widget.popupLoadingClose();
		if (!mobile_system && navigator.network && navigator.network.connection.type === Connection.NONE) {
			Util.alert('无网络连接，请检查您的设置！');
		} else {
			Util.alert('网络异常，请稍候重试...');
		}
    },
    upInfo: function () {
        Widget.popupLoading('上传中...');
    },
    getInfo: function () {
        Widget.popupLoading('获取中...');
    },
    delInfo: function () {
        Widget.popupLoading('删除中...');
    },
    sendCode: function () {
        Widget.popupLoading('验证码到达途中...');
    },
    cancelInfo: function () {
        Widget.popupLoading('取消中...');
    },
    up: 'upInfo',
    get: 'getInfo',
    del: 'delInfo',
    send: 'sendCode',
    cancel: 'cancelInfo',
//-----------------------------------------maternal start
    //---添加预产期or修改预产期
    addExpectConfinementDate: function (options) {
        options.url = "/resident/edc/add/" + options.memberId;
        delete  options.memberId;
        options.lmp = new Date(options.lmp);
        return this.commonPost(this.up, options, true);
    },

    //-----获取预产期
    getExpectConfinementDate: function (options) {
        options.url = "/resident/edc/get/" + options.memberId;
        return this.commonPost(this.get, options, false);
    },

    //---产期自测
    getWeekSituations: function (options) {
        options.url = '/resident/noticeSituations/situation/get';
        options.data = {agencyId: COMPANYID, pregnantWeek: options.week};
        return this.commonPost(this.get, options, true, 'data');
    },

    //---注意事项
    getMonthSituations: function (options) {
        options.url = '/resident/noticeSituations/notice/get';
        options.data = {agencyId: COMPANYID, pregnantMonth: options.month};
        return this.commonPost(this.get, options, true, 'data');
    },

    //---产检时间
    getCheckTimeMaternal: function (options) {
        options.url = '/resident/screening/schedules/get/sevenDay/' + options.memberId;
        options.data = {agencyId: COMPANYID,
            queryDate: options.queryDate, "memberId": options.memberId};
        return this.commonPost(this.get, options, true, 'data');
    },

    //接口未完善
    getReportMaternal: function (options) {
        options.url = '/resident/screening/items/get';
        options.data = {agencyId: COMPANYID};
        return this.commonPost(options, true, 'data');
    },

    //接口未完善
    getReportDetailMaternal: function (options) {
        options.url = '/resident/screening/items/get';
        options.data = {agencyId: COMPANYID};
        return this.commonPost(this.get, options, true, 'data');
    },
//-----------------------------------------maternal end

//-----------------------------------------baby start
    getImmunizationTime: function (options) {
        options.url = "/resident/child/vanccinations/get/" + LocalMode('baby').get().memberId;
        return this.commonPost(this.get, options, false);
    },
    getImmunizationTimeDetail: function (options) {
        options.url = "/resident/child/vanccinations/detail/get/" + LocalMode('baby').get().memberId + "/" + options.id;
        return this.commonPost(this.get, options, false);
    },
    getVitalSignRecords: function (options) {
        options.url = '/resident/child/growth/vitalSignRecords/get/' + LocalMode('baby').get().memberId;
        return this.commonPost(this.get, options, true);
    },
    upVaccineTime: function (options) {
        options.url = "/resident/child/vanccinations/upd/vaccineTime";
        return this.commonPost(this.up, options, true, 'data');
    },
    delVitalSignRecords: function (options) {
        options.url = '/resident/child/growth/vitalSignRecords/del/' + options.id;
        return this.commonPost(this.del, options, false);
    },

    addVitalSignRecords: function (options) {
        options.url = '/resident/child/growth/vitalSignRecords/add/' + LocalMode('baby').get().memberId;
        return this.commonPost(this.up, options, true, 'tempBabyData');
    },

    updVitalSignRecords: function (options) {
        options.url = '/resident/child/growth/vitalSignRecords/upd/' + options.id;
        return this.commonPost(this.up, options, true, 'tempBabyData');
    },

    getVitalSignsItem: function (options) {
        options.url = '/resident/child/growth/vitalSigns/get/' + LocalMode('baby').get().memberId;
        return this.commonPost(this.get, options, true);
    },
    getChildVanccinations: function (options) {
        options.url = "/resident/child/vanccinations";
        return this.commonPost(this.get, options, false);
    },
//-----------------------------------------baby end

//-----------------------------------------center start
    addMember: function (options) {
        options.url = '/resident/patient/bind';
        return this.commonPost(this.up, options, true);
    },

    getMedCard: function (options) {
        options.url = '/resident/medicalcard/get/underAccount/' + COMPANYID + "/" + options.accountId;
        return this.commonPost(this.get, options, false);
    },
    getMedCardById: function (options) {
        options.url = '/resident/medicalcard/get/underPatient/' + COMPANYID + '/' + options.id;
        return this.commonPost(this.get, options, false);
    },
    delMedCard: function (options) {
        options.url = '/resident/medicalcard/unBind/' + options.query;
        return this.commonPost(this.del, options, false);
    },

    getMedCardDet: function (options) {
        options.url = '/resident/medicalcard/get/CardInfo/' + options.cardId;
        return this.commonPost(this.get, options, false);
    },

    delMember: function (options) {
        options.url = '/resident/patient/unbind/' + COMPANYID + '/' + options.patientId;
        return this.commonPost(this.del, options, false);
    },

    getResetCode: function (options) {
        options.url = '/resident/user/reset/verifycode/' + options.mobileNo;
        return this.commonPost(this.send, options, false);
    },

    resetUserAccount: function (options) {
        options.url = '/resident/user/reset';
        return this.commonPost(this.up, options, true);
    },

    updateMember: function (options) {
        options.url = '/resident/patient/update';
        return this.commonPost(this.up, options, true);
    },

    addMedCard: function (options) {
        options.url = '/resident/medicalcard/bind';
        return this.commonPost(this.up, options, true);
    },

    getAddMedCardCode: function (options) {
        options.url = '/resident/medicalcard/bindMedicalCard/verifycode/' + options.mobileNo;
        return this.commonPost(this.send, options, true, 'data');
    },

    resetAccountPwd: function (options) {
        options.url = '/resident/user/updatepwd/update';
        return this.commonPost(this.up, options, true);
    },

    getNewVersion: function (appInit) {
        var options = {};
        options.url = '/mySetting/version/current/' + COMPANYID + '/' + mobile_system;
        options.data = {versionId: VERSION_NUMBER};
        if (appInit) {
            return DataExchange.commonAjax("", 'POST', options, true, 'data').done(function () {
                Widget.popupLoadingClose();
            }).fail(this.ajaxFailureHandler);
        }
        return DataExchange.commonPost(this.get, options, true, 'data');
    },

    upMedCard: function (options) {
        options.url = '/resident/medicalcard/update';
        return this.commonPost(this.up, options, true);
    },

    getSetting: function (options) {
        options.url = '/mySetting/pushSettings/get/' + options.familyId;
        return this.commonPost(this.get, options, false);
    },
    upSetting: function (options) {
        options.url = '/mySetting/pushSettings/upd';
        return this.commonPost(this.up, options, true);
    },
    chronicDiseaseManage: function (options) {
        options.url = "/resident/chronicDiseaseManage/sel/devices";
        return this.commonPost(this.get, options, true);
    },
    getDeviceDetail: function (options) {
        options.url = "/resident/chronicDiseaseManage/sel/devmember";
        return this.commonPost(this.get, options, true);
    },
    bindDevice: function (options) {
        options.url = '/resident/chronicDiseaseManage/bindDevice';
        return this.commonPost(this.up, options, true);
    },
//	closeQuestion: function(options) {
//		return $.ajax({
//			url: WEB_URL + '/mySetting/pushSettings/upd' ,
//			type: 'POST',
//			dataType: 'json',
//			data: options
//		}).fail(function() {
//			Widget.popupLoadingClose();
//			Widget.popupToast('网络异常，请重试:-(');
//		});
//	},

    sendSafeQuestions: function (options) {
        options.url = '/resident/user/sendSafeQuestions/' + options.accountId;
        return this.commonPost(this.get, options, false);
    },

    addDeviceDetail: function (options) {
        return this.commonPost(this.up, options, true, 'data');
    },

    saveAnswers: function (options, iswhen) {
        options.url = '/resident/user/saveAnswers';
        if (iswhen) {
            return DataExchange.commonAjax('', 'POST', options, true);
        } else {
            return DataExchange.commonPost(this.up, options, true);
        }
    },

    validSafeQ: function (options) {
        options.url = "/resident/user/validAnswers";
        return this.commonPost(this.up, options, true);
    },
    getSafePwd: function (options) {
        options = options || {};
        options.url = "/resident/user/answeredQuestions/" + UserProfile.mobile;
        return this.commonPost(this.get, options);
    },
    addFeedback: function (options) {
        options.url = '/mySetting/addSuggestionFeedback';
        return this.commonPost(this.up, options, true);
    },

    healthNewsCatalogs: function (options) {
        options.url = '/resident/healthNews/catalogs/get/' + COMPANYID;
        return this.commonPost(this.get, options, true, 'familyId');
    },
    healthNewsItem: function (options) {
        options.url = '/resident/healthNews/favorites/get/' + options.familyId;
        return this.commonPost(this.get, options, true, 'data');
    },

    healthConsult: function (options) {
        options.url = '/resident/healthConsult/collect/get';
        return this.commonPost(this.get, options, true, 'data');
    },

    delHealthConsult: function (options) {
        options.url = '/resident/healthConsult/collect/del';
        options.accountId = UserProfile.id;
        options.topId = options.id;
        return this.commonPost(this.cancel, options, true);
    },

    delHealthNews: function (options) {
        options.url = '/resident/healthNews/favorites/del/' + options.familyId + '/' + options.newsIdsStr;
        return this.commonPost(this.cancel, options, false);
    },

    getHospitalList: function () {
        var url = '/resident/hospital/subHospitals/' + COMPANYID;
        return this.commonGet(this.get, url);
    },
    getHospitalAllList: function () {
        var url = '/resident/hospital/subHospitalsNoFilter/' + COMPANYID;
        return this.commonGet(this.get, url);
    },

    getDeptList: function (options) {
        options.url = '/resident/hospital/' + options.hospitalId + '/depts/reg/common';
        return this.commonPost(this.get, options, true, 'data');
    },

    getDocList: function (options) {
        var url = '/resident/hospital/' + options.hospitalId + '/experts/reg/' + options.deptId;
        return this.commonGet(this.get, url);
    },

    getDeptClass: function (options, iswhen) {
        options.url = '/resident/schedule/hospital/' + COMPANYID + '/dept/' + options.deptId;
        if (iswhen) {
            return DataExchange.commonAjax("", 'POST', options, true);
        } else {
            return DataExchange.commonPost(this.get, options, true);
        }
    },
    getDeptInfo: function (options, iswhen) {
        options.url = '/resident/hospital/' + options.hospitalId + '/' + options.deptId + '/info';
        if (iswhen) {
            return DataExchange.commonAjax("", 'POST', options, false);
        } else {
            return DataExchange.commonPost(this.get, options, false);
        }
    },

    getIndexDate: function (options, iswhen) {
        options.url = '/resident/schedule/hospital/number';
        if (iswhen) {
            return DataExchange.commonAjax("", 'POST', options, true);
        } else {
            return DataExchange.commonPost(this.get, options, true);
        }
    },

    reg: function (options) {
        options.url = '/resident/guahao/apply/' + options.regFlag;
        delete options.regFlag;
        return this.commonPost(this.up, options, true);
    },

    getDocClass: function (options, iswhen) {
        options.url = '/resident/schedule/hospital/' + options.hospitalId + '/dept/' + options.deptId + '/expert/' + options.expertId;
        if (iswhen) {
            return DataExchange.commonAjax("", "POST", options, false);
        } else {
            return DataExchange.commonPost(this.get, options, false);
        }
    },

    getDocInfo: function (options, iswhen) {
        options.url = '/resident/hospital/' + options.hospitalId + '/' + options.deptId + '/' + options.expertId + '/info';
        if (iswhen) {
            return DataExchange.commonAjax("", "POST", options, false);
        } else {
            return DataExchange.commonPost(options, false);
        }
    },

    getRecipeList: function (options) {
        options.url = "/resident/reports/presByPatient/" + COMPANYID + "/" + UserProfile.id + "/" + Util.data('current.member').id;
        return this.commonPost(this.get, options, true, 'data');
    },

    getRecipeDetail: function (options) {
        options.url = "/resident/reports/prescription/detail/" + COMPANYID + '/' + options.hisRegId;
        return this.commonPost(this.get, options, false);
    },

    getMedicalTreatRecords: function (options) {
        options.url = "/resident/reports/visitDoctor/" + COMPANYID + '/' + UserProfile.id + "/" + Util.data('current.member').id;
        options.data.isSurvey = 2;
        return this.commonPost(this.get, options, true, 'data');
    },

    getMedialTreatRecordDetail: function (options) {
        options.url = "/resident/reports/visitDoctor/detail/" + options.treatRecordId;
        return this.commonPost(this.get, options, false);
    },

    getTreatEvaluateSurvey: function (options) {
        options.url = "/resident/survey/subject/" + options.tmId;
        return this.commonPost(this.get, options, false);
    },

    addTreatEvaluateSurvey: function (options) {
        options.url = "/resident/survey/answer";
        options.patientId = Util.data('current.member').id;
        options.accountId = UserProfile.id;
        return this.commonPost(this.get, options, true);
    },

    getTreatEvaluateSurveyResult: function (options) {
        options.url = "/resident/survey/result";
        return this.commonPost(this.get, options, true);
    },

    getMedicalExpenses: function (options) {
        options.url = "/resident/medicalExpenses/findMedicalExpenses";
        return this.commonPost(this.get, options, true);
    },

    getOrgDetail: function (options) {
        var url = "/resident/hospital/get/" + options.hosId;
        return this.commonGet(this.get, url);
    },

    getFeeRecord: function (options) {
        options.url = "/resident/reports/expenseByPatient/" + COMPANYID + "/" + UserProfile.id + "/" + Util.data('current.member').id;
        return this.commonPost(this.get, options, true, 'data');
    },

    getFeeDetail: function (options) {
        options.url = "/resident/reports/expense/detail/" + options.baseId;
        return this.commonPost(this.get, options, false);
    },
    getStationList: function (options) {
        var url = "/resident/hospital/subStations/" + options.agencyId;
        return this.commonGet(this.get, url);
    },
    getStationDetail: function (options) {
        var url = "/resident/hospital/getStation/" + options.id;
        return this.commonGet(this.get, url);
    },
    getOrgRecord: function (options, regType) {
        //options.regType = 0;
        options.url = '/resident/reports/regOnline/' + COMPANYID + "/"
            + UserProfile.id + "/" + Util.data('current.member').id + "/" + (regType ? regType : 0);
        return this.commonPost(this.get, options, true, 'data');
    },
    getRealTimeOrgRecord: function (options) {
        return this.getOrgRecord(options, 1);
    },
    getOfflineRecord: function (options) {
        return this.getOrgRecord(options, 2);
    },
    updateOrg: function (options) {
        options.url = "/resident/guahao/cancel/" + COMPANYID + "/" + options.applyId;
        return this.commonPost(this.up, options, false);
    },
    //-----------------------------------------consult >>>>
    getConsultLatestQuestions: function (options) {
        options.url = "/resident/healthConsult/latestConsults/get";
        return this.commonPost(this.get, options, true, "data");
    },
    getConsultMyQuestions: function (options) {
        options.url = "/resident/healthConsult/myConsultHealth/get";
        return this.commonPost(this.get, options, true, "data");
    },
    getConsultConversation: function (options) {
        options.url = "/resident/healthConsult/consultDialogList";
        return this.commonPost(this.get, options, true, "data");
    },
    consultConversationTextSubmit: function (options) {
        options.url = "/resident/healthConsult/addAgain";
        return this.commonPost(this.up, options, true, "data");
    },
    endConsultQuiz: function (options) {
        options.url = "/resident/healthConsult/close/" + options.topId;
        return this.commonPost(this.up, options);
    },
    addCollectConsultQuiz: function (options) {
        options.url = '/resident/healthConsult/collect/add/' + options.data.topId + '/' + options.data.memberId;
        return this.commonPost(this.up, options);
    },
    removeCollectConsultQuiz: function (options) {
        options.url = '/resident/healthConsult/collect/del';
        return this.commonPost(this.up, options, true, "data");
    },
    getConsultSorts: function (options) {
        options.url = "/resident/healthConsult/consultSorts/get/" + COMPANYID;
        return this.commonPost(this.get, options);
    },
    consultQuizSubmit: function (options) {
        options.url = "/resident/healthConsult/add";
        return this.commonPost(this.up, options, true, "data");
    },
    //-----------------------------------------consult <<<<
    //-----------------------------------------chronic >>>>
    removeChronicVitalSign: function (options) {
        options.url = '/resident/riskAssess/vital/del/' + options.signFormId;
        return this.commonPost(this.up, options);
    },
    getChronicVitalSigns: function (options) {
        options.url = '/resident/riskAssess/vital/chart/get';
        return this.commonPost(this.get, options, true, 'data');
    },
    getBPTrendData: function (options) {
        options.url = '/resident/riskAssess/vital/analysis';
        return this.commonPost(this.get, options, true, 'data');
    },
    getChronicRiskAssess: function (options) {
        options.url = "/resident/riskAssess/get/" + options.riskId;
        return this.commonPost(this.get, options);
    },
    chronicRiskAssessSubmit: function (options) {
        options.url = '/resident/riskAssess/add';
        return this.commonPost(this.get, options, true, 'data');
    },
    addChronicVitalSign: function (options) {
        options.url = '/resident/riskAssess/vital/add';
        return this.commonPost(this.up, options, true, 'data');
    },
    getChronicRevisit: function (options) {
        options.url = "/resident/chronicDiseaseManage/hypertensionVisits/get/1";
        return this.commonPost(this.up, options);
    },
    getChronicRiskAssessDates: function (options) {
        options.url = "/resident/riskAssess/dates/get";
        return this.commonPost(this.get, options, true, 'data');
    },
    //-----------------------------------------chronic <<<<
    //-----------------------------------------检查检验 >>>>
    getHealthExaminationCheck: function (options) {
        options.url = "/resident/examReport/get/" + COMPANYID + "/" + UserProfile.id + '/' + Util.data('current.member').id;
        return this.commonPost(this.get, options, true, 'data');
    },
    getHealthExaminationTest: function (options) {
        options.url = "/resident/reports/assayByPatient/new/" + COMPANYID + "/" + UserProfile.id + '/' + Util.data('current.member').id;
        return this.commonPost(this.get, options, true, 'data');
    },
    getHealthExaminationCheckDetail: function (options) {
        options.url = "/resident/examReport/get/" + options.checkDetailId;
        return this.commonPost(this.get, options);
    },
    getHealthExaminationTestDetail: function (options) {
        options.url = "/resident/reports/assay/detail/" + options.testDetailId;
        return this.commonPost(this.get, options);
    },
    //-----------------------------------------检查检验 <<<<
    //-----------------------------------------健康资讯 >>>>
    getHealthNewsCategories: function (options) {
        options.url = "/resident/healthNews/catalogs/get/" + COMPANYID;
        return this.commonPost(this.get, options);
    },
    getHealthNews: function (options) {
        options.url = "/resident/healthNews/" + options.catalogId;
        return this.commonPost(this.get, options, true, 'data');
    },
    getHealthNewsDetail: function (options) {
        options.url = "/resident/healthNews/detail/get/" + options.newsId;
        return this.commonPost(this.get, options, true, 'data');
    },
    addHealthNewsComment: function (options) {
        options.url = "/resident/healthNewsComments/add/" + options.newsDetailId + "/" + options.familyId + "/" + options.memberId;
        return this.commonPost(this.get, options, true, 'data');
    },
    removeHealthNewsCollect: function (options) {
        options.url = "/resident/healthNews/favorites/del/" + options.familyId + "/" + options.newsDetailId;
        return this.commonPost(this.del, options);
    },
    addHealthNewsCollect: function (options) {
        options.url = "/resident/healthNews/favorites/add/" + options.familyId + "/" + options.newsDetailId;
        return this.commonPost(this.up, options);
    },
    getHealthNewsShareInfo: function (options) {
        options.url = "/resident/healthNews/share/" + options.newsDetailId;
        return this.commonPost(this.get, options);
    },
    getHealthNewsComments: function (options) {
        options.url = "/resident/healthNewsComments/get/" + options.newsDetailId;
        return this.commonPost(this.get, options, true, 'data');
    },
    //-----------------------------------------健康资讯 <<<<
    //-----------------------------------------登录注册 >>>>
    getSecurityQuestions: function (options) {
        options.url = "/resident/user/answeredQuestions/" + options.account;
        return this.commonPost(this.get, options);
    },
    resetAccount: function (options) {
        options.url = "/resident/user/forgetpwd/reset";
        return this.commonPost(this.up, options, true, 'data');
    },
    getForgetPwdSecuritycode: function (options) {
        options.url = "/resident/user/forgetpwd/verifycode/" + options.phone;
        return this.commonPost(this.send, options);
    },
    getRegisterSecuritycode: function (options) {
        options.url = "/resident/user/register/verifycode/" + options.phone;
        return this.commonPost(this.send, options);
    },
    registerSubmit: function (options) {
        options.url = "/resident/user/register";
        return this.commonPost(this.up, options, true, 'data');
    },
    //-----------------------------------------登录注册 <<<<

    //健康工具
    getYgzcResult: function (options) {
        options.url = '/resident/tools/hbselftest';
        return this.commonPost(this.get, options, true, 'data');
    },
    getPredictedBabyBloodType: function (options) {
        options.url = '/resident/tools/babyBlood';
        return this.commonPost(this.get, options, true, 'data');
    },
    addTcmPhysicalTest: function (options) {
        options.url = '/resident/tcm/physicalSelfTestsResult';
        return this.commonPost(this.up, options, true, 'data');
    },
    getTcmPhysicalTestHistory: function (options) {
        options.url = '/resident/tcm/memberPhysicalSelf';
        return this.commonPost(this.get, options, true, 'data');
    },
    getCheckTestItems: function (options) {
        options.url = '/resident/tools/checklistitems';
        return this.commonPost(this.get, options, true, 'data');
    },
    getCheckTestItemsByName: function (options) {
        options.url = '/resident/tools/checklistitems';
        return this.commonPost(this.get, options, true, 'data');
    },
    getCheckTestDetailItem: function (options) {
        options.url = '/resident/tools/checklistitems/itemcontent';
        return this.commonPost(this.get, options, true, 'data');
    },

    //家庭医生
    getCommunityDoctors: function (options) {
        options.url = '/resident/familyDoctor/communityDoctor';
        return this.commonPost(this.get, options, true, 'data');
    },
    getDoctorTeams: function (options) {
        options.url = '/resident/familyDoctor/doctorTeam';
        return this.commonPost(this.get, options, true, 'data');
    },
    getTeamDoctor: function (options) {
        options.url = "/resident/familyDoctor/doctorTeam/selDoctor";
        return this.commonPost(this.up, options, true);
    },
    getFamilyPhysician: function (options) {
        options.url = "/resident/familyDoctor/doctorTeam/getDoctor";
        return this.commonPost(this.get, options, true);
    },
    applyFamilyPhysician: function (options) {
        options.url = "/resident/familyDoctor/signing/apply";
        return this.commonPost(this.up, options, true);
    },
    applying: function (options) {
        options.url = "/resident/familyDoctor/signing/record/find";
        return this.commonPost(this.get, options, true);
    },
    myFP: function (options) {
        options.url = "/resident/familyDoctor/myFamilyDocotrs/find";
        return this.commonPost(this.get, options, true);
    },
    findFDRecord: function (options) {
        options.url = "/resident/service/record/find";
        return this.commonPost(this.get, options, true);
    },
    ensureCancelDoc: function (options) {
        options.url = "/resident/familyDoctor/signing/cancel";
        return this.commonPost(this.cancel, options, true);
    },
    findFDApplyRecord: function (options) {
        options.url = "/resident/familyDoctor/applyRecord/find";
        return this.commonPost(this.get, options, true);
    },
    showFDMessage: function (options) {
        options.url = "/resident/familyDoctor/message/find";
        return this.commonPost(this.get, options, true);
    },
    getSignDetail: function (options) {
        options.url = "/resident/familyDoctor/signing/record/get";
        return this.commonPost(this.get, options, true);
    },
    getFDById: function (options) {
        options.url = "/resident/familyDoctor/myMemberDocotrs/find";
        return this.commonPost(this.get, options, true);
    },
    ///////////-------------------------daozhen start
    bodypartSecond: function (options) {
        options.url = "/resident/guide/bodypart/second/" + options.code + "/" + options.partType;
        return this.commonPost(this.get, options, true, 'data');
    },
    bodypartFirst: function (options) {
        options.url = "/resident/guide/bodypart/first/" + options.partType;
        return this.commonPost(this.get, options, false);
    },
    guideSymptoms: function (options) {
        options.url = "/resident/guide/symptoms/" + options.id;
        return this.commonPost(this.get, options, false);
    },
    diseaseMatched: function (options) {
        options.url = "/resident/guide/disease/matched/" + options.ids;
        return this.commonPost(this.get, options, true, 'data');
    },
    ///////////-------------------------daozhen end
	///////////-------------------------daozhen end
	/********************咨询*********************/
	getCurrMsgList: function (options) {
		options.RPC = 'S';
		options.url = '/patient/consultation/msgs/inProcess';
		return this.commonPost('', options, true);
	},
	//我的医生
	getFollowedDoctors: function (options) {
		options.RPC = 'S';
		options.url = '/consultation/doctors/follow/list/'+options.patientId;
		return this.commonPost(this.get, options);
	},
	getPrivateDoctors: function (options) {
		options.RPC = 'S';
		options.url = '/consultation/doctors/p/list/'+options.patientId;
		return this.commonPost(this.get, options);
	},
	isFollowedDoctor: function (options) {
		options.RPC = 'S';
		options.url = '/patient/followdoctor/isfollow';
		return this.commonPost(this.get, options, true);
	},
	getDrCommentList: function (options) {
		options.RPC = 'S';
		options.url = '/patient/comment/list/find';
		return this.commonPost(this.get, options, true);
	},
	getDoctorDetail: function (options) {
		options.RPC = 'S';
		options.url = '/consultation/doctor/detail';
		return this.commonGet1(this.get, options, true);
	},
	followDoctor: function (options) {
		options.RPC = 'S';
		options.url = '/patient/followdoctor/add';
		return this.commonPost('正在关注，请稍候...', options, true);
	},
	unfollowDoctor: function (options) {
		options.RPC = 'S';
		options.url = '/patient/followdoctor/cancel';
		return this.commonPost('正在取消关注，请稍候...', options, true);
	},
	getDoctorList: function (options) {
		options.RPC = 'S';
		options.url = '/consultation/doctors/list';
		return this.commonGet1(this.get, options, true, 'data');
	},
	vouchers: function (options) {
		options.RPC = 'S';
		options.url = "/patient/coupon/page/" + UserProfile.id;
		return this.commonPost(this.get, options, true);
	},
	getConsultAllList: function (options) {
		options.RPC= 'S';
		options.url = '/patient/consultation/msg/refresh';
		return this.commonGet1(this.post, options, true);
	},
	addConsultAppeal: function (options) {
		options.RPC = 'S';
		options.url = '/patient/consultation/msg/appeal';
		return this.commonPost(this.up, options, true)
	},
	getConsultAppeal: function (options) {
		options.RPC = 'S';
		options.url = '/patient/consultation/appeal/detail';
		return this.commonPost(this.get, options, true)
	},
	feeRecord: function (options) {
		options.RPC = 'S';
		options.url = "/patient/consume/list/" + options.patientId;
		return this.commonPost(this.get, options, true);
	},
	feeRecordDetail: function (options) {
		options.RPC = 'S';
		options.url = "/patient/consume/detail/" + options.id;
		return this.commonGet1(this.get, options);
	},
	getCouponListWhenPay: function (options) {
		options.RPC= 'S';
		options.url = '/patient/coupon/pay/list/'+options.patientId;
		return this.commonPost(this.get, options, true, 'data');
	},
	payPrivateDoctorBefore: function (options) {
		options.RPC= 'S';
		options.url = '/consultation/patient/p/pay';
		return this.commonPost(this.post, options, true);
	},
	paySingleConsultBefore: function (options) {
		options.RPC= 'S';
		options.url = '/consultation/patient/msg/start/before';
		return this.commonPost(this.post, options, true);
	},
	refundConsult: function (options) {
		options.RPC= 'S';
		options.url = '/consultation/refund';
		return this.commonPost(this.post, options, true);
	},
	applyCloseConsult: function (options) {
		options.RPC = 'S';
		options.url = '/patient/consultation/msg/patient/close';
		return this.commonPost(this.post, options, true);
	},
	addDrComment: function (options) {
		options.RPC = 'S';
		options.url = '/patient/comment/save';
		return this.commonPost(this.up, options, true)
	},
	addFirstConsult: function (options) {
		options.RPC = 'S';
		options.url = '/patient/consultation/msg/symptom';
		return this.commonPost(this.post, options, true);
	},
	addFollowUpConsult: function (options) {
		options.RPC = 'S';
		options.url = '/patient/consultation/msg/patient/send';
		return this.commonPost(this.post, options, true);
	},
	getDrCommentDetail: function (options) {
		options.RPC = 'S';
		options.url = '/patient/comment/get';
		return this.commonPost(this.get, options, true);
	}
};