Callback.showBabyHealthCareView = function (btnId) {
    UserProfile.checkBaby();
};
//儿童保健
Views.babyHealthCareView = $.extend({}, Views.footerNavView, {
    options: {
        tmpl: 'babyHealthCareView',
        name: '儿童保健'
    },
    animationType: 'left-right',
    subViews: ['healthBabyView', 'babyVaccinationIndexView', 'babyImmunizationTimeView', 'reportBabyView', 'babyImmunizationTimeView', 'babyImmunizationTimeView', 'addBabyBodyView', 'babyTrendView', 'babyVaccinationIntroCategoryView', 'babyVaccinationIntroTabooView', 'babyVaccinationIntroReactionView', 'babyVaccinationIntroWarnView', 'babyVaccinationIntroNodoView', 'babyVaccinationIntroCareView', 'babyVaccinationIntroQuestionView', 'babyVanccinationDetailView', 'babyTestHelpView', 'reportDetailBabyView', 'healthInfoView'
    ],
    indexAlias: 'index.baby'
});
//-------------------幼儿保健  >计免时间
Views.babyImmunizationTimeView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyImmunizationTimeView',
        name: '儿童保健-计免时间'
    },
    willShow: function (ct) {
        this.render(ct, {baby: LocalMode('baby').get(), iconURL: MEMBER_ICON_URL, t: Util.rtime()});
        this.renderImmunizationData();
    },
    renderImmunizationData: function () {
        function ajaxDoneHandle(json) {
            if (json.success) {
                var data = json.data;
                if (data.length) {
                    Views.babyImmunizationTimeView.deployImmunizationListAsHtml(data);
                }
            }
        };
        DataExchange.getImmunizationTime({}).done(ajaxDoneHandle);
    },
    deployImmunizationListAsHtml: function (data) {
        $('#babyImmunizationTimeData').html(Views.tmpl.babyImmunizationTimeSubView({WEB_URL: WEB_URL, data: data}));
        this.viewScrollerInit($('#babyImmunizationTimeContent'));
    }
});

Callback.showBabyVanccinationDetail = function (btnId) {
    var $ele = $("#" + btnId);
    var options = {
        id: $ele.attr("data-rel-id")
    };

    function ajaxDoneHandle(json) {
        if (json.success) {
            var data = json.data, injectTime = data.injectTime;
            data.injectTimeStr = DateUtil.formatWithPatternDate('yyyy年mm月dd日', injectTime ? new Date(injectTime) : new Date());
            Views.babyVanccinationDetailView.data = data;
            Callback.pageSwitchTabView(btnId);
        }
    };
    DataExchange.getImmunizationTimeDetail(options).done(ajaxDoneHandle);
};
//儿童保健  >计免时间 > 疫苗详情
Views.babyVanccinationDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVanccinationDetailView',
        name: '儿童保健  >计免时间 > 疫苗详情'
    },
    show: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    vanccinationTimeInit: function () {
        var time = $('#vanccinationTime').attr("data-rel");
        Util.mobiscrollDate("#vanccinationTime", {
            dateFormat: 'yyyy年mm月dd日',
            defaultValue: new Date(Number(time)),
            onSelect: function (value, inst) {
                $('#vanccinationTime').text(value);
            }
        });
    },
    willShow: function (ct) {
        this.render(ct, { vanccination: this.data });
        this.vanccinationTimeInit();
        this.viewScrollerInit($('#babyVanccinationContent'));
    },
    willHide: function () {
        $('#vanccinationTime').mobiscroll('destroy');
    }
});
Callback.vanccinationDescExpand = function (btnId) {
    var id = "#" + btnId, $ele = $(id), viewScroller;
    if ($ele.hasClass("collapse")) {
        $ele.removeClass("collapse").addClass("expand").append('<div><a class="ui-btn" data-action="vanccinationDescCollapse">收拢</a></div>');
    }
    viewScroller = Views.babyVanccinationDetailView._viewScroller;
    viewScroller.refresh();
    viewScroller.scrollToElement(id);
};
Callback.vanccinationDescCollapse = function (btnId) {
    $("#" + btnId).parents(".expand").addClass("collapse").removeClass("expand").end().remove();
};
Callback.vanccinationStatusToggle = function (btnId) {
    var $ele = $("#" + btnId), finishTime = null, flag = $ele.hasClass("finish"), options;
    if (flag) {
        return;
    } else {
        var temp = $('#vanccinationTime').text().split(/\D/g);
        temp.pop();
        finishTime = temp.join('-');
        flag = true;
    }
    options = {
        data: {
            "memberId": LocalMode('baby').get().memberId,
            "vaccineId": $ele.attr("data-rel-id"),
            "injectTime": finishTime
        }
    };
    DataExchange.upVaccineTime(options).done(ajaxDoneHandle);
    function ajaxDoneHandle(json) {
        if (json.success) {
            if (flag) {
                $ele.addClass("finish").removeClass("unfinish").find("span").html("已接种");
            } else {
                $ele.removeClass("finish").addClass("unfinish").find("span").html("未接种");
            }
            Widget.popupSuccess("修改成功");
        }
    }
};

//儿童保健  >幼儿健康
Views.healthBabyView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'healthBabyView',
        name: '儿童保健-幼儿健康'
    },
    willShow: function (ct) {
        this.pageNum = 1;
        var baby = LocalMode('baby').get();
        if (!$.isEmptyObject(baby)) {
            this.render(ct, {baby: baby, iconURL: MEMBER_ICON_URL, t: Util.rtime()});
        } else {
            this.render(ct, {baby: {sex: 'MALE'}, iconURL: null});
        }
        this.editBabyBody();
        StageManager.fixPageBack(Views.mainView);
    },
    didShow: function () {
        this.refresh = Util.makeScrollableWithPullRefresh($('#healthBaby'), {
            onPullDownRefresh: this.onPullDownRefresh,
            onPullUpRefresh: this.onPullUpRefresh
        });
    },
    didHide: function () {
        this.refresh.destroy();
    },
    pageNum: 1,

    isRefreshing: false,

    onPageRefresh: function () {
        var baby = LocalMode('baby').get(), sex, now, options;
        if ($.isEmptyObject(baby)) {
            return;
        }

        sex = baby.sex === "MALE" ? "boy" : "girl";
        now = new Date();
        options = {
            startTime: DateUtil.formatYY_MM_DD(new Date(new Date().setFullYear(now.getFullYear() - 1))),
            endTime: DateUtil.formatYY_MM_DD(now),
            pageNum: this.pageNum,
            pageSize: 3
        };
        //判断用户身体数值的颜色
        function _betweenNum(between, min, max) {
            var temp = null;
            if (!between) {
                temp = 'gear';
            }
            if (between >= min && between <= max) {
                temp = 'common';
            }
            if (between < min) {
                temp = 'light';
            }
            if (between > max) {
                temp = 'heavy';
            }
            return temp;
        };
        function ajaxFailHandle() {
            $('#healthBabyContent').html("");
        };
        function ajaxDoneHandle(json) {
            if (json.success) {
                var data = json.data, //data0 is the lastest data, if data is [] ,for the percentage set {}
                    data0 = data[0] || {}, month = baby.monthAge - 0, deployMonth = BabyDeploy.stageXMonth, len = deployMonth.length, j = 0, percentage, fixMinJ, recordTime, babyDeploy;
                // 判断用户年龄区间
                for (j; j < len - 1; j++) {
                    if (month >= deployMonth[j] && month <= deployMonth[j + 1]) {
                        break;
                    }
                }
                if (j === len - 1) {
                    Widget.popupToast("您的孩子超过两周岁了");
                }
                recordTime = data0.recordTime;
                babyDeploy = BabyDeploy[sex];
                // 用于页面显示的数据
                percentage = {
                    maxHeight: babyDeploy.maxHeight[j],
                    userHeight: data0.height || 0,
                    minHeight: babyDeploy.minHeight[j],
                    minWeight: babyDeploy.minWeight[j],
                    userWeight: data0.weight || 0,
                    maxWeight: babyDeploy.maxWeight[j],
                    chestCommon: babyDeploy.chest[j],
                    userChest: data0.chestCircum || 0,
                    headerCommon: babyDeploy.header[j],
                    userHeader: data0.headCircum || 0,
                    recordTime: DateUtil.formatWithPatternDate('yyyy/mm/dd', recordTime ? new Date(recordTime) : new Date())
                };
                fixMinJ = ((j - 1) <= -1) ? 0 : j - 1;
                $.extend(percentage, {
                    chestPre: _betweenNum(percentage.userChest, babyDeploy.chest[fixMinJ], percentage.chestCommon),
                    headPre: _betweenNum(percentage.userHeader, babyDeploy.header[fixMinJ], percentage.headerCommon),
                    heightPre: _betweenNum(percentage.userHeight, percentage.minHeight, percentage.maxHeight),
                    weightPre: _betweenNum(percentage.userWeight, percentage.minWeight, percentage.maxWeight)
                });
                $('#healthBabyContent').html(Views.tmpl.healthBabySubView({
                    percentage: percentage || {},
                    data: data || {}
                }));
                //渲染列表
                Views.healthBabyView.onListRefresh(data);
            }
        };
        DataExchange.getVitalSignRecords(options).done(ajaxDoneHandle).fail(ajaxFailHandle).always(function () {
            Views.healthBabyView.isRefreshing = false;
        });
    },

    onListRefresh: function (data) {
        for (var i = 0; i < data.length; i++) {
            data[i].recordTime = DateUtil.formatYY_MM_DD(new Date(data[i].recordTime));
        }
        $('#addFlag').before(Views.tmpl.healthBabySubListView({
            data: data
        }));
    },
    editBabyBody: function () {
        $('#healthBaby').motionTrack('start', {
            type: 'h',
            selector: '.table',
            delegate: {
                onTrackStart: function (target, pt) {
                    if (this.lastTarget && this.lastTarget !== target) {
                        $(this.lastTarget).children().first().css({'margin-left': '0'}).next().hide();
                        this.lastTarget.lastTrackDx = 0;
                    }
                    target.style.webkitTransitionDuration = 0;
                    target.lastTrackPt = pt;
                    if (typeof target.lastTrackDx === 'undefined') target.lastTrackDx = 0;
                    this.lastTarget = target;
                },
                onTrackMove: function (target, pt) {
                    var dx = target.lastTrackDx + (pt.x - target.lastTrackPt.x);
                    if (dx < -30) {
                        $(target).children().first().css({'margin-left': '-122px'}).next().show();
                        return;
                    } else if (dx > 30) {
                        $(target).children().first().css({'margin-left': '0'}).next().hide();
                        return;
                    }
                    target.lastTrackPt = pt;
                    target.lastTrackDx = dx;
                },
                onTrackEnd: function (target) {
                    target.lastTrackDx = 0;
                }
            }
        });

    },
    onPullDownRefresh: function () {
        if (Views.healthBabyView.isRefreshing) {
            return;
        }
        Views.healthBabyView.isRefreshing = true;
        Views.healthBabyView.pageNum = 1;
        Views.healthBabyView.onPageRefresh();
    },

    onPullUpRefresh: function () {
        if (Views.healthBabyView.isRefreshing) {
            return;
        }
        Views.healthBabyView.isRefreshing = true;
        var now = new Date(), options, num = Views.healthBabyView.pageNum + 1;
        options = {
            startTime: DateUtil.formatYY_MM_DD(new Date(new Date().setFullYear(now.getFullYear() - 1))),
            endTime: DateUtil.formatYY_MM_DD(now),
            pageNum: num,
            pageSize: 3
        }
        function ajaxDoneHandle(json) {
            if (json.success) {
                if (json.data.length) {
                    Views.healthBabyView.pageNum++;
                    Views.healthBabyView.onListRefresh(json.data);
                }
            }
        };
        function ajaxAlwaysHandle() {
            Views.healthBabyView.isRefreshing = false;
        };
        DataExchange.getVitalSignRecords(options).done(ajaxDoneHandle).always(ajaxAlwaysHandle);
    }
});

Callback.addBabyBody = function (btnId) {
    Util.data('tempBabyData', {
        type: 'add',
        title: '添加',
        id: $('#user').attr('data-rel'),
        time: DateUtil.formatYY_MM_DD(new Date())
    });
//    Views.babyHealthCareView.switchTabView(6);
    StageManager.pushView(Views.addBabyBodyView);
};
Callback.upBabyData = function (btnId) {
    var _btn = $('#' + btnId), _parent = _btn.parent(), _del = _parent.attr('data-rel'), _other = _parent.siblings(), tempBabyData = {
        id: _del,
        type: 'update',
        title: '修改',
        time: _btn.attr("data-rel")
    }, tempArray = ['weight', 'height', 'header', 'chest'];
    _other.children().each(function (index, e) {
        var text = parseFloat($(e).find('.data').text());
        tempBabyData[tempArray[index]] = (text === 0 ? "" : text);
    });
    Util.data('tempBabyData', tempBabyData);
//    Views.babyHealthCareView.switchTabView(6);
    StageManager.pushView(Views.addBabyBodyView);
};
Callback.delBabyData = function (btnId) {
    var _btn = $('#' + btnId), _del = _btn.parent().attr('data-rel');
    DataExchange.delVitalSignRecords({id: _del}).done(function (json) {
        Views.healthBabyView.pageNum = 1;
        Views.healthBabyView.onPageRefresh();
    });
};
//儿童保健  >幼儿健康 >添加
Views.addBabyBodyView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'addBabyBodyView',
        name: '儿童保健-幼儿健康-添加'
    },
    willShow: function (ct) {
        var data = Util.dataClear('tempBabyData');
        this.render(ct, { data: data });
        if (data.type == "add") {
            Util.babyDateSelectInit('#lastDate');
        }
    },
    willHide: function () {
        $('#lastDate').mobiscroll('destroy');
    }
});
Callback.babyDataCommit = function (btnId) {
    var _btn = $('#' + btnId), _parent = _btn.parent(), _type = _parent.attr('data-type'), _rel = _parent.attr('data-rel'), _other = _btn.siblings(), tempArray = ['weight', 'height', 'headCircum', 'chestCircum'], tempBabyData = {}, options = {
        id: _rel,
        tempBabyData: tempBabyData
    }, hasValue = false, i = 0, lastDate = $('#lastDate').text(), len = _other.length - 1, baby = LocalMode('baby').get();
    //_other.length - 1 是因为会取到日期的值，所以减去1

    for (i; i < len; i++) {
        var text = $(_other[i]).find('input').val();
        if (text) {
            hasValue = true;
            if (i === 0 && !Validator.weight(text)) {
                return;
            } else if (i === 1 && !Validator.height(text)) {
                return;
            } else if (i ===2 && !Validator.headCircum(text)) {
                return;
            } else if (i ===3 && !Validator.chestCircum(text)) {
                return;
            }
        }
        tempBabyData[ tempArray[i] ] = parseFloat(text || 0).toFixed(1);
    }
    if (!Validator.birthday(baby.birthday, lastDate)) {
        return;
    }
    if (!hasValue) {
        Widget.popupFailure('请至少输入一项！');
        return;
    }
    function ajaxDoneHandle(json) {
        if (json.success) {
//				        Views.babyHealthCareView.switchTabView(0);
            StageManager.popView();
        }
    };
    if (_type === "add") {
        tempBabyData.recordTime = lastDate;
        tempBabyData.dataFrom = ( mobile_system === "ios" ? "IPHONE" : "ANDROID_PHONE");
        DataExchange.addVitalSignRecords(options).done(ajaxDoneHandle);
    } else if (_type === "update") {
        DataExchange.updVitalSignRecords(options).done(ajaxDoneHandle);
    }
};
//-------------------儿童保健   >体检报告
Views.reportBabyView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'reportBabyView',
        name: '儿童保健   >体检报告 '
    },
    didShow: function (ct) {
        var pageBody = $('#pageBody');
        pageBody.html(Views.tmpl.reportBabySubView({data: {}, noMessage: true}));
        this.viewScrollerInit(pageBody);
    }
});
//-------------------儿童保健   >体检报告   >详细信息
Views.reportDetailBabyView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'reportDetailBabyView',
        name: '儿童保健   >体检报告>详细信息'
    },
    willShow: function (ct) {

    }
});
Callback.showBabyReportDetail = function (btnId) {
//    var _btn = $('#'+btnId);
//    var title = _btn.find('span').first().text();
//    LocalMode('maternal').update({reportDetailTitle:title});
//    Views.babyHealthCareView.switchTabView(6);
    StageManager.pushView(Views.addBabyBodyView);
};

//儿童保健  >疫苗接种
Views.babyVaccinationIndexView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVaccinationIndexView',
        name: '儿童保健  >疫苗接种'
    },
    willHide: function () {
        this.$super().didHide();
        if (this.pullRefresher) {
            this.pullRefresher.destroy();
            this.pullRefresher = null;
        }
    },
    willShow: function (ct) {
        function ajaxDoneHandle(json) {
            if (json.success) {
                var self = Views.babyVaccinationIndexView;
                self.vanccinations = json.data;
                self.render(ct, { vanccinations: json.data });
                self.bindEvents();
                self.viewScrollerInit($('#vaccinationsWrapper'), { bounce: false });
                this.pullRefresher = Util.makeScrollable($("#recommend-info"));
            }
        };
        DataExchange.getChildVanccinations({}).done(ajaxDoneHandle);
    },

    bindEvents: function () {
        $('#vaccinationInput').bind('input onpropertychange ',function () {
            function showVaccinationOptions(text) {
                var i = 0, li = $("#vaccinations").find('li'), l = li.length;
                for (; i < l; i++) {
                    var $li = li.eq(i);
                    if ($li.text().indexOf(text) !== -1) {
                        $li.show();
                    } else {
                        $li.hide();
                    }
                }
                $("#vaccinationsWrapper").show();
            }

            showVaccinationOptions(this.value);
        }).blur(function () {
                setTimeout(function () {
                    $("#vaccinationsWrapper").hide();
                }, 200);
            });
    }
});
Callback.vaccinationSelected = function (btnId) {
    var $ele = $("#" + btnId);
    $("#vaccinationInput").val($ele.text()).attr("data-pinyin", $ele.attr("data-pinyin"));
    $('#vaccinationsWrapper').hide();
};
Callback.vaccinationTabooSearch = function (btnId) {
    Views.babyVaccinationIntroTabooView.pinyin = $("#vaccinationInput").attr("data-pinyin");
    Callback.pageSwitchTabView(btnId);
}
//儿童保健  >疫苗接种 >疫苗分类
Views.babyVaccinationIntroCategoryView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVaccinationIntroCategoryView',
        name: '儿童保健  >疫苗接种 >疫苗分类'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.baby-vaccination-intro-content-wrapper'));
    }
});
//儿童保健  >疫苗接种 >注意事项
Views.babyVaccinationIntroWarnView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVaccinationIntroWarnView',
        name: '儿童保健  >疫苗接种 >注意事项'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.baby-vaccination-intro-content-wrapper'));
    }
});
//儿童保健  >疫苗接种 >不宜接种
Views.babyVaccinationIntroNodoView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVaccinationIntroNodoView',
        name: '儿童保健  >疫苗接种 >不宜接种'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.baby-vaccination-intro-content-wrapper'));
    }
});
//儿童保健  >疫苗接种 >呵护宝宝
Views.babyVaccinationIntroCareView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVaccinationIntroCareView',
        name: '儿童保健  >疫苗接种 >呵护宝宝'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.baby-vaccination-intro-content-wrapper'));
    }
});
//儿童保健  >疫苗接种 >常见问题
Views.babyVaccinationIntroQuestionView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVaccinationIntroQuestionView',
        name: '儿童保健  >疫苗接种 >常见问题'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.baby-vaccination-intro-content-wrapper'));
    }
});
//儿童保健  >疫苗接种 >反应
Views.babyVaccinationIntroReactionView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVaccinationIntroReactionView',
        name: '儿童保健  >疫苗接种 >反应'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.baby-vaccination-intro-content-wrapper'));
    }
});
//儿童保健  >疫苗接种 >原理与禁忌
Views.babyVaccinationIntroTabooView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyVaccinationIntroTabooView',
        name: '儿童保健  >疫苗接种 >原理与禁忌'
    },
    willShow: function (ct) {
        this.render(ct, {
            vanccinations: Views.babyVaccinationIndexView.vanccinations
        });
//        this.viewScrollerInit($('.baby-vaccination-intro-content-wrapper'));
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.baby-vaccination-intro-content-wrapper'));
        if (this.pinyin) {
            //通过搜索进入
            var i = 0, itmes = $(".vaccination-intro-item"), l = itmes.length;
            for (; i < l; i++) {
                var $ele = itmes.eq(i), id = $ele.attr("id");
                if ($ele.attr("data-pinyin").indexOf(this.pinyin) !== -1) {
                    Callback.vaccinationIntroItemToggle(id);
                    this.pinyin = null;
                    return;
                }
            }
        }
    }
});
Callback.vaccinationIntroItemToggle = function (btnId) {
    var id = "#" + btnId, $ele = $(id), $arrow = $ele.find(".arrow"), expand = "expand", collapse = "collapse", viewScroller;
    $('.arrow.expand').removeClass(expand).addClass(collapse).parent().next().hide();
    if ($arrow.hasClass(expand)) {
        $arrow.removeClass(expand).addClass(collapse);
    } else {
        $arrow.removeClass(collapse).addClass(expand);
    }
    $ele.next().toggle();
    viewScroller = Views.babyVaccinationIntroTabooView._viewScroller;
    viewScroller.refresh();
    viewScroller.scrollToElement(id, 500);

};

//儿童保健  >幼儿健康 >趋势
Views.babyTrendView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyTrendView',
        name: '儿童保健-幼儿健康-趋势'
    },
    didShow: function (ct) {

        this.drawWeight();
        //控制竖直方向滚动
        this.viewScrollerInit($('#addChat'), {
            hScroll: false
        });

    },
    XScroll: null,
    willHide: function () {
        if (this.XScroll) {
            this.XScroll.destroy();
        }
    },
    drawBody: function (ops) {
        if (this.XScroll) {
            this.XScroll.destroy();
            this.XScroll = null;
        }
        var sex = LocalMode('baby').get().sex === "MALE" ? "boy" : "girl",
            draw,
            baby,
            options;
        //chart背景渲染,x,y分别为x,y轴显示的数据
        $('#content').html(Views.tmpl.TrendView({
            data: {
                unit: ops.unit,
                y: ops.y,
                yStage: 5,
                x: BabyDeploy.stageX
                //这里的x的集合要和儿童具体的身高体重对照
            }
        }));
        Views.babyTrendView.controlScroll();
        draw = Util.draw();
        draw.initCanvas('trendCanvas');
        this.lineInit(ops.bodyItem, sex, draw);
        /**
         * strokeStyle线条颜色,宽度lineWidth
         * */
        baby = LocalMode('baby').get();
        options = {
            memberId: baby.memberId,
            itemId: ops.bodyItemId
        };
        function ajaxDoneHandle(json) {
            if (json.success) {
                var data = json.data, len = data.length, userData = [], birthDay = baby.birthday, i = 0, tempX;

                function xMonth(month) {
                    return  month > 12 ? 12 + (month - 12) / 12 : month;
                };
                for (i; i < len; i++) {
                    userData[i] = {};
                    tempX = ((new Date(data[i].recordTime) - new Date(birthDay)) / 1000 / 60 / 60 / 24 / 30);
                    if (tempX <= 24) {
                        userData[i]['x'] = xMonth(tempX);
                        userData[i]['y'] = data[i].itemValue;
                    }
                }
                Views.babyTrendView.drawUserLine({
                    strokeStyle: '#82bb64',
                    lineWidth: 2
                }, userData, {   minY: 0,
                    maxY: ops.y.shift(),
                    minUnitX: 40,
                    canvasHeight: 390,
                    cicleR: 2
                }, draw);

            }
        };
        DataExchange.getVitalSignsItem(options).done(ajaxDoneHandle);

    },

    drawHeight: function () {
        var options = {
            y: [150, 125, 100, 75, 50, 25, 0],
            bodyItem: "height",
            bodyItemId: "E10011",
            unit: '身高/cm'
        };
        this.drawBody(options);
    },

    drawWeight: function () {
        var options = {
            y: [24, 20, 16, 12, 8, 4, 0],
            bodyItem: "weight",
            bodyItemId: "E10012",
            unit: '体重/kg'
        };
        this.drawBody(options);
    },
    controlScroll: function () {

        //控制水平方向滚动
        this.XScroll = Util.makeScrollable($('#babyBodyChart'), {
            vScroll: false,
            hScroll: true,
            hScrollbar: false,
            bounce: false
        });

    },
    drawHeader: function () {
        var options = {
            y: [60, 50, 40, 30, 20, 10, 0],
            bodyItem: "header",
            bodyItemId: "E10014",
            unit: '头围/cm'
        };
        this.drawBody(options);
    },
    drawChest: function () {
        var options = {
            y: [60, 50, 40, 30, 20, 10, 0],
            bodyItem: "chest",
            bodyItemId: "E10015",
            unit: '胸围/cm'
        };
        this.drawBody(options);
    },

    lineInit: function (_rel, sex, draw) {
        /**
         * dashLength为虚线的最小长度
         * minUnitX minUnitY是X,Y最小间隔
         * canvasHeight画布高度
         * Baby里放置要画的数据
         * */
        var data = BabyDeploy[sex], options = {
            dashLength: 6,
            minUnitX: 40,
            canvasHeight: 390,
            diffY: 0
        }, maxColor = '#e88663', minColor = '#78b4cc', limitColor = '#b2cca5';
        switch (_rel) {
            case "height":
                this.drawRelativeLine(draw, maxColor, $.extend(options, {diffY: 120}), data.maxHeight);
                this.drawRelativeLine(draw, minColor, $.extend(options, {diffY: 120}), data.minHeight);
                break;
            case "weight":
                this.drawRelativeLine(draw, maxColor, $.extend(options, {diffY: 24}), data.maxWeight);
                this.drawRelativeLine(draw, minColor, $.extend(options, {diffY: 24}), data.minWeight);
                break;
            case "header":
                this.drawRelativeLine(draw, limitColor, $.extend(options, {diffY: 60}), data.header);
                break;
            case "chest":
                this.drawRelativeLine(draw, limitColor, $.extend(options, {diffY: 60}), data.chest);
                break;
        }
    },

    drawRelativeLine: function (draw, strokeStyle, options, data) {
        draw.getCanvas().strokeStyle = strokeStyle;
        draw.drawDashed(data, options);
    },

    drawUserLine: function (canvasOptions, data, drawOptions, draw) {
        draw.setCanvas(canvasOptions);
        draw.drawTrend(data, drawOptions);
        draw.clear();
        draw = null;
    }
});
Callback.showBabyTrend = function (btnId) {
    Views.babyHealthCareView.switchTabView(7);
};
Callback.showBabyBodyTrend = function (btnId) {
    var _btn = $('#' + btnId), _rel = _btn.addClass('selected').attr('data-rel');
    _btn.siblings('.selected').removeClass('selected');
    Views.babyTrendView['draw' + _rel]();
};

//----儿童保健 >幼儿健康  >帮助
Views.babyTestHelpView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'babyTestHelpView',
        name: '儿童保健  >幼儿健康 >帮助'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('#helpContent'));
    }
});
Callback.showBabyTestHelpView = function (btnId) {
    Views.babyHealthCareView.switchTabView(16);
};