// undone function
Callback.undone = function (btnId) {
    Widget.popupFailure("正在建设中...");
    return;
};

// the  entry of userCenterView

Callback.bShowUserCenter = function (btnId) {
    var _page = null;
    if (!UserProfile.isUserLoggedIn()) {
        _page = 'loginView';
    } else {
        _page = 'userCenterView';
    }
    StageManager.pushView(Views[_page]);
};

Callback.backMainView = function (btnId) {
    var _btn = $('#' + btnId);
    Util.data('index.mainView', _btn.attr('data-rel'));
    StageManager.pushView(Views.mainView);
}
//---userCenterView
Views.userCenterView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'userCenterView',
        name: '用户中心'
    },
    willShow: function (ct) {
        this.render(ct, {
            data: UserProfile,
            imgUrl: WEB_URL + '/resident/image/member/',
            t: Util.rtime()
        });
        this.viewScrollerInit($('#dial'), {
            vScroll: false
        });
		Util.makeScrollable($('.user-center'));
    },
    onPageBack: function () {
        return false;
    }
});
Views.userCenterDeviceView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'userCenterDeviceView',
        name: '用户中心-设备管理'
    },
    didShow: function (ct) {
        this.refreshPage = Util.makeScrollableWithPullRefresh($('#userCenterDevice'), this);
    },
    didHide: function () {
        this.refreshPage.destroy();
    },
    onPullDownRefresh: function () {
        Views.userCenterDeviceView.load();
    },
    load: function () {
        function ajaxDoneHandle(json) {
            $("#devicesContent").html(Views.tmpl.userCenterDeviceSubView({ data: json.data }));
        };
        DataExchange.chronicDiseaseManage({
            familyId: UserProfile.getFamilyId()
        }).done(ajaxDoneHandle);
    }
});
Views.userCenterDeviceDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'userCenterDeviceDetailView',
        name: '用户中心-设备管理-设备详情'
    },
    show: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var memberRelation = this.data.memberRelation, i = 0, len = memberRelation.length, member;
        if (memberRelation) {
            for (; i < len; i++) {
                member = memberRelation[i].member;
                if (!member.name) {
                    memberRelation[i].member = UserProfile.getMember(member.id);
                }
            }
        }
        console.log(this.data);
        this.render(ct, this.data);
//    	this.viewScrollerInit($('.ui-scroll'));
    }
});
Callback.showDeviceDetail = function (btnId) {
    var options = {
        deviceId: $("#" + btnId).attr("data-rel")
    };

    function ajaxDoneHandle(json) {
        Views.userCenterDeviceDetailView.show(json.data);
    };
    DataExchange.getDeviceDetail(options).done(ajaxDoneHandle);
}

Callback.addDevice = function (btnId) {
    var sn = $("#deviceSn").val(), options;
    if (!$.trim(sn)) {
        Widget.popupToast('请填写序列号:-(');
        return;
    }
    options = {
        loginId: UserProfile.id,
        sn: sn
    };
    function ajaxDoneHandle(json) {
        if (json.success) {
            $('#deviceSn').val('');
            Views.userCenterDeviceView.load();
        }
    };
    DataExchange.bindDevice(options).done(ajaxDoneHandle);
};

//----addMedicalCardView
Views.addMedicalCardView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'addMedicalCardView',
        name: '添加就诊卡'
    },
    initArgs: function (memberId) {
        this.memberId = memberId;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var user = UserProfile.getMember(this.memberId),
            data = {
                cardholder: user,
                imgUrl: WEB_URL + '/resident/image/member/'
        };
        this.render(ct, { data: data });
        this.viewScrollerInit($('#addMedicalCard').find(".ui-scroll"));
    },
    timer: null,
    stime: 60,
    resetTime: function () {
        if (this.timer) {
            clearInterval(this.timer);
        }
        this.stime = 60;
    },
    willHide: function () {
        this.resetTime();

    }
});
Callback.showAddMedicalCardView = function (btnId) {
    var _btn = $('#' + btnId),
        memberId = _btn.attr('data-rel'),
        addMedicalCardView = Views.addMedicalCardView;
    addMedicalCardView.initArgs(memberId);
};

Callback.getAddMedCardCode = function (btnId) {
    var addMedicalCardView = Views.addMedicalCardView;
    addMedicalCardView.resetTime();
    var _btn = $('#' + btnId).removeClass('ui-btn'),
        user = UserProfile.getMember(addMedicalCardView.memberId),
        patientId = user.id,
        mobileNo = user.mobileNo,
        medicalCardNo = $('#medicalCardNo').val(),
        options;

    options = {
        mobileNo: mobileNo,
        data: {
            "patientId": patientId,
            "hospitalId": COMPANYID,
            "medicalCardNo":  medicalCardNo,
            "isFirst": false
        }
    };

    function ajaxFailHandle() {
        _btn.addClass('ui-btn');
    }

    DataExchange.getAddMedCardCode(options).done(Callback.authCodeDoneHandle).fail(ajaxFailHandle);
};
Callback.authCodeDoneHandle = function (json) {
    if (json.success) {
        Widget.popupSuccess("验证码已发送，请注意查收");
        authCode();
    } else {
        $('#getAuthCode').addClass('ui-btn');
    }
    function authCode() {
        StageManager.getCurrentView().timer = setInterval(function () {
            var page = StageManager.getCurrentView(),
                getAuthCode = $('#getAuthCode');
            if (page.stime <= 0) {
                getAuthCode.text("重新获取").addClass('ui-btn');
                clearInterval(page.timer);
                return;
            }
            getAuthCode.text(page.stime-- + '秒后请重试');
        }, 1000);
    };
};
Callback.addMedCard = function (btnId) {
    var authCode = $('#authCode').val(),
        user = UserProfile.getMember(Views.addMedicalCardView.memberId),
        patientId = user.id,
        mobileNo = user.mobileNo,
        medicalCardNo = $('#medicalCardNo').val(),
        options, validData;


    validData = {
        medCard2: [medicalCardNo],
        testMedicalCardNo: medicalCardNo,
        authCode: authCode
    };

    if (!Validator.validator(validData)) {
        return;
    }
    options = {
        "patientId": patientId,
        "hospitalId": COMPANYID,
        "name": user.name,
        "mobileNo": mobileNo,
        "verifyCode": authCode,
        "medicalCardNo": medicalCardNo,
        "isFirst": false
    };
    function ajaxDoneHandle(json) {
        if (json.success) {
            Widget.popupSuccess("添加成功...");
            StageManager.popView();
        }
    }

    DataExchange.addMedCard(options).done(ajaxDoneHandle);
};
//-----medCardDetailView
Views.medCardDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'medCardDetailView',
        name: '就诊卡详情'
    },
    willShow: function (ct) {
        var Xcardholder = Util.data('Xcardholder') || {},
            cardId = Util.data('medCardDet') || Xcardholder.cardId,
            memberId = Xcardholder.memberId,
            fix = {cardId: cardId};

        function ajaxDoneHandle(json) {
            var page = StageManager.getCurrentView(), data = {};
            if (json.success) {
                data = json.data;
                var id = data.patientId, user = UserProfile.getMemberById(id), hospitalId = data.hospitalId, user0 = {};
                if (memberId) {
                    user0 = UserProfile.getMember(memberId);
                }
                //data.medicalCardValid在此处会被改成false 备注bbl
                $.extend(data, user, user0, fix, { medicalCardValid: data.medicalCardValid });
                data.hospitalId = hospitalId;
            }
            page.render(ct, {data: data});
        }

        DataExchange.getMedCardDet({cardId: cardId}).done(ajaxDoneHandle).fail(function () {
            StageManager.popView();
        });
    }

});
Callback.showMedCardDetailView = function (btnId) {
    StageManager.pushView(Views.medCardDetailView);
};
Callback.upMedCard = function (btnId) {
    var _btn = $('#' + btnId), options = {
        "id": _btn.attr('data-cardId'),
        "patientId": _btn.attr('data-patientId'),
        "hospitalId": _btn.attr('data-hospitalId'),
        "name": _btn.attr('data-name'),
        "medicalCardTypeId": _btn.attr('data-medicalCardTypeId'),
        "medicalCardNo": _btn.attr('data-medicalCardNo'),
        "medicalCardValid": _btn.attr('data-medicalCardValid')
    };
    if (!Validator.medicalCardValid(options.medicalCardValid)) {
        return;
    }
    DataExchange.upMedCard(options).done(function (json) {
        if (json.success) {
            Widget.popupSuccess("修改成功");
        }
        StageManager.popView();
    });
};
//----addMemberView
Views.addMemberView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'addMemberView',
        name: '添加用户'
    },
    willShow: function (ct) {
        var title = Util.data('addMember'),
            data = {
                patient: {}
            };
        if (title === 'maternal') {
            $.extend(data, {
                title: "添加孕妇信息",
                row: title,
                role: "GRAVIDE",
                roleValue: "孕妇"
            });
        } else if (title.indexOf("update") !== -1) {
            //update 这里参数需要知道成员id所以判断字符串里是否有update
            var arr = title.split('-');
            $.extend(data, {
                title: "修改家庭成员",
                row: arr[0],
                patient: UserProfile.getMember(arr[1])
            });
            this.memberId = arr[1];
        } else if (title === 'baby') {
            $.extend(data, {
                title: "添加婴儿成员",
                row: title,
                role: "CHILD",
                roleValue: "儿童"
            });
        } else {
            $.extend(data, {
                title: "添加家庭成员"
            });
        }
        this.render(ct, {
            data: data,
            imgUrl: WEB_URL + '/resident/image/member/',
            time: Util.rtime()
        });
        this.viewScrollerInit($('#scroll'), {
            onScrollEnd: function () {
                var page = StageManager.getCurrentView(),
                    scroller = page._viewScroller;
                scroller.refresh();
            }
        });
        this.selectInit();
        $('.fixScrollerBug').click(function (e) {
           setTimeout(function () {
               var page = StageManager.getCurrentView(),
                   scroller = page._viewScroller;
               scroller.scrollToElement(e.srcElement, 100);
           }, 0);
        });
    },
    selectInit: function () {
        var now = new Date(), year = now.getFullYear(), birth = $.trim($("#birth").text());
        Util.mobiscrollDate('#basicUsageShow', {
            defaultValue: birth ? new Date(birth) : new Date(),
            startYear: year - 90,
            endYear: year,
            onSelect: function (value, inst) {
                if (!Validator.now(new Date(value))) {
                    return;
                }
                $('#birth').text(value);
            }
        });
        Util.mobiscrollSelect('#roleScroll', {
            onSelect: function (value, inst) {
                var roleId = inst.temp[0];
                if (roleId === "GRAVIDE") {
                    $("#sex").addClass("female-add").removeClass("male-add");
                }
                $('#role').val(value).attr('data-rel', roleId);
            }
        });
    },
    willHide: function () {
        $('#basicUsageShow').mobiscroll('destroy');
        $('#roleScroll').mobiscroll('destroy');
        $('.fixScrollerBug').unbind();
    }
});

Callback.roleToggle = function (btnId) {

    var changeFlag = $("#roleWrapper").attr('data-rel');
    if (changeFlag === "true") {
        return false;
    }
    var $ele = $("#roleWrapper .icon-arrow-right");
    if (!$ele.length) {
        $ele = $("#roleWrapper .right-icon");
    }
    if ($ele.hasClass("collapse")) {
        $ele.removeClass("collapse").addClass("expand");
    } else {
        $ele.removeClass("expand").addClass("collapse");
    }
    $('#roleScroll').mobiscroll('show');
    return false;
}

Callback.getPic = function (btnId) {
    var _btn = $('#' + btnId);
    function resetBar () {
            StatusBar.styleBlackOpaque();
    }

    function onSuccess(imageURI) {
        _btn.find('img')[0].src = imageURI;
        resetBar();
    };
    function onFail(message) {
        resetBar();
    };
    navigator.camera.getPicture(onSuccess, onFail, {
        quality: 35,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
    });
};
Callback.refreshWebView = function (status) {
    if (mobile_system === 'ios' && parseInt(device.version, 10) < 7 ) {
        if (status === "start") {
            StatusBar.hide();
        } else if (status === "end") {
            cordova.exec(function () {
                StatusBar.show();
                Layout.adjustWindowSize(wndw.width(), wndw.height() - 20);
            }, function () {
                Widget.popupToast("程序发生错误");
            }, 'LandScape', 'protrait', []);
        }
    }
};

Callback.fireMobiScroll = function (btnId) {
    $('#' + $('#' + btnId).attr('data-rel')).mobiscroll('show');
};

Callback.showUpdateMemberView = function (btnId) {
    Util.data('addMember', 'update-' + $('#' + btnId).attr('memberid'));
    StageManager.pushView(Views.addMemberView);
};

Callback.showAddMemberView = function (btnId) {
    Util.data('addMember', '');
    StageManager.pushView(Views.addMemberView);
};
Callback.changeSex = function (btnId) {
    var sex = $('#' + btnId).find('.sex-toggle');
    if ($("#role").attr("data-rel") === "GRAVIDE") {
        if (!sex.hasClass("female-add")){
            sex.addClass("female-add").removeClass("male-add");
        }
        return Widget.popupToast("您选择的角色是孕妇");
    }
    if (sex.hasClass("female-add")) {
        sex.addClass("male-add").removeClass("female-add");
    } else {
        sex.addClass("female-add").removeClass("male-add");
    }

};
Callback.delMember = function (btnId) {
    var _btn = $('#' + btnId), patientId = _btn.attr('data-id');
    Util.confirm("确定要删除吗？删除该用户同时会删除其绑定的就诊卡", function (idx) {
        if (idx === 2) {
            DataExchange.delMember({patientId: patientId}).done(function (json) {
                if (json.success) {
                    Widget.popupSuccess("删除成功");
                    UserProfile.delMemberById(patientId);
                    StageManager.delView(1);
                    setTimeout(function () {
                        StageManager.popView();
                    }, 20);

                }
            });
        }
    }, "温馨提示");
};
Callback.saveMemberInfo = function (btnId) {
    function getSex () {
        var $sex = $('#sex');
        if ($sex.hasClass("female-add")) {
            return "女";
        } else if (($sex.hasClass("male-add"))) {
            return "男";
        }
    }
    var phoneNo = $.trim($('#phoneNo').val()),
        username = $.trim($('#username').val()),
        birthDay = $.trim($('#birth').text()),
        sex = getSex(),
        idCard = $.trim($('#idCard').val()),
        address = $.trim($('#address').val()),
        role = $("#role").attr("data-rel"),
        _btn = $('#' + btnId),
        _id = _btn.attr('data-id'),
         _back = Util.data('addMember'),
        _birth = birthDay.replace(/-/g, ""),
        page = StageManager.getCurrentView(),
        options, validData;
    validData = {
        testMobileNo: phoneNo,
        testBirth: _birth,
        testSex: sex,
        testIdCard: idCard,
        testBaby: birthDay,
        checkIdCard: true
    };
    if (_back !== 'baby') {
        delete validData.testBaby;
    }

    if (!Validator.validator(validData)) {
        return;
    }
    options = {
        "accountId": UserProfile.id,
        "memberId": Views.addMemberView.memberId,
        "mobileNo": phoneNo,
        "idCard": idCard,
        "name": username,
        "birthday": birthDay,
        "sex": sex === "男" ? "MALE" : "FEMALE",
        "address": address,
        "isFamilyMember": true,
        "hospitalId": COMPANYID,
        "role": role
    };

    function uploadImg(json) {
        if (json.success) {
            // var uri = $('#userImg').attr('src'),
            //     memberId = json.data.memberId || UserProfile.getMemberById(_id).memberId;
            // if (uri.indexOf(WEB_URL) === -1 && uri.indexOf('themes/images/') === -1) {
            //     Widget.popupLoading("上传头像中...");
            //     FSManager.upload({
            //         file: uri,
            //         url: WEB_URL + "/resident/image/member/image/" + memberId,
            //         onSuccess: 'upUserImg',
            //         onError: 'upUserImg'
            //     });
            // } else {
            //     Callback.addMemberEnd();
            // }
            Callback.addMemberEnd();
        }
    }

    if (_back.indexOf("update") === -1) {
        //添加用户
        delete  options.memberId;
        DataExchange.addMember(options).done(function (json) {
            if (json.success) {
                Views.addMemberView.memberId = 0;
                UserProfile.patients.unshift(json.data);
                if (UserProfile.patients.length === 1) {
                    Util.data('current.member', UserProfile.patients[0]);
                }
                if (_back === "maternal") {
                    UserProfile.addLocalMode("maternal", json.data);
                    page.callback = "showMaternalHealthCareView";
                } else if (_back === 'baby') {
                    UserProfile.addLocalMode("baby", json.data);
                    page.callback = "showBabyHealthCareView";
                } else {
                    page.callback = "showMedCardManageView";
                }
                Util.data('addMember', "");
            }
        }).done(uploadImg);
    } else {
        //更新用户
        if (!_id) {
            Widget.popupFailure("未知错误", function () {
                StageManager.popView();
                return false;
            });
        }
        $.extend(options, {id: _id});
        DataExchange.updateMember(options).done(function (json) {
            if (json.success) {
                UserProfile.patients = json.data;
                //when update user info ,should update local data
                UserProfile.updateLocalMode(options);
                page.callback = "pageBack";
            }
        }).done(uploadImg);
    }
};
Callback.upUserImg = function (json) {
    Widget.popupLoadingClose();
    var response;
    if ( JSON ) {
        response = JSON.parse(json.response);
    } else {
        eval("response = " + json.response);
    }

    if (response.success) {
        Widget.popupSuccess("图片上传成功");
    } else {
        Widget.popupSuccess("图片上传失败");
    }

    Callback.addMemberEnd();

};
Callback.addMemberEnd = function(){
    var page = StageManager.getCurrentView(),
        callback = page.callback;
    delete page.callback;
    Callback[ callback ]();
};

//---medCardManageView



Callback.delMedCard = function (btnId) {
    var _btn = $('#' + btnId), _rel = _btn.attr('data-rel');
    DataExchange.delMedCard({query: _rel}).done(function (json) {
        if (json.success) {
            Callback.pageBack();
            Widget.popupSuccess("删除成功");
        }
    });
};

Callback.getMedCardDet = function (btnId) {
    var _rel = $('#' + btnId).attr('data-rel');
    Util.data('medCardDet', _rel);
    StageManager.pushView(Views.medCardDetailView);
};
//----accountSafeView
Views.accountSafeView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'accountSafeView',
        name: '账号安全'
    },
    willShow: function (ct) {
        var self = this;
        DataExchange.getSafePwd().done(function (json) {
            var flag = false;
            if (json.success) {
                flag = !$.isEmptyObject(json.data);
            }
            if (flag) {
                Util.data('setPwd', {code: UserProfile.code});
            } else {
                Util.data('setPwd', "");
            }
            self.render(ct, {
                data: UserProfile,
                setPwd: flag
            });
        }).fail(function () {
            self.render(ct, {
                data: UserProfile,
                setPwd: !!Util.data('setPwd')
            });
        });

    }
});
//---------------answerSecretQuestionView
Views.answerSecretQuestionView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'answerSecretQuestionView',
        name: '回答密保问题'
    }
});
//--------------------modifyPwdView
Views.modifyPwdView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'modifyPwdView',
        name: '修改账号密码'
    },
    willShow: function (ct) {
        this.render(ct, {data: UserProfile});
    }
});
Callback.modifyPwd = function (btnId) {
    var username = $('#username').val(), oldPwd = $('#oldPwd').val(), newPwd = $('#newPwd').val(), newPwds = $('#newPwds').val(), options, validData;
    if (!username) {
        Widget.popupFailure("未知原因...账号不存在,即将返回", function () {
            StageManager.popView();
        });
        return false;
    }
    validData = {
        oldPwd: oldPwd,
        newPwd: newPwd,
        newPwds: newPwds
    };
    if (!Validator.validTwoPwd(validData)) {
        return;
    }
    options = {
        "accountId": UserProfile.id,
        "mobileNo": UserProfile.mobile,
        "oldPassword": oldPwd,
        "newPassword": newPwd,
        "confirmPassword": newPwds
    };
    DataExchange.resetAccountPwd(options).done(function (json) {
        if (json.success) {
            Widget.popupSuccess("修改成功");
            StageManager.popView();
        }
    });
};
//-------------------resetAccountView
Views.resetAccountView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'resetAccountView',
        name: '重置手机账号'
    },
    willShow: function (ct) {
        this.render(ct, {data: {oldPhone: UserProfile.mobile}});
        this.viewScrollerInit($('#resetAccount'));
    },
    timer: null,
    willHide: function () {
        this.resetTime();
    },
    stime: 60,
    resetTime: function () {
        if (this.timer) {
            clearInterval(this.timer);
        }
        this.stime = 60;
    }
});

Callback.getAccountCode = function (btnId) {
    Views.resetAccountView.resetTime();
    var _phone = $('#newPhone').val(), _btn = $('#' + btnId);
    if (!Validator.testMobileNo(_phone)) {
        return;
    } else {
        _btn.removeClass('ui-btn');
        DataExchange.getResetCode({mobileNo: _phone}).done(Callback.authCodeDoneHandle).fail(function () {
            _btn.addClass('ui-btn');
        });
    }
};
Callback.resetAccount = function (btnId) {
    var oldPwd = $('#oldPwd').val(), newPwd = $('#newPwd').val(), newPwds = $('#newPwds').val(), newPhone = $('#newPhone').val(), authCode = $('#authCode').val(), validData, options;
    validData = {
        oldPwd: oldPwd,
        newPwd: newPwd,
        newPwds: newPwds
    };
    if (!Validator.validTwoPwd(validData)) {
        return;
    }
    validData = {
        testMobileNo: newPhone,
        authCode: authCode
    };
    if (!Validator.validator(validData)) {
        return;
    }
    options = {
        "loginUserId": UserProfile.id,
        "oldMobileNo": UserProfile.mobile,
        "oldPwd": oldPwd,
        "mobileNo": newPhone,
        "password": newPwd,
        "verifyCode": authCode
    };
    DataExchange.resetUserAccount(options).done(function (json) {
        if (json.success) {
            Views.loginView.loginAjax(newPhone, newPwd);
        }
    });
};
//--------------------setSecretQuestionView
Views.setSecretQuestionView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'setSecretQuestionView',
        name: '设置安全问题'
    },
    willShow: function (ct) {
        var options = {accountId: UserProfile.id}, self = this;
        if (this.statusPwd) {
            DataExchange.getSafePwd().done(function (json) {
                if (json.success) {
                    self.render(ct, {
                        data: json.data,
                        isClose: true
                    });
                }
            });
        } else {
            DataExchange.sendSafeQuestions(options).done(function (json) {
                if (json.success) {
                    self.render(ct, {data: json.data.questionList});
                    function questionSelectInit() {
                        Views.setSecretQuestionView.questionSelect = Util.mobiscrollSelect('#questions', {
                            onSelect: function (value, inst) {
                                var temp = inst.temp[0];
                                $('#q1').attr('data-id', temp).text(value);
                            }
                        });
                        $('#questions_dummy').hide();
                    }
                    questionSelectInit();
                } else {
                    StageManager.popView();
                }
            });
        }

    },
    didHide: function () {
        if (this.questionSelect) {
            this.questionSelect.mobiscroll('destroy');
        }
    }
});
Callback.closeSafeQ = function (btnId) {
    var $closeAnswer = $('#closeAnswer'),
        anewer = $closeAnswer.val(),
        questionId = $closeAnswer.attr('data-rel');
    DataExchange.validSafeQ({
        "accountId": UserProfile.id,
        "questionId": questionId,
        "answer": anewer
    }).done(function (json) {
        if (json.success) {
            Widget.popupSuccess("您已经关闭安全问题啦", function () {
                StageManager.popView();
            });
        }
    });
};
Callback.saveSecretQ = function (btnId) {
    var $temp = $('#q1'),
        options = {
        accountId: UserProfile.id
        }, submit;

    function isSubmit($ele) {
        var id = $ele.attr('data-id'), answer = $ele.next().find('input').val();
        if (answer && id) {
            return {
                questionId: id,
                answer: answer
            };
        }
    };
    submit = isSubmit($temp);
    if (!submit) {
        Widget.popupFailure("请选择回答一个问题...");
        return false;
    }
    DataExchange.saveAnswers($.extend(submit, options)).done(function (json) {
        if (json.success) {
            Util.data('setPwd', {code: UserProfile.code});
        }
        StageManager.popView();
    });
};
Callback.showQuestion = function (btnId) {
    $('#questions').mobiscroll('show');
};

Callback.setSecretQuestion = function (btnId) {
    var setSecretQ = $('#setSecretQ'), _rel = setSecretQ.attr('data-rel') === "yes";
    Views.setSecretQuestionView.statusPwd = _rel;
    StageManager.pushView(Views.setSecretQuestionView);
//    if (_rel === "yes") {
//        Widget.popupLoading("正在关闭安全问题");
//        setTimeout(function () {
//            Util.data('setPwd', '');
//            Widget.popupLoadingClose();
//            setSecretQ.removeClass('yes').attr('data-rel', 'no');
//        }, 500);
//    } else {
//        StageManager.pushView(Views.setSecretQuestionView);
//    }
};
//-----------------------------aboutUsView
Views.aboutUsView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'aboutUsView',
        name: '关于我们'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.about-us'));
    }
});

//----------------------disclaimerView
Views.disclaimerView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'disclaimerView',
        name: '免责声明'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('#discScroll'));
    }
});

//---------------------feedbackView
Views.feedbackView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'feedbackView',
        name: '意见反馈'
    },
    willShow: function (ct) {
        this.render(ct, {mobile: UserProfile.mobile});
    }
});
Callback.saveFeedback = function (btnId) {
    var content = $.trim($('#content').val()), name = $.trim($('#name').val()), phoneNum = $.trim($('#phoneNum').val()), email = $.trim($('#email').val()), options, validData;
    validData = {
        content: content,
        testEmail: email,
        relative: {
            phoneNum: phoneNum,
            name: name
        }
    };
    if (!Validator.validator(validData)) {
        return;
    }
    options = {
        "userId": UserProfile.id,
        "content": content,
        "email": email,
        "name": name,
        "phoneNum": phoneNum
    };
    function ajaxDoneHandle(json) {
        if (json.success) {
            Widget.popupSuccess("提交成功...");
            StageManager.popView();
        }
    };
    DataExchange.addFeedback(options).done(ajaxDoneHandle);
};
//---------------------faqView
Views.faqView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'faqView',
        name: '常见问题'
    },
    didShow: function (ct) {
        $('#faq').delegate('.option-item', 'click', function (e) {
            var tempFaq = {
                faqTitle: e.currentTarget.innerText,
                faqId: e.currentTarget.id
            };
            Util.data("tempFaq", tempFaq);
            StageManager.pushView(Views.faqDetailView);
        });
    }
});

//--------------------faqDetailView
Views.faqDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'faqDetailView',
        name: '常见问题解析'
    },
    willShow: function (ct) {
        var tempFaq = Util.dataClear("tempFaq"), data = { title: tempFaq.faqTitle };
        this.render(ct, {
            data: data,
            q: FAQ[ tempFaq.faqId ]
        });
        this.viewScrollerInit($('#scroll'));
    }
});

//-----------------settingView
Views.settingView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'settingView',
        name: '设置'
    },
    willShow: function (ct) {
        var options = {
            familyId: UserProfile.familyId
        };

        function ajaxDoneHandle(json) {
            var page = StageManager.getCurrentView();
            if (json.success) {
                page.render(ct, {
                    data: json.data,
					mobile_system: mobile_system,
					version: VERSION_NUMBER
                });
                page.viewScrollerInit($('#scroll'));
            }
        };
        DataExchange.getSetting(options).done(ajaxDoneHandle);
    },
    didHide: function () {
        this.viewScrollerDestroy();
    }
});
Callback.upPushSetting = function (btnId) {
    var _btn = $('#' + btnId), _rel = _btn.attr('data-rel'), _status = _btn.children().first(), options;
    options = {
        familyId: UserProfile.familyId
    };
    options[_rel] = _status.hasClass('yes') ? 'NO' : 'YES';
    function ajaxDoneHandle(json) {
        if (json.success) {
            Widget.popupSuccess("已经更新成功");
            _status.toggleClass('yes');
        }
    };
    DataExchange.upSetting(options).done(ajaxDoneHandle);
};
Callback.showSettingView = function (btnId) {
    StageManager.pushView(Views.settingView);
};
//----------------------collectView
Views.collectView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'collectView',
        name: '收藏'
    },
    row: 'news',
    pageNum: 1,
    catalog: null,
    catalogId: -1,
    dialogSwipe: null,
    didShow: function (ct) {
        this.scrollRefresh = Util.makeScrollableWithPullRefresh($('#collectScroller'), {
            onPullDownRefresh: this.onPullDownRefresh
        });
        this.onPullDownRefresh();
    },
    clearDialog: function () {
        $('#dialog').remove();
        if (this.dialogSwipe) {
            this.dialogSwipe.destroy();
            this.dialogSwipe = null;
        }
    },
    onPullDownRefresh: function () {
        if (Views.collectView.isRefreshing) {
            return;
        }
        var self = Views.collectView;
        self.pageNum = 1;
        //资讯模块
        self.clearDialog();
        if (self.row === 'consult') {
            //获取内容
            self.getContent();
        } else if (self.row === 'news') {
            $('.ui-tab-item.collect').eq(1).removeClass('selected').end().eq(0).addClass('selected');
            $('.header-right').show();
            //加载目录
            function ajaxDoneHandle(json) {
                var _tmpl;
                if (json.success) {
                    self.catalog = json.data;
                    _tmpl = Views.tmpl.collectMenuView({ data: json.data });
                    $('.ui-page').after(_tmpl);
                    //设为可滑动
                    self.dialogSwipe = Util.makeScrollable($('#dialogScroll'));
                    self.getContent();
                }
            };
            DataExchange.healthNewsCatalogs({
                familyId: UserProfile.familyId
            }).done(ajaxDoneHandle);
            //咨询模块
        }
    },

    getConsultContent: function () {
        $('#dialog').remove();
        var self = Views.collectView, options = self.ajaxOps;
        $('.ui-tab-item.collect').eq(0).removeClass('selected').end().eq(1).addClass('selected');
        $('.header-right').hide();

        DataExchange.healthConsult(options).done(self.ajaxDoneHandle).always(self.ajaxAlwaysHandle);
    },
    ajaxAlwaysHandle: function () {
        Views.collectView.isRefreshing = false;
    },
    ajaxDoneHandle: function (json) {
        var self = Views.collectView, options = self.ajaxOps;
        if (json.success) {
            if (json.data && json.data.length) {
                self.pageNum = self.pageNum + 1;
            }
            $.extend(json, options.data);
            $('#addFlag').before(Views.tmpl.collectSubView({
                data: json,
                round: Math.round,
                now: new Date().getTime(),
                imgUrl: WEB_URL + '/resident/healthNews/newsPic/get/'
            }));
            self.bindSwipe();
        }
    },
    isRefreshing: false,
    onPullUpRefresh: function () {
        Views.collectView.getContent();
    },
    getContent: function () {
        if (Views.collectView.isRefreshing) {
            return;
        }
        if (Views.collectView.pageNum === 1) {
            $('.collect-item').remove();
        }
        var self = Views.collectView, options;
        self.isRefreshing = true;
        options = {
            familyId: UserProfile.familyId,
            data: {
                "catalogId": Views.collectView.catalogId,
                "pageNum": Views.collectView.pageNum,
                "pageSize": 5
            }
        };
        self.ajaxOps = options;
        if (self.row === "news") {
            DataExchange.healthNewsItem(options).done(self.ajaxDoneHandle).always(self.ajaxAlwaysHandle);
        } else {
            options.data.familyId = options.familyId;
            delete  options.familyId;
            delete  options.data.catalogId;
            self.getConsultContent();
        }
    },
    didHide: function () {
        this.pageNum = 1;
        this.ajaxAlwaysHandle();
        this.catalog = null;
        if (this.scrollRefresh) {
            this.scrollRefresh.destroy();
            this.scrollRefresh = null;
        }
        this.clearDialog();
        $('#collectView').motionTrack('stop');
    },
    bindSwipe: function () {
        function onTrackStart(target, pt) {
            Views.collectView.isRefreshing = true;
            if (this.lastTarget && this.lastTarget !== target) {
                $(this.lastTarget).css({"margin-left": "0"});
                this.lastTarget.lastTrackDx = 0;
            }
            target.style.webkitTransitionDuration = 0;
            target.lastTrackPt = pt;
            if (typeof target.lastTrackDx === 'undefined') target.lastTrackDx = 0;
            this.lastTarget = target;
        };
        function onTrackMove(target, pt) {
            var dx = target.lastTrackDx + (pt.x - target.lastTrackPt.x);
            if (dx < -30) {
                $(target).css({
                    "margin-left": "-84px"
                });
                return;
            } else if (dx > 30) {
                $(target).css({
                    "margin-left": "0"
                });
                return;
            }
            target.lastTrackPt = pt;
            target.lastTrackDx = dx;
        };
        function onTrackEnd(target) {
            target.lastTrackDx = 0;
            Views.collectView.isRefreshing = false;
        };
        $('#collectView').motionTrack('start', {
            type: 'h',
            selector: '.collect-item',
            delegate: {
                onTrackStart: onTrackStart,
                onTrackMove: onTrackMove,
                onTrackEnd: onTrackEnd
            }
        });
    }
});
Callback.loadMoreCollect = function (btnId) {
    Views.collectView.onPullUpRefresh();
};
Callback.delCollect = function (btnId) {
    var _btn = $('#' + btnId), rel = _btn.attr('data-rel'), options;

    function ajaxDoneHandle(json) {
        if (json.success) {
            Widget.popupToast("取消收藏成功");
            Views.collectView.onPullDownRefresh();
        }
    };
    if (Views.collectView.row === "news") {
        options = {
            familyId: UserProfile.familyId,
            newsIdsStr: rel
        };
        DataExchange.delHealthNews(options).done(ajaxDoneHandle);
    } else {
        options = {
            accountId: UserProfile.id,
            id: rel
        };
        DataExchange.delHealthConsult(options).done(ajaxDoneHandle);
    }
};

Callback.showCollectMenu = function (btnId) {
    Util.makeDialog("dialog", true);
    var catalogId = Views.collectView.catalogId;
    $("li.f-16-e6").removeClass('f-16-e6');
    $('#dialog').find('li').each(function () {
        var $li = $(this);
        if ($li.attr('data-rel') === catalogId + "") {
            $li.addClass('f-16-e6');
        }
    });

};
Callback.chooseClass = function (btnId) {
    var $dialog = $('#dialog'), collectView = Views.collectView, font = 'f-16-e6';
    $dialog.find("li.f-16-e6").removeClass(font).end().hide().prev().css({'opacity': 1});
    collectView.catalogId = $('#' + btnId).addClass(font).attr('data-rel');
    collectView.onPullDownRefresh();
};
Callback.changeCollectRow = function (btnId) {
    if ($('#' + btnId).hasClass('selected')) {
        return;
    }
    var collectView = Views.collectView;
    collectView.row = $('.ui-tab-item.collect').not('.selected').attr('data-rel');
    collectView.onPullDownRefresh();
};
//---------versionCheckView
Views.versionCheckView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'versionCheckView',
        name: '版本检查'
    }
});
Callback.checkUpdate = function (btnId) {
    UserProfile.isCheck = false;
    Util.checkVersionUpdate();
};
Callback.downloadVersion = function (btnId) {
    var _btn = $('#' + btnId), url = _btn.attr('data-rel');
    window.open(url, '_system');
    if ($('#downNewVersion').attr('data-mustUpgrade') === 'YES') {
        if (APPVERSION !== 'wechat' && mobile_system === 'android') {
            if (Util.statisticEnabled) Util.statistic.onAppExit();
            navigator.app.exitApp();
        }

    }
};
Callback.cancelDownload = function (btnId) {
    var mustUp = $('#downNewVersion').attr('data-mustUpgrade') === 'YES';
    if (mustUp) {
        Util.confirm('APP有版本更新，本次是强制更新，如不更新，将不能使用该APP。是否要立即更新？', function (index) {
            if (index === 2) {
                window.open($('#downNewVersion').attr('data-rel'), '_system');
            } else {
                if (APPVERSION !== 'wechat' && mobile_system === 'android') {
                    if (Util.statisticEnabled) Util.statistic.onAppExit();
                    navigator.app.exitApp();
                }
            }
        }, '版本更新', '暂不更新,确定');
    }

};
Callback.logOff = function (btnId) {
    Util.confirm('您确定要退出吗？', function (index) {
        if (index === 2) {
            Callback.logOffSuccess(UserProfile.id);
        }
    });
};
Callback.logOffSuccess = function (userId) {

    UserProfile.setUserLogout();
    Util.data('index.mainView', '');
    StageManager.pushView(Views.mainView);
    function unBind (userId) {
        cordova.exec(function (result) {
            console.log("unbind success");
        }, function () {
            console.log("unbind fail");
        }, 'PushRegister', 'unbindChannel', [
            WEB_URL + '/resident/push/unBind', userId
        ]);
    };
    // unBind(userId);
};

function pushBindSuccess(){
    console.log("success");
};
//-----logOffView
Views.logOffView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'logOffView',
        name: '注销登陆'
    }
});
//----- userChooseView
Views.userChooseView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'userChooseView',
        name: '用户选择'
    },
    willShow: function (ct) {
        var ps = UserProfile.patients, backForUser = Util.data('backForUser');
        this.render(ct, {
            data: ps,
            time: Util.rtime(),
            imgUrl: WEB_URL + '/resident/image/member/',
            backForUser: backForUser
        });
        this.viewScrollerInit($('#iscroll'));
    }
});

Callback.showUserChooseView = function (btnId) {
    var _btn = $('#' + btnId),
        _rel = _btn.attr('data-rel'),
        deviveIdentify = _btn.attr('data-device-id'),
        deviveCardId = _btn.attr('data-device-card-id'),
        _index = _btn.attr('data-index'),
        memberId = _btn.attr('memberId'),
        cardId = _btn.attr('data-cardId'),
        medicalCardNo = $('#medicalCardNo').val(),
        name = $('#name').val(),
		sessionId = $('#i-session-id').val();
    Util.data('addMedCardNo', {medicalCardNo: medicalCardNo, name: name});
    Util.data('backForUser', {
		sessionId:sessionId,
        page: _rel,
        index: _index,
        cardId: cardId,
        memberId: memberId,
        deviveIdentify: deviveIdentify,
        deviveCardId: deviveCardId
    });
    StageManager.pushView(Views.userChooseView);
};

Callback.userChoose = function (btnId) {
    var _btn = $('#' + btnId), memberId = _btn.attr('data-memberId'), role = _btn.attr('data-role'), backForUser = Util.data('backForUser'), age = _btn.attr('data-age');
    if (backForUser.page === "maternal") {
        if (role == "GRAVIDE") {
            UserProfile.updateMaternal(memberId);
            StageManager.popView();
        } else {
            Widget.popupFailure("请选择孕妇");
            return false;
        }
    } else if (backForUser.page === "baby") {
        if (role !== "CHILD") {
            Widget.popupFailure("请选择婴儿");
            return false;
        } else {
            UserProfile.updateBaby(memberId);
            StageManager.popView();
        }
    } else if (backForUser.page === "userCenter") {
        Util.data('cardholder', {memberId: memberId});
        StageManager.popView();
    } else if (backForUser.page === "medCardDet") {
        Util.data('Xcardholder', {memberId: memberId, cardId: backForUser.cardId});
        StageManager.popView();
    } else if (backForUser.page === "quiz") {
        Views.consultQuizView.member = UserProfile.getMember(memberId);
        StageManager.popView();
    } else if (backForUser.page === "user.center.device") {
        var options = {};
        options.url = "/resident/chronicDiseaseManage/addDeviceDetail";
        options.data = {"deviceId": backForUser.deviveIdentify, "memberId": memberId};
        if (backForUser.deviveCardId) {//更新
            options.url = "/resident/chronicDiseaseManage/updateDeviceDetail";
            options.data = {"cardId": backForUser.deviveCardId, "memberId": memberId};
        }
        DataExchange.addDeviceDetail(options).done(function (json) {
            if (json.success) {
                Views.userCenterDeviceDetailView.data = json.data;
            }
            StageManager.popView();
        });
    } else {
        UserProfile.updateCurrentMember(memberId);
        StageManager.popView();
    }
};
Callback.userPageBack = function (btnId) {
    Util.data('backForUser', {});
    StageManager.popView();
};
//-------------onlineESQ
Views.onlineESQView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'onlineESQView',
        name: '在线客服'
    }
});
//------
Callback.showMedCardManageView = function (btnId) {
    var memberid;
    if (btnId) {
        memberid =  $('#' + btnId).attr('memberid');
    } else {
        memberid = UserProfile.patients[0].memberId;
    }
    Util.data('addMember', 'update-' + memberid);
    StageManager.pushView(Views.medCardManage2View);
};
Views.medCardManage2View = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "medCardManage2View",
        name: "就诊卡管理"
    },
    willShow: function (ct) {
        var memberid = Util.data('addMember').replace('update-', '') || Util.dataClear('cardholder').memberId,
            member = UserProfile.getMember(memberid);
        this.render(ct, {
            member: member,
            t: Util.rtime(),
            imgUrl:  WEB_URL + '/resident/image/member/'
        });
        this.willShow2(member);
        StageManager.fixPageBack(Views.userCenterView);
    },
    willShow2: function (member) {
        Util.data('medCardDet', '');
        Util.data('Xcardholder', '');
        DataExchange.getMedCardById({id: member.id}).done(function (json) {
            var page = StageManager.getCurrentView(),
                view = Views.tmpl.medCardManage2SubView;
            if (json.success) {
                $('#MedCardManageContent').html(view(json));
                page.viewScrollerInit($('#MedCardManageScroll'));
            }
        });
    }
});