Callback.showChronicView = function () {
    if (!Util.loginSuggest()) {
        return;
    }
    StageManager.pushView(Views.chronicIndexView);
};
//////////////////////

Views.chronicIndexView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'chronicIndexView',
        name: '首页-慢病管理'
    },
    willShow: function (ct) {
        this.pageNum = 1;
        this.render(ct, {memberImgURL: MEMBER_ICON_URL, member: Util.data('current.member')});
//		this.loadVitalSigns();
    },
    didShow: function () {
        this._viewScroller = Util.makeScrollableWithPullRefresh($('.ui-scroll'), {
            onPullDownRefresh: this.onPullDownRefresh/*,onPullUpRefresh:self.onPullUpRefresh*/
        });
        $('.vital-sign-list').motionTrack('start', {
            type: 'h',
            selector: '.item',
            delegate: this
        });
    },
    onTrackStart: function (target, pt) {
        if (this.lastTarget && this.lastTarget !== target) {
            $(this.lastTarget).css({"left": '0'}).children().eq(2).hide();
            this.lastTarget.lastTrackDx = 0;
        }//如果前面已经有移动的，恢复初始状态
        target.style.webkitTransitionDuration = '.2s';
        target.lastTrackPt = pt;
        if (typeof target.lastTrackDx === 'undefined') target.lastTrackDx = 0;
        this.lastTarget = target;
    },
    onTrackMove: function (target, pt) {
        target.style.webkitTransitionDuration = '.2s';
        var dx = target.lastTrackDx + (pt.x - target.lastTrackPt.x);
        if (dx < -30) {
            $(target).css({"left": '-84px'});
            return;
        } else if (dx > 30) {
            $(target).css({"left": '0'});
            return;
        }
        target.lastTrackPt = pt;
        target.lastTrackDx = dx;
    },
    onTrackEnd: function (target) {
        target.lastTrackDx = 0;
    },
    didHide: function () {
        this.$super().didHide();
        $('.vital-sign-list').motionTrack('stop');
        if (this._viewScroller) {
            this._viewScroller.destroy();
            this._viewScroller = null;
        }
    },
    onPullDownRefresh: function () {
        Views.chronicIndexView.pageNum = 1;
        Views.chronicIndexView.loadVitalSigns(false);
    },
//	onPullUpRefresh:function(){
//		Views.chronicIndexView.pageNum = Views.chronicIndexView.pageNum+1;
//		Views.chronicIndexView.loadVitalSigns(true);
//	},
    loadVitalSigns: function (isAppend) {
        var self = this;

        DataExchange.getChronicVitalSigns({
            "data": {
                memberId: Util.data('current.member').memberId,
                pageNum: self.pageNum,
                pageSize: 3,
                endDate: DateUtil.formatWithPatternDate("yyyy-mm-dd", new Date(new Date().getTime() + 86400000))
            }
        }).done(function (json) {
                if (json.success) {
                    var data = json.data, vsList = Util.data('chronic.vsList') || [];
                    for (var i = 0, len = data.length; i < len; i++) {
                        self.processData(data[i]);
                    }
                    Util.data('chronic.vsList', vsList.concat(data));
                    self.deployASHtml(data, isAppend);
                }
            });
    },
    findVitalSign: function (id) {
        var vsList = Util.dataClear('chronic.vsList');
        for (var i = 0, len = vsList.length; i < len; i++) {
            if (vsList[i].id === Number(id)) {
                return vsList[i];
            }
        }
    },
    processData: function (data) {
        if (data.calBloodPressure < 120) {
            data.levelStr = '理想';
            data.levelCol = '#70d0d6';
            data.levelClass = 'vs-level-1';
            data.levelClass2 = 'ideal';
        } else if (data.calBloodPressure < 140) {
            data.levelStr = '正常';
            data.levelCol = '#9dd670';
            data.levelClass = 'vs-level-2';
            data.levelClass2 = 'normal';
        } else if (data.calBloodPressure < 160) {
            data.levelStr = '轻度';
            data.levelCol = '#dcc768';
            data.levelClass = 'vs-level-3';
            data.levelClass2 = 'mild';
        } else if (data.calBloodPressure < 180) {
            data.levelStr = '中度';
            data.levelCol = '#e48334';
            data.levelClass = 'vs-level-4';
            data.levelClass2 = 'medium';
        } else {
            data.levelStr = '重度';
            data.levelCol = '#e45a5a';
            data.levelClass = 'vs-level-5';
            data.levelClass2 = 'serious';
        }
    },
    deployASHtml: function (data, isAppend) {
        if (data.length) {
            var $content = $('.vital-sign-list'), $parentContent = $content.parent();
            if (isAppend) {
                $('.vital-sign-list').append(Views.tmpl.chronicVitalSignSubView({
                    datas: data
                }));
            } else {
                $('.vital-sign-list').html(Views.tmpl.chronicVitalSignSubView({
                    datas: data
                }));
            }
            if (!$("#a_pullUp").length) {
                $parentContent.append('<a id="a_pullUp" class="ui-btn a-pullup" data-action="loadMoreChronicVitalSign">点击加载更多</a>');
            }
        } else {
            if (this.pageNum === 1 && !$(".no-vsList").length) {
                $('.vital-sign-list').html(
                    '<div class="corver-page    reportMaternal"><div class="no-report-bg reportMaternal"></div><div class="f-14-adadad tac text">暂无体征数据</div></div>');
                $("#a_pullUp").remove();
            }
        }
//        var self = this;
//        var $eles = $(".vital-sign-list .item");
//        for(var i=0,len=$eles.length;i<len;i++){
//            Util.makeScrollable($eles.eq(i), {
//                hScroll:false,
//                vScroll:false,
//                onScrollEnd: function(){
//                    Views.isAnyViewScrolling = false;
//                    self.onVitalSignScrollEnd(this);
//                }
//            });
//        }
    }
//    onVitalSignScrollEnd:function(that){
//        var dir = that.dirX;
//        if (dir == 0) {return;}
//        if(dir == -1){
//            that.scroller.style.marginLeft = '0px';
//        }else{
//            //--84px is the width of delete icon
//            that.scroller.style.marginLeft = '-84px';
//        }
//    }
});
Callback.loadMoreChronicVitalSign = function () {
    Views.chronicIndexView.pageNum = Views.chronicIndexView.pageNum + 1;
    Views.chronicIndexView.loadVitalSigns(true);
};

Callback.deleteChronicVitalSign = function (btnId) {
    DataExchange.removeChronicVitalSign({
        signFormId: $("#" + btnId).attr("data-rel")
    }).done(function (json) {
            if (json.success) {
                Views.chronicIndexView.onPullDownRefresh();
            }
        });
}
Views.chronicVitalSignDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'chronicVitalSignDetailView',
        name: '首页-慢病管理-血压详情'
    },
    show: function (detailId) {
        this.vs = Views.chronicIndexView.findVitalSign(detailId);
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        Views.chronicIndexView.processData(this.vs);
        this.render(ct, {vs: this.vs, member: Util.data('current.member')});
        this.viewScrollerInit($('.ui-scroll'));
    }
});
Callback.showVitalSignDetail = function (btnId) {
    Views.chronicVitalSignDetailView.show($("#" + btnId).attr('data-rel'));
};

Views.chronicVitalSignsTrendView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'chronicVitalSignsTrendView',
        name: '首页-慢病管理-血压详情-趋势'
    },
    canvas: {
        w: wndw.width() - 72,
        h: wndw.height() - 132
    },
    chartCanvas: null,
    modeTime: 7,
    willShow: function (ct) {
        this.chartCanvas = null;
        Widget.popupLoading();
        if ( mobile_system === 'ios' && parseInt(device.version, 10) >= 7 ) {
            cordova.exec(function () {
                Views.chronicVitalSignsTrendView.showStep1(ct);
            }, function () {
                Widget.popupLoadingClose();
                Widget.popupToast('程序发生错误');
            }, 'StatusBar', 'hide', []);
        } else {
            Views.chronicVitalSignsTrendView.showStep1(ct);
        }
    },
    showStep1: function (ct) {
        var self = this;
        cordova.exec(function () {
            setTimeout(function () {
                Widget.popupLoadingClose();
                $("#J_cssAppend").html(Views.tmpl.cssAppend({
                    windowWidth: wndw.width(),
                    windowHeight: wndw.height()
                }));
                self.canvas = {
                    w: wndw.width() - 72,
                    h: wndw.height() - 132
                };
                self.render(ct, {
                    member: Util.data('current.member'),
                    memberImgURL: MEMBER_ICON_URL,
                    canvasW: wndw.width() - 70,
                    canvasH: wndw.height() - 130
                });
                self.viewScrollerInit($('#horizontalScroll'), {
                    bounce: false,
                    snap: true,
                    momentum: false,
                    hScrollbar: false,
                    onScrollEnd: function (e) {
                        Views.isAnyViewScrolling = false;
                        document.querySelector('#indicator span.active').className = '';
                        document.querySelector('#indicator span:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                    }
                });
                self.canvasBg();
                Widget.popupLoading('正在获取体征');
                setTimeout(function () {
                    self.getBPTrendData(7, '一周');
                }, 800);
            }, 1000);
        }, function () {
            Widget.popupLoadingClose();
            Widget.popupToast('程序发生错误');
        }, 'LandScape', 'landscape', []);
    },
    getBPTrendData: function (beforeDays, timeStr) {
        var now = new Date(), endDate = new Date(now.getTime() + 86400000), startDate = new Date(endDate.getTime() - beforeDays * 86400000), self = this;
        DataExchange.getBPTrendData({
            "data": {
                memberId: Util.data('current.member').memberId,
                startDate: startDate,
                endDate: endDate
            }
        }).done(function (json, textStatus, jqXHR) {
                if (json.success) {
                    self.modeTime = beforeDays - 0;
                    self.canvasChart(json.data.detailList);
                    $('#chartTitle').html(timeStr);
                    $('#txtTitle').html(timeStr);
                    $('#counts').html(json.data.measureTimes);
                    $('#bp').html(json.data.avgSbp + '/' + json.data.avgDbp);
                    $('#pulse').html(json.data.avgPulse);
                    if (json.data.measureTimes === 0) {
                        $('.bottom').html('您暂时没有血压数据');
                    } else {
                        $('.bottom').html('您的血压状态为<span id="level"></span><span id="warm"></span>');
                        $('#level').css('color', Constant.getVSRemindColor(json.data.bpLevel)).html(Constant.getVSRemindText(json.data.bpLevel));
                        Constant.getRemind(json.data.bpLevel, function (data) {
                            $('#warm').html(data);
                        });
                        // $('#warm').html(Constant.getRemind(json.data.bpLevel));
                    }
                }
            });
    },
    testShowTrendView: function () {
        Views.chronicVitalSignsTrendView.canvasBg();
//		Views.registerDestructor(function() {
//			if (this._viewScroller) this._viewScroller.destroy();
//		});
        this.bpTrendSelTime('一周');
    },
    canvasBg: function () {
        var vcContent = Util.canvasInit(document.getElementById("charBg")), i;
        vcContent.beginPath();
        vcContent.strokeStyle = "#f5f5f5";
        vcContent.lineWidth = 0.5;
        for (i = 1; i <= 29; i++) {
            if (i % 6 === 0)
                continue;
            vcContent.moveTo(0, i / 30 * this.canvas.h);
            vcContent.lineTo(this.canvas.w, i / 30 * this.canvas.h);
            vcContent.stroke();
        }
        vcContent.closePath();

        vcContent.beginPath();
        vcContent.strokeStyle = "#cccfcc";
        vcContent.lineWidth = 0.5;
        for (i = 1; i <= 4; i++) {
            vcContent.moveTo(0, i / 5 * this.canvas.h);
            vcContent.lineTo(this.canvas.w, i / 5 * this.canvas.h);
            vcContent.stroke();
        }
        vcContent.closePath();
    },
    bpTrendSelTime: function (timeStr) {
        Widget.popupLoading();
        var data = TestSuit.bpTrendData;
        setTimeout(function () {
            $('#chartTitle').html(timeStr);
            $('#txtTitle').html(timeStr);
            $('#counts').html(data.measureTimes);
            $('#bp').html(data.avgSbp + '/' + data.avgDbp);
            $('#pulse').html(data.avgPulse);
            $('#level').css('color', Constant.getVSRemindColor(data.bpLevel)).html(Constant.getVSRemindText(data.bpLevel));
            $('#warm').html(Constant.getRemind(data.bpLevel));
            Views.chronicVitalSignsTrendView.modeTime = 7;
            Views.chronicVitalSignsTrendView.canvasChart(data.detailList);
            Widget.popupLoadingClose();
        }, 666);
    },
    canvasChart: function (vslist) {
        var vcContent, i, points = [], w = this.canvas.w, h = this.canvas.h;
        if (this.chartCanvas) {
            vcContent = this.chartCanvas;
        } else {
            vcContent = Util.canvasInit(document.getElementById("bpTrendChart"));
            this.chartCanvas = vcContent;
        }

        if (vslist.length === 1) {
            points.push(this.valToPX(vslist[0], w / 2));
        } else {
            for (i = vslist.length; i > 0; i--)
                points.push(this.valToPX(vslist[i - 1], (vslist.length - i) * w / (vslist.length - 1)));
        }

        vcContent.clearRect(0, 0, w, h);
        if (vslist.length !== 0) {

            //area
            vcContent.beginPath();
            var startP = points[0], endP, centerP;
            vcContent.moveTo(startP.x, startP.y);
            for (i = 1; i < points.length; i++) {
                endP = points[i];
                vcContent.lineTo(endP.x, endP.y);
                startP = endP;
            }
            vcContent.lineTo(points[i - 1].x, h);
            vcContent.lineTo(points[0].x, h);
            vcContent.lineTo(points[0].x, points[0].y);
            vcContent.closePath();
            var gradient = vcContent.createLinearGradient(0, 0, 0, h);
            gradient.addColorStop(0, 'rgba(185,216,178,0.8)');
            gradient.addColorStop(1, 'rgba(185,216,178,0.2)');
            vcContent.fillStyle = gradient;
            vcContent.fill();
            //line
            vcContent.beginPath();
            startP = points[0];
            vcContent.moveTo(startP.x, startP.y);
            for (i = 1; i < points.length; i++) {
                endP = points[i];
                vcContent.lineTo(endP.x, endP.y);
                startP = endP;
            }
            vcContent.strokeStyle = '#abd09c';
            vcContent.lineWidth = 1.5;
            vcContent.stroke();
            //circle
            for (i = 0; i < points.length; i++) {
                centerP = points[i];
                this.drawCircle(vcContent, centerP, '#f6f6f6', 4.5);
                this.drawCircle(vcContent, centerP, '#82bb64', 3);
            }
            //横坐标
            if (vslist.length === 1) {
                $('.bottom-label').html(DateUtil.formatWithPatternDate('yyyy-mm-dd HH:ii ', new Date(vslist[0].recordTime)));
            } else {
                $('.bottom-label').html(DateUtil.formatWithPatternDate('yyyy-mm-dd HH:ii ', new Date(vslist[vslist.length - 1].recordTime)) + ' 至 ' + DateUtil.formatWithPatternDate('yyyy-mm-dd HH:ii ', new Date(vslist[0].recordTime)));
            }
            //绑定canvas点击事件
            this.bindCanvasClick(vslist, points.reverse());
        } else {
            $('.bottom-label').html("");
        }
    },
    valToPX: function (item, x) {
        var hPX = 100, val = item.calBloodPressure;
        if (val >= 40 && val < 120)
            hPX = ( val - 40 ) / 4; else if (val >= 120 && val < 180)
            hPX = val - 100; else if (val >= 180 && val < 250)
            hPX = ( val + 100 ) * 2 / 7;
        return {
            x: x,
            y: ( 1 - hPX / 100 ) * this.canvas.h
        };
    },
    drawCircle: function (vcContext, center, color, r) {
        vcContext.beginPath();
        vcContext.arc(center.x, center.y, r, 0, Math.PI * 2, true);
        vcContext.closePath();
        vcContext.fillStyle = color;
        vcContext.fill();
    },
    bindCanvasClick: function (vslist, points) {
        $('#bpTrendChart').off('click');
        if (points.length > 24) {
            return;
        }

        var selVS = null, selPoint = null;
        $('#bpTrendChart').on('click', function (event) {
            var x = event.offsetX, y = event.offsetY, i = 0, minIndex, minJuli = 1000 , juli;
            for (i in points) {
                juli = Math.sqrt((points[i].x - x) * (points[i].x - x) + (points[i].y - y) * (points[i].y - y));
                if (juli < minJuli) {
                    minJuli = juli;
                    minIndex = i;
                }
            }
            if (minJuli === 1000 || minJuli > 18) {
                //清理弹出框
                $('.bpTrend-alert').remove();
                selVS = null;
                selPoint = null;
                return;
            }
            //找到了最小距离点
            //先判断是否已经弹出
            if (selPoint && $('.bpTrend-alert').length > 0/*是否有弹出框*/) {
                if (selPoint.x === points[minIndex].x && selPoint.y === points[minIndex].y) {
                    return;
                } else {
                    //清理弹出框
                    $('.bpTrend-alert').remove();
                    selVS = null;
                    selPoint = null;
                }
            }
            selVS = vslist[minIndex];
            selPoint = points[minIndex];
            var w, h, top, left, valign, halign;
            w = event.target.width / 2;
            h = event.target.height / 2;
            if (selPoint.y > h / 2) {
                valign = 'v-top';
                top = selPoint.y - 53;
            }
            if (selPoint.y <= h / 2) {
                valign = 'v-bottom';
                top = selPoint.y + 30;
            }
            if (selPoint.x < w * 0.2) {
                halign = 'h-left';
                left = selPoint.x + 30;
            }
            if (selPoint.x > w * 0.8) {
                halign = 'h-right';
                left = selPoint.x - 110;
            }
            if (selPoint.x >= w * 0.2 && selPoint.x <= w * 0.8) {
                halign = 'h-center';
                left = selPoint.x - 35;
            }
            $('#canvas').append(Views.tmpl.chronicVitalSignTrendAlertView({
                vs: selVS,
                top: top,
                left: left,
                valign: valign,
                halign: halign
            }));
        });
    },
    onPageBack: function () {
        return false;
    }
});
Callback.closeTrend = function () {
    cordova.exec(function () {
        Widget.popupLoading('请稍候');
        setTimeout(function () {
            Views.chronicVitalSignsTrendView.chartCanvas = null;
            if  ( 'StatusBar' in window ) {
                if ( mobile_system === 'ios' && parseInt(device.version, 10) >= 7 ) {
                    StatusBar.show();
                    Layout.adjustWindowSize(wndw.width(), wndw.height()-20);
                } else {
                    Layout.adjustWindowSize(wndw.width(), wndw.height());

                }


            }
            //ios 7 need -20
            Widget.popupLoadingClose();
            StageManager.layout.popStackView();
//					if (StageManager.getCurrentView()) {
//						StageManager.().onResize(wndw.width(), wndw.height());
//					}
        }, 666);
    }, function () {
        Widget.popupToast('程序发生错误');
    }, 'LandScape', 'protrait', []);
};
Callback.bpTrendDateSel = function (btnId) {
    var btn = $('#' + btnId), time = btn.attr('data-rel'), timeStr = btn.html();
    $('.time-table .ui-btn').removeClass('active');
    btn.addClass('active');
    {
        //清理弹出框
        $('.bpTrend-alert').remove();
        selVS = null;
        selPoint = null;
    }
    Views.chronicVitalSignsTrendView.getBPTrendData(time, timeStr);
};

Views.chronicRiskAssessView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'chronicRiskAssessView',
        name: '首页-慢病管理-血压详情-风险评估'
    },
    inputHint: {
        'RIS016': '身高可输入范围是40-250',
        'RIS017': '体重可输入范围是2-150',
        'RIS005': '腰围可输入范围是15-300',
        'RIS013': '尿微量白蛋白可输入范围是0-300'
    },
    willShow: function (ct) {
        var member = Util.data('current.member');
        this.render(ct, {
            member: {
                height: member.height > 0 ? member.height : '',
                weight: member.weight > 0 ? member.weight : '',
                birthYear: new Date(member.birthday).getFullYear()
            }
        });
        this.jqRiskAssessDivs = $('div.bp-risk-assess-questionnaire');
        this.currPageX = 0;
        this.submitParams = {};
        if (member.height > 0 && member.weight > 0) {
            var bmi = (member.weight / (member.height * member.height / 10000)).toFixed(2);
            $('#bpRiskAssess_BMI').html(bmi);
            this.submitParams['RIS004'] = bmi;
        }
        this.bindEvent();
    },
    didShow: function (ct) {
        var self = this;
        this.viewScrollerInit($('#bpRiskAssess'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#bp_risk_assess_questionnaire_navi li.active').className = '';
                document.querySelector('#bp_risk_assess_questionnaire_navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('#bpRiskAssess').height())
            return;
        this.pullRefresher = Util.makeScrollable(jqEl);
    },
    didHide: function () {
        this.$super().didHide();
        if (this.pullRefresher) {
            this.pullRefresher.destroy();
            this.pullRefresher = null;
        }
    },
    riskAssessSubmitAjax: function () {
        var arr = [], inputHint = Views.chronicRiskAssessView.inputHint, k;
        for (k in this.submitParams) {
            if (k === 'RIS016' && this.submitParams[k] - 0 < 40) {
                Widget.popupToast(inputHint[k]);
                return;
            }
            if (k === 'RIS017' && this.submitParams[k] - 0 < 2) {
                Widget.popupToast(inputHint[k]);
                return;
            }
            /*if(k==='RIS010') {
             if( isNaN(this.submitParams[k]) ) {
             Widget.popupToast('高密度脂蛋白胆固醇的值必须请输入数字！');return;
             }
             if( this.submitParams[k]-0 < 0 ) {
             Widget.popupToast('高密度脂蛋白胆固醇的值必须大于零！');return;
             }
             }*/
            if (k === 'RIS005' && this.submitParams[k] - 0 < 15) {
                Widget.popupToast(inputHint[k]);
                return;
            }
            arr.push(k + '=' + this.submitParams[k]);
        }
        var sel = $('#year');
        arr.push(sel.attr('name') + '=' + sel.val());
        var assessDetail = arr.join(';');

        var member = Util.data('current.member'), vs = Views.chronicVitalSignDetailView.vs, params = {};
        params.assessDetail = assessDetail;
        params.memberId = member.memberId;
        params.assessTime = DateUtil.formatWithPatternDate('yyyy-mm-dd HH:ii', new Date());
        params.vitalSignFormId = vs.id;
        params.sbp = vs.sbp;
        params.dbp = vs.dbp;
        params.pulse = vs.pulse;

        DataExchange.chronicRiskAssessSubmit({
            "data": params
        }).done(function (json) {
                if (json.success) {
                    var data = json.data, nowStr = DateUtil.formatWithPatternDate('yyyy-mm-dd', new Date()), todayRiskTime = Util.data(UserProfile.id + '.riskTime.' + nowStr);
                    if (todayRiskTime) {
                        Util.data(UserProfile.id + '.riskTime.' + nowStr, todayRiskTime + 1);
                    } else {
                        Util.data(UserProfile.id + '.riskTime.' + nowStr, 1);
                    }
                    data.assessTime = params.assessTime;
                    data.sbp = params.sbp;
                    data.dbp = params.dbp;
                    data.pulse = params.pulse;
                    Views.chronicRiskAssessResultView.show(data);
                }
            });
    },
    bindEvent: function () {
        var self = this;
        $('#chronicRisk input[type="tel"]').on('input',function () {
            var value = this.value;
            if (!value && this.lastValue.length === 1) {
                this.value = '';
                this.lastValue = '';
                return;
            }
            if (!value || isNaN(value) || value.length > 4 || value - 0 < 0) {
                this.value = this.lastValue;
                return;
            }
            this.lastValue = value;
        }).on('blur', function () {
                var that = $(this), val = that.val().trim(), max = that.attr('max') - 0, min = Number(that.attr("min")), name = that.attr('name');
                if (val && (val > max || val < min)) {
                    Widget.popupToast(Views.chronicRiskAssessView.inputHint[name]);
                    that.focus();
                    return;
                }
                if (val) {
                    self.submitParams[name] = val;
                } else {
                    delete self.submitParams[name];
                }
                if (name === 'RIS016' /* 身高 */ || name === 'RIS017' /* 体重 */) {
                    var stature = $('#bpRiskAssess_stature').val() - 0, weight = $('#bpRiskAssess_weight').val() - 0;
                    if (stature && weight) {
                        var bmi = (weight / (stature * stature / 10000)).toFixed(2);
                        $('#bpRiskAssess_BMI').html(bmi);
                        self.submitParams['RIS004'] = bmi;
                    } else {
                        $('#bpRiskAssess_BMI').html('--');
                        delete self.submitParams['RIS004'];
                    }
                }
            });
    }
});
Callback.toggleRiskAssessSelection = function (btnId) {
    var _btn = $('#' + btnId), type = _btn.attr('data-type'), submitParams = Views.chronicRiskAssessView.submitParams;
    if (_btn.hasClass('selected')) {
        _btn.removeClass('selected');
        delete submitParams[type];
    } else {
        _btn.addClass('selected');
        submitParams[type] = 1;
    }
};
Callback.riskAssessSubmit = function (btnId) {
    var nowStr = DateUtil.formatWithPatternDate('yyyy-mm-dd', new Date()), todayRiskTime = Util.data(UserProfile.id + '.riskTime.' + nowStr);
    if (todayRiskTime && todayRiskTime >= 1) {
        Util.confirm('请注意，您本次提交的内容将覆盖今日已有的评估结果！', function (index) {
            if (index === 2) {
                Views.chronicRiskAssessView.riskAssessSubmitAjax();
            }
        }, '风险评估');
    } else {
        Views.chronicRiskAssessView.riskAssessSubmitAjax();
    }
};

Views.chronicRiskAssessResultView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'chronicRiskAssessResultView',
        name: '首页-慢病管理-血压详情-风险评估结果'
    },
    show: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
//		StageManager.layout.tabViewStack.pop();//返回到前前一页
        this.prepare(this.data);
        this.render(ct, {
            member: Util.data('current.member'),
            iconURL: MEMBER_ICON_URL,
            data: this.data
        });
    },
    prepare: function (data) {
        Util.data('current.riskLevel', data.riskLevel);
        if (data.riskLevel === 'NORMAL_RISK') {
            data.riskLevelTxt = '正常';
            data.riskLevelCls = 'ideal';
        } else if (data.riskLevel === 'LOW_RISK') {
            data.riskLevelTxt = '低危';
            data.riskLevelCls = 'mild';
        } else if (data.riskLevel === 'MEDIUM_RISK') {
            data.riskLevelTxt = '中危';
            data.riskLevelCls = 'medium';
        } else if (data.riskLevel === 'HIGH_RISK') {
            data.riskLevelTxt = '高危';
            data.riskLevelCls = 'serious';
        }
    }
});

Views.chronicVitalSignAddView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'chronicVitalSignAddView',
        name: '首页-慢病管理-添加血压'
    },
    willShow: function (ct) {
        this.render(ct, {
            member: Util.data('current.member'),
            memberImgURL: MEMBER_ICON_URL,
            now: DateUtil.formatWithPatternDate('yy-mm-dd HH:ii', new Date())
        });
        Util.mobiscrollDateTime('#dateTime');
        Validator.inputs($('input'));
    },
    willHide: function () {
        $('#dateTime').mobiscroll('destroy');
    },
    ajaxAdd: function (params) {
        DataExchange.addChronicVitalSign({
            "data": params
        }).done(function (json, textStatus, jqXHR) {
                if (json.success) {
                    Widget.popupToast('添加成功');
                    StageManager.popView();
                }
            });
    }
});
Callback.addVitalSign = function () {
    var member = Util.data('current.member'), $sbp = $('#sbp'), $dbp = $('#dbp'), $pulse = $('#pulse'), sbp = $sbp.val() - 0, dbp = $dbp.val() - 0, pulse = $pulse.val() - 0, time = $('#dateTime').val();
    if (sbp === 0 || sbp < 40 || sbp > 250) {
        Widget.popupToast('高压值无效(40-250)，请重新输入');
        $sbp.focus();
        return;
    }
    if (dbp === 0 || dbp < 40 || dbp > 250) {
        Widget.popupToast('低压值无效(40-250)，请重新输入');
        $dbp.focus();
        return;
    }
    if (pulse === 0 || pulse < 40 || pulse > 250) {
        Widget.popupToast('脉搏值无效(40-250)，请重新输入');
        $pulse.focus();
        return;
    }
    if (sbp < dbp) {
        Widget.popupToast('高压值必须大于低压值，请重新输入');
        $sbp.focus();
        return;
    }
    Views.chronicVitalSignAddView.ajaxAdd({
        memberId: member.memberId,
        sbp: sbp,
        dbp: dbp,
        pulse: pulse,
        recordTime: time,
        dataFrom: mobile_system === "ios" ? "IPHONE" : "ANDROID_PHONE"
    });
};

Views.chronicRevisitView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'chronicRevisitView',
        name: '首页-慢病管理-随访记录'
    },
    show: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct, {data: this.data});
        this.jqRiskAssessDivs = $('div.revist-tab');
        this.processSymptoms();
    },
    processSymptoms: function () {
        if (this.data.currentSymptoms) {
            var symptoms = this.data.currentSymptoms.split(";");
            var $symptoms = $("#chronicRevist .symptom-desc");
            for (var i = 0, len = $symptoms.length; i < len; i++) {
                for (j in symptoms) {
                    if ((Number(symptoms[j]) - 1) === i) {
                        $symptoms.eq(i).addClass("selected").append('<label class="flag"></label>');
                    }
                }
            }
        }
    },
    didShow: function (ct) {
        var self = this;
        this.viewScrollerInit($('#chronicRevistContent'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#bp_risk_assess_questionnaire_navi li.active').className = '';
                document.querySelector('#bp_risk_assess_questionnaire_navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    didHide: function () {
        this.$super().didHide();
        if (this.pullRefresher) {
            this.pullRefresher.destroy();
            this.pullRefresher = null;
        }
    },
    initVerticalScroller: function (index) {
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.fake-wrapper').height() <= ($('#chronicRevistContent').height() - 20))
            return;
        this.pullRefresher = Util.makeScrollable(jqEl);
    }
});
Callback.showChronicRevisitView = function () {
    DataExchange.getChronicRevisit({}).done(function (json) {
        if (json.success) {
            Views.chronicRevisitView.show(json.data);
        }
    });
}

Views.chronicRiskAssessHistoryView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'chronicRiskAssessHistoryView',
        name: '首页-慢病管理-风险评估历史'
    },
    show: function (data) {
        this.processData(data);
        var today = new Date();
        this.currentYear = today.getFullYear();
        this.currentMonth = today.getMonth();
        this.currentDay = today.getDate();
        StageManager.pushView(this);
    },
    didShow: function (ct) {
        this.renderCalender(true);
        this.bindEvents();
    },
    processData: function (data) {
        this.histories = {};
        for (var i in data) {
            var date = DateUtil.formatWithPatternDate('yyyy-m-d', new Date(data[i].date));
            this.histories[date] = data[i];
        }
    },
    renderCalender: function (isShowCurrentDay) {
        var weeks = ['日', '一', '二', '三', '四', '五', '六'];
        var dateArr = [];
        var begainDate = new Date(this.currentYear, this.currentMonth, 1), endDate = new Date(this.currentYear, this.currentMonth + 1, 0), beforeMonthEndDate = new Date(this.currentYear, this.currentMonth, 0), supplyBefore = begainDate.getDay(),//往前需要补给的天数
            supplyAfter = 6 - endDate.getDay();//往后需要补给的天数
        $(".calender .top .title").html(this.currentYear + "年 " + (this.currentMonth + 1) + "月");
        for (var i = supplyBefore - 1; i >= 0; i--) {
            var date = new Date(this.currentYear, this.currentMonth - 1, beforeMonthEndDate.getDate() - i);
            dateArr.push({'day': date.getDate(), 'month': date.getMonth() + 1, 'year': date.getFullYear(), "cls": "disable"});
        }
        for (var i = 1; i <= endDate.getDate(); i++) {
            var date = new Date(this.currentYear, this.currentMonth, i);
            var key = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate();
            if (this.histories[key]) {
                dateArr.push({'day': date.getDate(), 'month': date.getMonth() + 1, 'year': date.getFullYear(), "cls": "normal has-history", riskId: this.histories[key].riskId});
            } else {
                if (isShowCurrentDay && i === this.currentDay) {
                    dateArr.push({'day': date.getDate(), 'month': date.getMonth() + 1, 'year': date.getFullYear(), "cls": "normal selected"});
                } else {
                    dateArr.push({'day': date.getDate(), 'month': date.getMonth() + 1, 'year': date.getFullYear(), "cls": "normal"});
                }
            }
        }
        for (var i = 1; i <= supplyAfter; i++) {
            var date = new Date(this.currentYear, this.currentMonth + 1, i);
            dateArr.push({'day': date.getDate(), 'month': date.getMonth() + 1, 'year': date.getFullYear(), "cls": "disable"});
        }
        var htmlBuff = [];
        htmlBuff.push('<table width="100%" height="100%" cellpadding="0" cellspacing="0">');
        htmlBuff.push('<col width="15%"/><col width="14%"/><col width="14%"/><col width="14%"/><col width="14%"/><col width="14%"/>');
        for (var i = 0, len = dateArr.length; i < len; i++) {
            if (!(i % 7)) {
                if (i) {
                    htmlBuff.push('</tr>');
                    htmlBuff.push('<tr>');
                } else {
                    htmlBuff.push('<tr>');
                }
            }
            htmlBuff.push('<td><div data-rel="' + dateArr[i].riskId + '" class="' + dateArr[i].cls + '">' + dateArr[i].day + '</div></td>');
        }
        htmlBuff.push('</tr>');
        htmlBuff.push('</table>');
        $(".days-wrapper").html(htmlBuff.join("").toString());
        $(".calender .days-wrapper .normal").click(function () {
            if ($(this).hasClass("has-history")) {
                var riskId = $(this).attr("data-rel");
                DataExchange.getChronicRiskAssess({
                    "riskId": riskId
                }).done(function (json) {
                        if (json.success) {
                            Views.chronicRiskAssessResultView.show(json.data);
                        }
                    });
            } else {
                $(".calender .days-wrapper .normal.selected").removeClass('selected');
                $(this).addClass("selected");
            }
        });
    },
    bindEvents: function () {
        var self = this;
        $(".calender .left-arrow-wrapper").click(function () {
            var date = new Date(self.currentYear, self.currentMonth - 1, self.currentDay);
            self.currentYear = date.getFullYear();
            self.currentMonth = date.getMonth();
            self.renderCalender();
        });
        $(".calender .right-arrow-wrapper").click(function () {
            var date = new Date(self.currentYear, self.currentMonth + 1, self.currentDay);
            self.currentYear = date.getFullYear();
            self.currentMonth = date.getMonth();
            self.renderCalender();
        });
    }
});
Callback.showChronicRiskAssessHistory = function () {
    DataExchange.getChronicRiskAssessDates({
        "data": {
            "memberId": Util.data('current.member').memberId,
            "visitDateS": null,
            "visitDateE": new Date(),
            "pageNum": 1,
            "pageSize": 10000
        }
    }).done(function (json) {
            if (json.success) {
                Views.chronicRiskAssessHistoryView.show(json.data);
            }
        });
};


Callback.showChronicNewsView = function (btnId) {
    var healthInfoView = Views.healthInfoView;
    healthInfoView.catName = '慢病资讯';
    healthInfoView.showCategory = false;
    StageManager.pushView(healthInfoView);
};

