Views.noopsycheDiagnoseGuideView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'noopsycheDiagnoseGuideView',
        name: '自助诊断-首页'
    }
});
Callback.diagnoseGo = function (btnId) {
    var age = $('#age').val().trim(), sex = $('#sex').val();
    if (!age.length) {
        Widget.popupToast('请输入年龄后继续');
        return;
    }
    if (isNaN(age) || age <= 0) {
        Widget.popupToast('请输入真实的年龄后继续');
        return;
    }
    Util.data('cache.diagnoseInfo', {
        sex: sex,
        age: age
    });
    StageManager.pushView(Views.noopsycheDiagnoseImgView);
};
Views.noopsycheDiagnoseImgView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'noopsycheDiagnoseImgView',
        name: '自助诊断-模型',
        img: {
            "woman-front": "themes/images/renti/woman-front.png",
            "woman-contrary": "themes/images/renti/woman-contrary.png",
            "man-front": "themes/images/renti/man-front.png",
            "man-contrary": "themes/images/renti/man-contrary.png"
        },
        mark: {
            "woman-front": "woman-contrary",
            "woman-contrary": "woman-front",
            "man-front": "man-contrary",
            "man-contrary": "man-front"
        }
    },
    willShow: function (ct) {
        var diagnoseInfo = Util.data('cache.diagnoseInfo');
        if (diagnoseInfo.sex === "MALE") {
            diagnoseInfo.imgSrc = this.options.img["man-front"];
            diagnoseInfo.imgSrc2 = this.options.img["man-contrary"];
        } else {
            diagnoseInfo.imgSrc = this.options.img["woman-front"];
            diagnoseInfo.imgSrc2 = this.options.img["woman-contrary"];
        }
        diagnoseInfo.mobile_system = mobile_system;
        this.render(ct, diagnoseInfo);
    },
    didShow: function () {
        // this.viewScrollerInit($('.ui-woman-block'));
    }
});
Callback.overturnRenti = function (btnId) {
    var btn = $('#' + btnId);
    if (btn.hasClass('overturn-in-contrary')) {
        if (mobile_system === 'android') {
            $('.ui-renti-contrary').hide();
            $('.ui-renti-front').show();
        } else {
            $('.page-3d').removeClass('overturn');
        }
    } else {
        if (mobile_system === 'android') {
            $('.ui-renti-front').hide();
            $('.ui-renti-contrary').show();
        } else {
            $('.page-3d').addClass('overturn');
        }
    }
};
function imgToList(code, directionType, id) {
    var rentiDiv = $('.ui-renti-front'), selector = '#' + id;
    if (directionType !== 'FRONT') {
        rentiDiv = $('.ui-renti-contrary');
    }
    rentiDiv.find(selector).show();
    setTimeout(function () {
        rentiDiv.find(selector).hide();
    }, 180);
    var partType = Views.noopsycheDiagnoseListView.getPartType(Util.data('cache.diagnoseInfo')), options = {
        code: code,
        partType: partType,
        data: {
            directionType: directionType
        }
    };
    DataExchange.bodypartSecond(options).done(function (json) {
        if (json.success) {
            Util.data("twoLevelPartData", json.data);
            StageManager.pushView(Views.noopsycheDiagnoseList2View);
        }
    });
};

Callback.showRentiList = function () {
    var partType = Views.noopsycheDiagnoseListView.getPartType(Util.data('cache.diagnoseInfo'));
    DataExchange.bodypartFirst({
        partType: partType
    }).done(function (json) {
            if (json.success) {
                Util.data("firstLevelPartData", json.data);
                StageManager.pushView(Views.noopsycheDiagnoseListView);
            }
        });
};
Views.noopsycheDiagnoseListView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'noopsycheDiagnoseListView',
        name: '自助诊断-列表',
        title: '自助诊断',
        action: 'showRentiTwoLevel'
    },
    willShow: function (ct) {
        this.render(ct, {
            datas: Util.data('firstLevelPartData'),
            options: this.options
        });
    },
    didShow: function () {
        this.viewScrollerInit($('.renti-first-Part'));
    },
    getPartType: function (param) {
        var sex = param.sex, age = param.age * 1, postfix = (sex === "MALE" ? "MAN" : "WOMAN"), prefix = "";

        if (age < 18 && age >= 13) {
            prefix = "THIRTEEN_SEVENTEEN_";
        } else if (age < 13 && age >= 7) {
            prefix = "SEVEN_TWELVE_";
        } else if (age < 7 && age >= 3) {
            prefix = "THREE_SIX_";
        } else if (age < 3 && age >= 0) {
            prefix = "ZERO_TWO_";
        }
        return prefix + postfix;
    }
});

Callback.showRentiTwoLevel = function (btnId) {
    // Views.noopsycheDiagnoseList2View.options.title = $("#" + btnId).find('.left-label').html();
    var partType = Views.noopsycheDiagnoseListView.getPartType(Util.data('cache.diagnoseInfo')), code = $("#" + btnId).attr("data-rel");
    DataExchange.bodypartSecond({
        partType: partType,
        code: code,
        data: {}
    }).done(function (json) {
            if (json.success) {
                Util.data("twoLevelPartData", json.data);
                StageManager.pushView(Views.noopsycheDiagnoseList2View);
            }
        });

};
Views.noopsycheDiagnoseList2View = $.extend({}, Views.noopsycheDiagnoseListView, {
    options: {
        tmpl: 'noopsycheDiagnoseListView',
        name: '自助诊断-列表2',
        title: '',
        action: 'showSymptoms'
    },
    willShow: function (ct) {
        var twoLevelPartData = Util.data('twoLevelPartData');
        this.options.title = twoLevelPartData[0].partName;
        twoLevelPartData.splice(0, 1);
        this.render(ct, {
            datas: twoLevelPartData,
            options: this.options
        });
    }
});

Callback.showSymptoms = function (btnId) {
    var btn = $('#' + btnId), id = btn.attr('data-rel'), partName = btn.find('.left-label').html();
    DataExchange.guideSymptoms({
        id: id
    }).done(function (json) {
            if (json.success) {
                Util.data("symptomData", { part: partName, data: json.data });
                Util.data("selectedSymptomData", '');
                StageManager.pushView(Views.symptomDescribeView);
            }
        });
};
Views.symptomDescribeView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'symptomDescribeView',
        name: '自助诊断-列表3',
        title: ''
    },
    willShow: function (ct) {
        var param = Util.data("symptomData"), data = Util.data("selectedSymptomData");

        this.options.title = param.part;
        this.render(ct, {
            options: this.options,
            datas: param.data,
            sels: data
        });
    },
    didShow: function () {
        this.viewScrollerInit($('.renti-first-Part'));
    }
});
Callback.checkSymptom = function (btnId) {
    var btn = $('#' + btnId), _switch = btn.find('.sex-sel'), data_Id = btn.attr('data-rel'), data_name = btn.find('.sex-label').html(), data = Util.data("selectedSymptomData") || {}, param = Util.data("symptomData");

    if (_switch.hasClass('sel')) {
        delete data[data_Id];

        Util.data("selectedSymptomData", data);

        _switch.removeClass('sel');
    } else {
        data[data_Id] = '(' + param.part + ')' + data_name;

        Util.data("selectedSymptomData", data);

        _switch.addClass('sel');
    }
};

Callback.showSelectedSymptomView = function (btnId) {
    // StageManager.pushView(Views.selectedSymptomView);
    if (!$('.sex-sel.sel').length) {
        Widget.popupToast("请选择疾病状况");
        return;
    }
    Callback.toPathogenesis(btnId);
};
Views.selectedSymptomView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'selectedSymptomView',
        name: '已选症状'
    },
    willShow: function (ct) {
        this.render(ct, {
        });
    }
});

Callback.toPathogenesis = function (btnId) {
    var symptoms = Util.data("symptomData").data, symptomSels = Util.data("selectedSymptomData"), ids = [], i = 0, age = Util.data('cache.diagnoseInfo').age + '';
    for (; i < symptoms.length; i++) {
        var symptomId = symptoms[i].id;
        if (symptomSels[ symptomId ]) {
            ids.push(symptomId);
        }
    }
    ids = ids.join(',');
    DataExchange.diseaseMatched({
        ids: ids,
        data: {
            age: age
        }
    }).done(function (json) {
            if (json.success) {
                if (!json.data || json.data.length === 0) {
                    Util.alert("无匹配病症");
                    return;
                }
                Util.data("pathogenesisData", json.data);
                StageManager.pushView(Views.symptomResultView);
            }
        });
};
Views.symptomResultView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'symptomResultView',
        name: '可能病因'
    },
    willShow: function (ct) {
        var data = Util.data("pathogenesisData");
        this.render(ct, {
            info: data
        });
        this.shrinkInfo();
        this.renderProgress();
        this.viewScrollerInit($('#pageScrollerWrapper'));
    },
    shrinkInfo: function () {
        $(".shrink-title").each(function (i) {
            var divH = $(this).height(), $span = $("span", $(this)).eq(0);
            while ($span.outerHeight() > divH) {
                $span.text($span.text().replace(/(\s)*([a-zA-Z0-9]+|\W)(\.\.\.)?$/, "..."));
            }
        });
    },
    renderProgress: function () {
        function renderPublicProgress(param) {
            var process = param.process, // 一个canvas标签
                canvas = param.self, // 拿到绘图上下文,目前只支持"2d"
                context = canvas.getContext('2d'), // 将绘图区域清空,如果是第一次在这个画布上画图,画布上没有东西,这步就不需要了
//			context.clearRect(0, 0, 48, 48);

                devicePixelRatio = window.devicePixelRatio || 1, backingStoreRatio = context.webkitBackingStorePixelRatio || context.backingStorePixelRatio || 1, ratio = devicePixelRatio / backingStoreRatio, canvasWidth = canvas.width, canvasHeight = canvas.height;
            if (devicePixelRatio !== backingStoreRatio) {
                canvas.width = canvasWidth * ratio;
                canvas.height = canvasHeight * ratio;

                canvas.style.width = canvasWidth + 'px';
                canvas.style.height = canvasHeight + 'px';

                context.scale(ratio, ratio);
            }

            // 画进度
            var i = 0;
            var r = setInterval(function () {
                if (i >= process * 1) {
                    clearInterval(r);
                    return;
                }
                if (i > 0) context.clearRect(0, 0, canvasWidth, canvasHeight);
                context.save();

                context.beginPath();
                context.moveTo(param.x, param.y);
                context.arc(param.x, param.y, param.r4, 0, Math.PI * 2, false);
                context.closePath();
                context.fillStyle = param.r4Color;
                context.fill();

                //在中间写字
                context.font = "bold " + param.fontSize + " Arial";
                context.fillStyle = '#000';
                context.textAlign = 'center';
                context.textBaseline = 'middle';
                context.moveTo(55, 55);
                context.fillText(process + '%', param.x, param.y);

                context.globalCompositeOperation = 'destination-over';
                context.beginPath();
                context.moveTo(param.x, param.y);
                context.arc(param.x, param.y, param.r3, 0, Math.PI * 2, false);
                context.closePath();
                context.fillStyle = param.r3Color;
                context.fill();
                context.beginPath();

                context.globalCompositeOperation = 'destination-over';
                context.beginPath();
                context.moveTo(param.x, param.y);
                context.arc(param.x, param.y, param.r2, 0, Math.PI * 2, false);
                context.closePath();
                context.fillStyle = param.r2Color;
                context.fill();
                context.beginPath();

                // 画扇形的时候这步很重要,画笔不在圆心画出来的不是扇形
                context.moveTo(param.x, param.y);
                context.arc(param.x, param.y, param.r1, -Math.PI / 2, -Math.PI / 2 + Math.PI * 2 * (i + 1) / 100, false);
                context.closePath();
                context.fillStyle = param.r1Color;
                context.fill();

                context.restore();
                i++;
            }, 15);
            context.closePath();
        };
        var self = $('#big-pathogenesis-progress');
        renderPublicProgress({
            self: self[0],
            x: 55,
            y: 55,
            fontSize: '18pt',
            process: self.text(),
            r1: 55,
            r1Color: '#03898c',
            r2: 48,
            r2Color: '#fff',
            r3: 46,
            r3Color: '#03898c',
            r4: 44,
            r4Color: '#fff'
        });
        $('.ui-item-progress').each(function (index, element) {
            var r1Color = '#33afb1';
            if (index > 3 && index < 8) {
                r1Color = '#5ec2c0';
            } else if (index < 12 && index >= 8) {
                r1Color = '#8bccce';
            } else if (index >= 12) {
                r1Color = '#cde5e5';
            }
            renderPublicProgress({
                self: this,
                x: 28,
                y: 28,
                fontSize: '10pt',
                process: $(this).text(),
                r1: 28,
                r1Color: r1Color,
                r2: 25,
                r2Color: '#fff',
                r3: 23,
                r3Color: r1Color,
                r4: 22,
                r4Color: '#fff'
            });
        });
    }
});

Callback.pageBackToIndex = function (btnId) {
    StageManager.pushView(Views.mainView);
};
Callback.toDiseaseView = function (btnId) {
    console.log("这个页面未整合进来-!-");
};
Callback.toggleSexVal = function (btnId) {
    var $btn = $('#' + btnId);
    if ($btn.val() === '男') {
        $btn.val('女');
        $('#sex').val('FEMALE');
    } else {
        $btn.val('男');
        $('#sex').val('MALE');
    }
};