Callback.showFamilyPhysicianView = function (btnId) {
    if (!Util.loginSuggest()) {
        return;
    }
    StageManager.pushView(Views.familyPhysicianView);
};
//////////////////////////////
Views.familyPhysicianView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "familyPhysicianView",
        name: "家庭医生"
    },
    willShow: function (ct) {
        LocalMode("fp").remove();
        this.render(ct);
        StageManager.fixPageBack(Views.mainView);

    },
    willHide: function () {
        Util.data('index.mainView', "");
    }
});

Views.knowFDView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "knowFDView",
        name: "服务协议书"
    },
    willShow: function(ct) {
        var self =this;
        DataExchange.commonText('json/fdKnowLedge.txt').done(function (text) {
            self.render(ct, {data: text});
            self.viewScrollerInit($('#fdKnowledge'));
        });
    }
});
////////////////////////
Views.applyFamilyPhysicianView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "applyFamilyPhysicianView",
        name: "申请家庭医生"
    },
    willShow: function (ct) {
        this.render(ct, {
            fp: LocalMode("fp").get()
        });
        this.viewScrollerInit($('#familyPhysician'));
        StageManager.fixPageBack(Views.familyPhysicianView);
    }

});

Callback.applyDocSelect = function (btnId) {
    var FP = LocalMode("fp"),
        fp = FP.get(),
        hosCheck,
        teamCheck,
        personCheck;
    function check (item, message) {
        if (fp[item] && $('#' + item).attr('data-id')) {
            return true;
        } else {
            Widget.popupFailure("请先选择" + message);
        }
    }
    if ("person" === btnId) {
        StageManager.pushView(Views.applyMedCardView);
        return;
    }
    personCheck = check('person', "签约成员");
    if ("newHosId" === btnId && personCheck) {
        Views.hosListView.mode = "fp";
        StageManager.pushView(Views.hosListView);
        return;
    }
    hosCheck = personCheck && check('newHosId', "社区服务中心");
    if ("team" === btnId && hosCheck) {
        StageManager.pushView(Views.hosTeamView);
        return;
    }
    teamCheck = hosCheck && check('team', "服务团队");
    if ("doctorId" === btnId && teamCheck) {
        StageManager.pushView(Views.hosTeamDoctorView);
        return;
    }
    if ("applySubmit" === btnId && teamCheck && check('doctorId', "医生")) {
        StageManager.pushView(Views.ensureApplyInfoView);
        return;
    }
};
////////////////////////////////

Views.applyMedCardView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "applyMedCardView",
        name: "选择签约成员"
    },
    willShow: function (ct) {
        DataExchange.getMedCard({accountId: UserProfile.id}).done(function (json) {
            var page = StageManager.getCurrentView(),
                cardNo = LocalMode("fp").get().cardNo || "";
            if (json.success) {
                page.render(ct, {
                    data: json.data,
                    cardNo: cardNo.split(',')
                });
            } else {
                page.render(ct, {data: {}});
            }
            page.viewScrollerInit($('#applyPerson'));
        });
    }
});
Callback.selectMedCard = function (btnId) {
    $('#' + btnId).toggleClass('selected');
};
Callback.collectMedCard = function (btnId) {
    var medCards = $('.med-card-item.selected'),
        FP = LocalMode("fp"),
        name = [],
        id = [],
        cardnum = [],
        person = [],
        medCard;
	medCards.each(function(index, value) {
		medCard = medCards.eq(index);
		var personId = medCard.attr('data-rel'),
			member = UserProfile.findMember(personId),
			cardUser;
		if (member) {
			person.push(personId);
			cardUser = $.trim(medCard.find('.med-card-name').text());
			cardnum.push(medCard.attr('data-card'));//card.num
			id.push(member.idCard);
			name.push(cardUser); //name
		} else {
			medCards.removeClass('selected');
			Widget.popupToast("无法查到就诊卡为" + cardUser.replace(/\*/g,"") + "的使用者的身份证");
		}
	});
    FP.update({
        idNo: id.join(','),
        name: name.join(','),
        cardNo: cardnum.join(','),
        person: person.join(',')
    });
    StageManager.popView();
};

Callback.applySelectHos = function (btnId) {
    var _btn = $('#' + btnId),
        hosId = $.trim(_btn.attr('data-id')),
        hos = $.trim(_btn.text().replace("√", ""));

    Views.detailHosView.init({
        hos: hos,
        hosId: hosId
    });

};
Callback.ensureApplyHos = function (btnId) {
    var  FP = LocalMode("fp"),
        fp = FP.get(),
        data = Views.detailHosView.data;
    if (fp.newHosId != data.hosId) {
        FP.update({
            newHosId: data.hosId,
            newHos: data.hos,
            team: "",
            teamName:"",
            doctorId: "",
            docName: ""
        });
    }
    StageManager.pushView(Views.applyFamilyPhysicianView);
};
Views.detailHosView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "detailHosView",
        name: "社区详情"
    },
    onPageBack: function () {
        Views.hosListView.mode = "fp";
    },
    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var self = this;
        function fail () {
            self.render(ct, {
                data: this.data
            })
        }
        DataExchange.getOrgDetail(this.data).done(function(json){
            if (json.success) {
                self.render(ct, {
                    data: self.data,
                    json: json.data
                });
                self.viewScrollerInit($('#detailHos'));
            } else {
                fail();
            }
        }).fail(fail);
    }
});
///////////////////////////////////
Views.hosTeamView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "hosTeamView",
        name: "服务团队"
    },
    willShow: function (ct) {

        var self = this;

        DataExchange.getDoctorTeams({
            data: {agencyId: LocalMode("fp").get().newHosId, pageNum: 1, pageSize: 30}
        }).done(function (json) {
            if (json.success) {
                self.render(ct, {
                    datas: json.data,
                    team: LocalMode("fp").get().team
                });
                self.viewScrollerInit($('#teamHos'), {
                    bounceLock: true
                });
            }
        });
    }
});

Callback.ensureHosTeam = function (btnId) {
    var _btn = $('#' + btnId),
        team = _btn.attr('data-rel'),
        teamName = $.trim(_btn.prev().text()),
        FP = LocalMode("fp"),
        fp = FP.get();
    if (fp.team != team) {
        FP.update({
            doctorId: "",
            docName: "",
            team: team,
            teamName: teamName
        });
    }
    StageManager.popView();
};

Views.hosTeamDoctorView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "hosTeamDoctorView",
        name: "家庭医生/团队/医生"
    },
    willShow: function (ct) {
        var fp = LocalMode("fp").get(),
            self = this;
        function fail () {
            self.render(ct, {
                fp: fp,
                datas: [],
	            DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	            t: new Date().getTime()
            });
        }
        DataExchange.getTeamDoctor({
            teamId: fp.team
        }).done(function(json){
            if (json.success) {
                self.render(ct, {
                    fp: fp,
                    datas: json.data,
	                DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	                t: new Date().getTime()
                });
                self.viewScrollerInit($('#hosTeamDoctor'));
            } else {
                fail();
            }

        }).fail(fail);
    }
});

Callback.selectApplyDoctor = function (btnId) {
    var _btn = $('#' + btnId),
        docId = _btn.attr('data-id'),
        docName = $.trim(_btn.find('.dct-name').text());
    Views.detailHosDoctorView.init({
        ajax: {
            doctorId: docId
        },
        docLevel: $.trim(_btn.find('.dct-level').text()),
        docName: docName
    });
};
//////////////////////////////
Views.ensureApplyInfoView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "ensureApplyInfoView",
        name: "申请家庭医生"
    },
    willShow: function (ct) {
        this.render(ct, {
	        data: LocalMode("fp").get(),
	        DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	        t: new Date().getTime()
        });
        this.viewScrollerInit($('#ensureInfo'));
        Util.mobiscrollSelect('#monthsSelect', {
            onSelect: function (value, inst) {
                var month = $('#month');
                month.attr('data-rel', inst.temp[0]);
                month.text(value);
            }
        });
        var now = new Date();
        Util.mobiscrollDate('#signDate', {
            onSelect: function (value) {
                var signDate = $('#signDate');
                signDate.attr('data-rel', value);
                signDate.text(value);
            },
            minDate: new Date(),
            maxDate: new Date(now.setMonth(now.getMonth() + 1 ))

        });
    },
    willHide: function () {
        $('#monthsSelect').hide().mobiscroll('destroy');
        $('#signDate').hide().mobiscroll('destroy');
    }
});

Callback.showSignDateScroll = function (btnId) {
    $('#signDate').mobiscroll('show');
};
Callback.submitApplyInfo = function (btnId) {
    var FP = LocalMode("fp"),
        fp = FP.get(),
        message = $.trim($('#message').val()),
        month = $('#month').attr('data-rel'),
        signDate = $.trim($('#signDate').text());
    if (message.length > 100) {
        Widget.popupToast("字数超过100");
        return;
    }
    if (!signDate) {
        Widget.popupToast("请选择签约时间");
        return;
    }
    if (!month) {
        Widget.popupToast("请选择签约期限");
        return;
    }
    DataExchange.applyFamilyPhysician({
        "hospitalId": fp.newHosId,
        "name": fp.name,
        "cardNo": fp.cardNo,
        "idNo": fp.idNo,
        "doctorId": fp.doctorId,
        "message": message,
        "doctName": fp.docName,
        "month": month,
        "startDate": signDate
    }).done(function (json) {
       if (json.success) {
           FP.remove();
           StageManager.pushView(Views.familyPhysicianView);
       }
    });
};

Views.detailHosDoctorView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'detailHosDoctorView',
        name: '医生简介'
    },
    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var FP = LocalMode("fp"),
            fp = FP.get(),
            self = this;
        function fail() {
            self.render(ct, {
                data: self.data,
                fp: fp,
                info: {},
	            DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	            t: new Date().getTime()
            });
        }
        DataExchange.getFamilyPhysician(this.data.ajax).done(function (json) {
            if (json.success) {
                self.render(ct, {
                    info: json.data,
                    data: self.data,
                    fp: fp,
	                DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	                t: new Date().getTime()
                });
            } else {
                fail();
            }
        }).fail(fail);
    }
});

Callback.ensureDoctor = function (btnId) {
    var _btn = $('#' + btnId),
        docId = _btn.attr('data-id'),
        FP = LocalMode("fp"),
        fp = FP.get(),
        $page = $('#detailHosDoctor');
    FP.update({
        doctorId: docId,
        docName: $.trim($page.find('.doc-name').text()),
        docLevel: $.trim($page.find('.doc-pos').text())
    });
    StageManager.pushView(Views.applyFamilyPhysicianView);
};

Views.applyingFPHomeView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "applyingFPHomeView",
        name: "家庭医生申请中"
    },
    data: null,
    willShow: function (ct) {
        var self = this;
        this.render(ct);
        DataExchange.applying({
            hospitalId: COMPANYID,
            accountId: UserProfile.id
        }).done(function (json) {
            if (json.success) {
                var data = json.data,
                    first = data[0];
                self.data = data;

                first.updateTime = DateUtil.formatYY_MM_DD(new Date(first.updateTime));
                $('#content').html(
                    Views.tmpl.applyingHomeSubView({
                        data: first,
	                    DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	                    t: new Date().getTime()
                    })
                );
                $('#swipe').html(
                    Views.tmpl.swipeCircleView({
                        len: data.length
                    })
                );
                self.swipeCircle();
            }
        });
    },
    swipeCircle: function () {
        this.viewScrollerInit($('#applyingHome'), {
            onScrollEnd: function () {
                var dirX = this.dirX,
                    grn = $('.icon-circle.grn'),
                    index = grn.attr('data-rel'),
                    className = 'grn',
                    $content = $('#content'),
                    next, data;
                if (dirX) {
                    if (dirX === 1) {
                        next = grn.next();
                    } else if (dirX === -1 ){
                        next = grn.prev();
                        index = index - 2;
                    }
                    if (next.length) {
                        grn.removeClass(className);
                        next.addClass(className);
                        data = Views.applyingFPHomeView.data[index];
                        data.updateTime = DateUtil.formatYY_MM_DD(new Date(data.updateTime));
                        $content.html(
                            Views.tmpl.applyingHomeSubView({
                                data: data,
	                            DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	                            t: new Date().getTime()
                            })
                        );
                    }
                }
                Views.applyingFPHomeView._viewScroller.refresh();
            }
        });
    }
});

Views.myFamilyPhysicianView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "myFamilyPhysicianView",
        name: "我的家庭医生"
    },
    willShow: function (ct) {
        var self = this;
        DataExchange.myFP({
            hospitalId: COMPANYID,
            accountId: UserProfile.id
        }).done(function (json) {
            self.render(ct, {
                data: json.data,
                JSON: JSON,
	            DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	            t: new Date().getTime()
            });
            self.viewScrollerInit($('#myHome'));
        }).fail(function(){
            self.render(ct, {
                data: [],
                JSON: JSON,
	            DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	            t: new Date().getTime()
            });
            self.viewScrollerInit($('#myHome'));
        });
    }
});

Callback.cancelSignDoc = function (btnId) {
    Views.cancelSignDocView.init($('#' + btnId).attr('data-rel'));
};

/***
 * showSignDocRecord
 * 查看服务信息
 * 接口未完善
 * ****/
Callback.showSignDocRecord = function (btnId) {
    var _btn = $('#' + btnId),
        hospitalId = _btn.attr('data-hospitalId'),
        doctorId = _btn.attr('data-doctorId');
    Views.showSignDocRecordView.init({
        hospitalId: hospitalId,
        doctorId: doctorId
    });
};


Callback.showFDApplyRecord = function (btnId) {
    StageManager.pushView(Views.showFDApplyRecordView);
};
//////////////////////
Views.cancelSignDocView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "cancelSignDocView",
        name: "取消签约"
    },
    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct,
	        {
		        data: JSON.parse(this.data),
		        DOCTOR_ICON_URL: DOCTOR_ICON_URL,
		        t: new Date().getTime()
	        }

        );
        this.viewScrollerInit($('#cancelSignDoc'));
    }
});
Callback.ensureCancelDoc = function (btnId) {
    var _btn = $('#' + btnId),
        signingId = _btn.attr('data-rel'),
        message = $('#message').val(),
        options = {
            "hospitalId": COMPANYID,
            "signId": signingId,
            "message": message
        };
    DataExchange.ensureCancelDoc(options).done(function (json) {
        if (json.success) {
            Widget.popupSuccess("发送取消签约申请成功");
            StageManager.popView();
        }
    });
};
//////////////////////
Views.showSignDocRecordView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "showSignDocRecordView",
        name: "查看服务记录"
    },
    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct);
        DataExchange.findFDRecord($.extend({}, this.data, {
            "accountId": UserProfile.id,
            "pageNum": 1,
            "pageSize": 5
        })).done(function (json) {
            if (json.success) {

            }
        });
    }
});
//////////////////////
Views.showFDMessageView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "showFDMessageView",
        name: "查看我的医生消息"
    },
    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct);
        this.ajax();
        this.viewScrollerInit($('#fdMessage'));
    },
    willHide: function () {
        this.viewScrollerDestroy();
    },
    ajax: function (month) {
        var self = this;
        DataExchange.showFDMessage({
            "familyId": UserProfile.familyId,
            hospitalId: COMPANYID,
            "yearMonth": month ? month : ""
        }).done(function (json) {
            if (json.success) {
                var data = json.data,
                    baseItem = data.baseItem;
                self.month = data.monthName;
                if (baseItem.length) {
                    $('#messageContent').append(
                        Views.tmpl.showMessageSubView({
                            data: baseItem,
                            Date: Date
                        })
                    );
                }

            }
        });
    }
});
Callback.loadMoreFDMessage = function (btnId) {
    Views.showFDMessageView.ajax(Views.showFDMessageView.month);
};
//////////////////////
Views.showFDApplyRecordView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "showFDApplyRecordView",
        name: "查看我的申请医生记录"
    },
    willShow: function (ct) {
        function render (data) {
            Views.showFDApplyRecordView.render(ct, {
                data: data,
                Date: Date,
                formatWithPatternDate: DateUtil.formatWithPatternDate
            });
        }
        DataExchange.findFDApplyRecord({
            "hospitalId": COMPANYID,
            "accountId": UserProfile.id,
            "pageNum": 1,
            "pageSize": 10
        }).done(function (json) {
            if (json.success) {
                render(json.data);
                Views.showFDApplyRecordView.viewScrollerInit($('#applyRecord'));
            } else {
                render({});
            };
        }).fail(function () {
            render({});
        });
    }
});

Callback.showFDSignDetail = function (btnId) {
    var _btn = $('#' + btnId)
        ;
};
//////////////////////
Callback.showEvaluationFDView = function (btnId) {
    StageManager.pushView(Views.evaluationFDView);
};
Views.evaluationFDView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "evaluationFDView",
        name: "家庭医生评价"
    },
    didShow: function (ct) {
        this.viewScrollerInit($('#applyRecord'));
    }
});

Callback.showSignDetail = function (btnId) {
    var _btn = $('#' + btnId),
        signId = _btn.attr('data-rel');
    Views.getSignDetailView.init({
        id: signId
    });
};

Views.getSignDetailView = $.extend({}, Views.PanelView, {
   options: {
       tmpl: "getSignDetailView",
       name: "查看申请记录详细"
   },
    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    didShow: function () {
        DataExchange.getSignDetail(this.data).done(function (json) {
            if (json.success) {
                var data = json.data;
                data.updateTime = DateUtil.formatYY_MM_DD(new Date(data.updateTime));
                $('#signContent').html(
                    Views.tmpl.applyingHomeSubView({
                        data: data,
                        JSON: JSON,
	                    DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	                    t: new Date().getTime()
                    })
                );
                Views.getSignDetailView.viewScrollerInit($('#signFDDetail'));
            }
        });
    }
});

/////////////////
Callback.consultFDView = function (btnId) {
    var _btn = $('#' + btnId),
        args = {
            patientId: _btn.attr("data-patientId"),
            docid: _btn.attr("data-docid")
        };
    Views.consultFDView.initArgs(args);
};
Callback.toFD = function (btnId) {

};
Views.consultFDView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'consultFDView',
        name: "家庭医生-咨询"
    },
    initArgs: function (args) {
        this.data = args;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var self = this;

        DataExchange.getConsultSorts({}).done(function (json) {
            if (json.success) {
                self.render(ct, {
                    member: UserProfile.findMember(self.data.patientId),
                    iconUrl: MEMBER_ICON_URL,
                    t: Util.rtime(),
                    sorts: json.data,
                    data: self.data
                });
	            self.viewScrollerInit($('.ui-scroll'));
            }
        }).fail(function () {
                self.render(ct, {
                    member: UserProfile.findMember(self.data.patientId),
                    iconUrl: MEMBER_ICON_URL,
                    t: Util.rtime(),
                    sorts: [],
                    data: {}
                });
		        self.viewScrollerInit($('.ui-scroll'));
        });
    },

    willHide: function () {
        $('#birth').mobiscroll('destroy');
	    this.viewScrollerDestroy();
    }
});

Callback.consultFDSubmit = function (btnId) {
    var $input = $("#quiz"), input = $input.val().replace(Validator.emoji, ""), hasImg = false,
        _btn = $('#' + btnId);
    if (!Util.trim(input)) {
        Widget.popupToast('请输入问题内容:-(');
        return false;
    }
    if (input.length < 10 || input.length > 100) {
        Widget.popupToast('问题描述请控制在10-100字之间，谢谢。:-(');
        return false;
    }
    hasImg = !!$(".display-image-wrapper img").length;
    DataExchange.consultQuizSubmit({
        "data": {
            memberId: _btn.attr("data-patientId"),
            doctorId: $('.answerFD.medical-status').hasClass('yes') ? _btn.attr("data-docid") : "",
            aqContent: input,
            agencyId: COMPANYID,
            enclosureType: hasImg ? "IMAGE" : "NONE",
            sortId: $("#quizRole").attr("data-id"),
            privacyStrategy: $('.share.medical-status').hasClass('yes')
        }
    }).done(function (json) {
            if (json.success) {
                if (hasImg) {
                    Widget.popupLoading("正在上传图片中...");
                    FSManager.upload({
                        file: $(".display-image-wrapper img").attr("src"),
                        url: WEB_URL + "/resident/healthConsult/add/images/" + json.data,
                        onSuccess: 'consultPicUploaded',
                        onError: 'consultPicUploadFailed'
                    });
                } else {
                    StageManager.popView();

                }
            }
        });
}