// 健康咨询
Views.consultView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'consultView',
        name: '首页-健康咨询'
    },
    init: function () {
        var index = Util.data("consult.tab.index");
        this.pageNum = 1;
        this.tabIdx = index ? index : 1;
        $("#a_pullUp").remove();
    },
    didShow: function (ct) {
        this.init();
        this.pullRefresher = Util.makeScrollableWithPullRefresh($('.ui-pull-to-refresh'), {onPullDownRefresh: this.onPullDownRefresh});
        this.onPullDownRefresh();
    },
    onPullDownRefresh: function () {
        var consultView = Views.consultView;
        consultView.pageNum = 1;
        if (consultView.isRefresh) {
            consultView.isRefresh = false;
            return;
        } else {
            consultView.isRefresh = true;
        }
        consultView.loadByTab();
    },
    didHide: function () {
        if (this.pullRefresher) {
            this.pullRefresher.destroy();
            this.pullRefresher = null;
        }
        delete  this.isRefresh;
    },
    loadByTab: function () {
        $(".horizon-tabs .tab").removeClass("highlight").eq(this.tabIdx - 1).addClass("highlight");
        var pageNum = this.pageNum, ajax, option = {
            "data": { pageNum: pageNum, pageSize: 5 }
        }, self = this, isLatest = this.tabIdx === 1;
        if (isLatest) {//最新问题
            ajax = "getConsultLatestQuestions";
        } else {//我的问题
            ajax = "getConsultMyQuestions";
            option.data.familyId = UserProfile.getFamilyId();
        }
        function ajaxFail() {
            if (self.pageNum > 1) {
                self.pageNum--;
            }
        };
        DataExchange[ajax](option).done(function (json) {
            var data = json.data;
            if (json.success && data.length) {
                self.renderSubView(data, pageNum, isLatest);
            } else {
                ajaxFail();
            }
        }).fail(ajaxFail);
    },
    renderSubView: function (data, pageNum, isLatest) {
        var i = 0, len = data.length, dataPar, item, $consult, html, tmpl, iconURL;
        if (isLatest) {
            dataPar = "answer";
            tmpl = "consultSubLatestView";
            iconURL = DOCTOR_ICON_URL;
        } else {
            dataPar = "aqContent";
            tmpl = "consultSubMyQuestionsView";
            iconURL = MEMBER_ICON_URL;
        }
        for (; i < len; i++) {
            item = data[i][dataPar];
            if (item && item.length > 32) {
                item = item.substring(0, 30) + "...";
            }
        }
        if (data && len) {
            $consult = $(".consult-contents");
            html = Views.tmpl[tmpl]({
                iconURL: iconURL,
                questions: data,
                t: Util.rtime()
            });
            if (pageNum === 1) {
                $consult.html(html);
                if (!$("#a_pullUp").length) {
                    $consult.after('<a id="a_pullUp" class="ui-btn a-pullup" data-action="loadMoreConsultQuestions">点击加载更多</a>');
                }
            } else {
                $consult.append(html);
            }
        }
    }
});
Callback.loadMoreConsultQuestions = function () {
    Views.consultView.pageNum = Views.consultView.pageNum + 1;
    Views.consultView.loadByTab();
};

Callback.consultToggle = function (btnId) {
    var $ele = $("#" + btnId), index = Number($ele.attr("data-rel")), consultView;
    if (Number(index) === 2 && !Util.loginSuggest()) {//我的问题
        return;
    }
    if ($ele.hasClass("highlight")) {
        return;
    }
    consultView = Views.consultView;
    consultView.tabIdx = index;
    Util.data("consult.tab.index", index);
    consultView.pageNum = 1;
    $(".consult-contents").empty();
    consultView.loadByTab();
};
Callback.showQuestionConversation = function (btnId) {
    var $ele = $("#" + btnId), topId = $ele.attr("data-rel"), status = $ele.attr("data-rel-status"), comeFrom = $ele.attr("data-come-from");
    Views.questionConversationView.show(topId, status, comeFrom);
};
//健康咨询问答
Views.questionConversationView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'questionConversationView',
        name: '首页-健康咨询-问答'
    },
    show: function (topId, status, comeFrom) {
        this.topId = topId;
        this.status = status;
        this.comeFrom = comeFrom;
        Util.log(comeFrom);
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct, {status: this.status, comeFrom: this.comeFrom});
        this._viewScroller = Util.makeScrollableWithPullRefresh($('.ui-scroll'), {
            onPullDownRefresh: this.onPullDownRefresh,
            bounceLock: true
        });
        this.onPullDownRefresh();

    },
    loadConversation: function () {
        var self = this;
        DataExchange.getConsultConversation({
            "data": {
                topId: this.topId,
                familyId: UserProfile.getFamilyId()
            }
        }).done(function (json) {
            if (json.success) {
                var data = json.data, dialogList = data.dialogList, dialogList0 = dialogList[0];
                self.memberId = dialogList0.peopleId;
                self.memberName = dialogList0.name;
                self.sex = dialogList0.sex;
                self.renderConversation(dialogList, false, data.collected);
            }
        });
    },
    renderConversation: function (data, isAppend, isCollect) {
        var html = Views.tmpl.consultConversationSubView({
            tabIdx: Views.consultView.tabIdx,
            iconURL: MEMBER_ICON_URL,
            picURL: CONSULT_PIC_URL,
            conversations: data,
            status: this.status,
            comeFrom: this.comeFrom,
            isAppend: isAppend,
            t: Util.rtime()
        });
        if (isAppend) {
            $('.conversation-content').append(html);
            this._viewScroller.scrollToElement("#dashSplit", 500);
            this.onPullDownRefresh();
        } else {
            $("#scrollRefresh").html(html);
            if (isCollect) {
                $('#collect div').removeClass('not-collect').addClass('collected').next().text('已收藏');
            }
        }
    },

    didHide: function () {
        var page = Views.questionConversationView;
        if (page._viewScroller) {
            page._viewScroller.destroy();
            page._viewScroller = null;
        }
        delete  page.isRefresh;
    },
    onPullDownRefresh: function () {
        if (Views.questionConversationView.isRefresh) {
            Views.questionConversationView.isRefresh = false;
            return;
        } else {
            Views.questionConversationView.isRefresh = true;
        }
        Views.questionConversationView.loadConversation();
    }
});

Callback.consultConversationTextSubmit = function () {
    var $input = $("#comment"), input = $input.val().replace(Validator.emoji, ""), questionConversationView;
    if (!Validator.validator({ questionContent: input})) {
        return;
    }
    questionConversationView = Views.questionConversationView;
    DataExchange.consultConversationTextSubmit({
        "data": {
            memberId: questionConversationView.memberId,
            aqContent: input,
            topId: questionConversationView.topId,
            enclosureType: "NONE"
        }
    }).done(function (json) {
            if (json.success) {
                var conversation = [
                    {
                        id: json.data,
                        peopleId: questionConversationView.memberId,
                        name: questionConversationView.memberName,
                        sex: questionConversationView.sex,
                        aqType: 0,
                        enclosureType: 0,
                        content: input,
                        consultTimeStr: DateUtil.formatWithPatternDate('yyyy-mm-dd HH:ii:ss', new Date())
                    }
                ];
                questionConversationView.renderConversation(conversation, true);
                $input.val('');
            }
        });
    return false;
}
Callback.endProblem = function (btnId) {
    var $ele = $("#" + btnId);
    if ($ele.hasClass("finished")) {
        return;
    }
    DataExchange.endConsultQuiz({
        "topId": Views.questionConversationView.topId
    }).done(function (json) {
            if (json.success) {
                $ele.removeClass("not-finish").addClass("finished").next().text("已结束");
                $("#consultConversationView").removeClass("ui-has-footer").find('.bottom').remove();
            }
        });
}
Callback.collectProblemToggle = function (btnId) {
    var $ele = $("#" + btnId), questionConversationView = Views.questionConversationView, options = {
        data: {
            "topId": questionConversationView.topId
        }
    }, isCollected = false, ajax;
    if ($ele.hasClass("collected")) {
        ajax = "removeCollectConsultQuiz";
        options.data.accountId = UserProfile.id;
        isCollected = true;

    } else {
        ajax = "addCollectConsultQuiz";
        options.data.memberId = Util.data('current.member').memberId;
    }
    function ajaxDone() {
        if (isCollected) {
            $ele.removeClass("collected").addClass("not-collect").next().text("收藏");
        } else {
            $ele.addClass("collected").removeClass("not-collect").next().text("已收藏");
        }
    };
    DataExchange[ajax](options).done(ajaxDone);
}
Callback.enlargePic = function (btnId) {
    var $mask = $("#image_mask"), $imageScroll = $mask.find(".image-scroll"), $fakeWrapper = $imageScroll.find(".fake-wrapper"), $img = $fakeWrapper.find("img"), currentSrc = $img.attr("src"), displayScr = $("#" + btnId).attr("src");
    if (currentSrc !== displayScr) {
        $img.attr("src", displayScr);
        $fakeWrapper.css({width: '100%'});
        $img.css({width: '100%'});
    }
    $mask.css("display", "block");
    Views.questionConversationView.imageScroll = Util.makeScrollable($imageScroll);
}
Callback.closePic = function (btnId) {
    var $ele = $("#image_mask");
    $ele.css("display", "none");
    Views.questionConversationView.imageScroll.destroy();
}
Callback.imageControl = function (btnId) {
    var $btn = $("#" + btnId), type = $btn.attr("data-rel"), $fakeWrapper = $("#image_mask").find(".fake-wrapper"), $img = $fakeWrapper.find("img");
    var ratio = type == "plus" ? 1.1 : 0.9, width = $img.width() * ratio + "px";
    $img.css({"width": width});
    $fakeWrapper.css({"width": width});
}
//健康咨询问答
Views.consultQuizView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'consultQuizView',
        name: '首页-健康咨询-我要提问'
    },
    show: function (mode) {
        this.mode = mode;
        if (mode) {
            this.member = LocalMode(mode).get();
        } else {
            this.member = Util.data("current.member");
        }
        StageManager.pushView(this);
    },
    member: null,
    willShow: function (ct) {
        var self = this;
        $.when(
                DataExchange.getConsultSorts({}),
                DataExchange.getFDById({
                    "hospitalId": COMPANYID,
                    patientId: this.member.id
                })
            ).done(function (json1, json2) {
                console.log(arguments);
                if (json1[0].success && json2[0].success) {
                    var i = 0, showData = {},  sort = json1[0].data, temp;
                    if (self.mode) {
                        if (self.mode === "baby") {
                            temp = "幼儿保健";
                        } else if (self.mode === "maternal") {
                            temp = "孕妇保健";
                        }
                        for (; i < sort.length; i++) {
                            if (sort[i].name === temp)
                                break;
                        }
                        showData = {
                            name: sort[i].name,
                            id: sort[i].id
                        };
                    }
                    self.render(ct, {
                        sorts: sort,
                        member: self.member,
                        iconUrl: MEMBER_ICON_URL,
                        t: Util.rtime(),
                        showData: showData,
                        fd: json2[0].data
                    });
                    Util.birthDaySelectInit();
	                self.viewScrollerInit($('.ui-scroll'));
                }
            }).fail(function () {
                self.render(ct, {
                    sorts: [],
                    member: self.member,
                    iconUrl: MEMBER_ICON_URL,
                    t: Util.rtime(),
                    showData: {},
                    fd: []
                });
		        self.viewScrollerInit($('.ui-scroll'));
            });

    },

    willHide: function () {
        $('#birth').mobiscroll('destroy');
	    this.viewScrollerDestroy();
    }
});
Callback.showConsultQuizView = function (btnId) {
    if (!Util.loginSuggest()) {
        return;
    }
    var mode = $('#' + btnId).attr('data-rel');
    Views.consultQuizView.show(mode);

};
Callback.quizRoleToggle = function (btnId) {
    var $ele = $("#" + btnId), input = $("#quizRole");
    if ($ele.attr('data-rel') !== "open") {
        input.attr("data-id", $ele.attr("data-id")).text($ele.text());
    }
    $(".submit-form .account-container").toggle();
}
Callback.removeConsultPic = function (btnId) {
    $("#" + btnId).parent().remove();
}
Callback.consultQuizSubmit = function (btnId) {
    var $input = $("#quiz"), input = $input.val().replace(Validator.emoji, ""), _btn = $("#" + btnId), hasImg = false;
    if (!Util.trim(input)) {
        Widget.popupToast('请输入问题内容:-(');
        return false;
    }
    if (input.length < 10 || input.length > 100) {
        Widget.popupToast('问题描述请控制在10-100字之间，谢谢。:-(');
        return false;
    }
    hasImg = !!$(".display-image-wrapper img").length;
    DataExchange.consultQuizSubmit({
        "data": {
            memberId: Views.consultQuizView.member.memberId,
            aqContent: input,
            agencyId: COMPANYID,
            doctorId: $('.answerFD.medical-status').hasClass('yes') ? _btn.attr("data-docid") : "",
            enclosureType: hasImg ? "IMAGE" : "NONE",
            sortId: $("#quizRole").attr("data-id"),
            privacyStrategy: $('.share.medical-status').hasClass('yes')
        }
    }).done(function (json) {
            if (json.success) {
                if (hasImg) {
                    Widget.popupLoading("正在上传图片中...");
                    FSManager.upload({
                        file: $(".display-image-wrapper img").attr("src"),
                        url: WEB_URL + "/resident/healthConsult/add/images/" + json.data,
                        onSuccess: 'consultPicUploaded',
                        onError: 'consultPicUploadFailed'
                    });
                } else {
                    StageManager.popView();

                }
            }
        });
}
Callback.consultPicUploaded = function () {
    Widget.popupLoadingClose();
    StageManager.popView();
}
Callback.consultPicUploadFailed = function (code, source, target, http_status) {
    Widget.popupLoadingClose();
    Widget.popupToast('上传图片失败，请重试:-(');
}
Callback.myQuestionShare = function (btnId) {
    var _btn = $('#' + btnId);
    _btn.find('span').toggleClass('yes');
};
/************************** 发送图片开始 *****************************/
Callback.pickImage = function () {
    if ($(".display-image-wrapper img").length) {
        Widget.popupToast('最多只能提交一张:-(');
        return;
    }
    var pictureSource = navigator.camera.PictureSourceType,   // picture source
        destinationType = navigator.camera.DestinationType; // sets the format of returned value
    function getPhoto(source) {
        // Retrieve image file location from specified source
        navigator.camera.getPicture(onPhotoURISuccess, onFail, {
            quality: 35,
            destinationType: destinationType.FILE_URI,
            sourceType: source
        });
    };
// Called if something bad happens.
//
    function onFail(message) {
//	Widget.popupToast('Failed because: ' + message);
        Callback.refreshWebView("end");
    };
    function onPhotoURISuccess(imageURI) {
        // Uncomment to view the image file URI
        $(".display-image-wrapper").append('<div><div class="remove-flag ui-btn" data-action="removeConsultPic"></div><img src="' + imageURI + '"/></div>');
        Callback.refreshWebView("end");
    };
    Callback.refreshWebView("start");
    getPhoto(pictureSource.SAVEDPHOTOALBUM);
}
/************************** 发送图片结束 *****************************/