Views.healthToolView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'healthToolView',
        name: '健康工具'
    },
    didShow: function () {
        StageManager.fixPageBack(Views.mainView);
    }
});

Views.bmiCalculatorView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'bmiCalculatorView',
        name: 'BMI计算器'
    }
});
Views.bmiResultView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'bmiResultView',
        name: 'BMI计算器'
    },
    willShow: function (ct) {
        this.render(ct, this.data);
        var start = -5;//起始点-5px
        var measure = 300 / 30;//每数值1代表的像素是10px
        var index = start + measure * (this.data.bmiResult - 15);
        $('#bmi-result-cursor').css({'margin-left': index + 'px'});
        this.viewScrollerInit($('#bmiResult'));
    },
    showWithData: function (json) {
        Widget.popupLoading('请稍候...');
        setTimeout(function () {
            Widget.popupLoadingClose();
        }, 500);
        this.data = json;
        StageManager.pushView(Views.bmiResultView);
    }
});
Callback.calculateBmi = function () {
    var height = $('#bmi-height').val();
    var weight = $('#bmi-weight').val();
    if (isNaN(height) || isNaN(weight)) {
        Widget.popupToast('身高和体重必须都为数字');
        return false;
    }
    if (!$.trim(height) || !$.trim(weight)) {
        Widget.popupToast('身高和体重都不能为空');
        return false;
    }
    if (parseInt(height) <= 0 || parseInt(weight) <= 0) {
        Widget.popupToast('身高和体重都不能小于等于0');
        return false;
    }
    var result = (weight * 10000 / (height * height)).toFixed(2);
    if (result < 15 || result > 45) {
        Widget.popupToast('BMI计算异常，请输入正确的身高和体重值');
        return false;
    }
    var sv = [
        [15, 18.5],
        [18.5, 24],
        [24, 28],
        [28, 36],
        [36, 45]
    ];
    var sn = ['偏瘦', '正常', '偏胖', '肥胖', '重度肥胖'];
    var tips = ['您的体重状况为：偏瘦。根据本计算，您目前的体重低于正常范围，请适当调整饮食结构，增加富含营养的食物摄入（如蔬菜水果、鱼类等），加强锻炼。必要时请就医，检查有无患慢性全身性消耗性疾病（如贫血、慢性萎缩性胃炎、恶性肿瘤、糖尿病、结核病等）可能。', '您的体重状况为：正常。根据本计算，您目前的体重在健康范围内，患心血管疾病、糖尿病、高血压、高血脂等疾病风险较低，请继续保持。', '您的体重状况为：偏胖。根据本计算，您目前的体重稍高于正常范围，请适当运动，调整饮食结构，补充富含膳食纤维的食物（如蔬菜水果、粗粮杂粮、豆类及菌藻类食物），减少不必要的高热量食物（如蛋糕、饮料、酸奶等）摄入。同时，您患心血管疾病、糖尿病、高血压、高血脂等疾病的风险较高，请定期检查。', '您的体重状况为：肥胖。根据本计算，您目前属于肥胖，请定日定量运动，调整饮食结构，补充富含膳食纤维的食物（如蔬菜水果、粗粮杂粮、豆类及菌藻类食物），减少不必要的高热量食物（如蛋糕、饮料、酸奶等）摄入。必要时及时就医，检查有无心血管疾病、高血压、高胆固醇等疾病。', '您的体重状况为：重度肥胖。根据本计算，您目前属于重度肥胖，可能引起高血压、糖尿病、痛风等疾病，并发其他疾病的风险也高于非肥胖者。建议先去医院进行一次彻底的体检，然后寻求专业的减肥机构来减肥。健康无价，加油哦！'];
    var index = 0;
    $.each(sv, function (i, val) {
        if (result >= val[0] && result < val[1]) {
            index = i;
            return;
        }
    });
    var json = {bmiResult: result, bmiWeight: weight, bmiHeight: height, sort: sn[index], tip: tips[index]};
    Views.bmiResultView.showWithData(json);
};
Views.hepatitisBSelfTestView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'hepatitisBSelfTestView',
        name: '乙肝自测'
    },
    didShow: function (ct) {
        this.bindSelectEvent();
        this.viewScrollerInit($('.ui-scroll'));//scroll一定要定义能scroll的块的高度
    },
    bindSelectEvent: function () {
        $('.ygzc-da').children('.ui-btn').click(function () {
            var btnId = $(this).attr('id');
            var cascadeBtnId = (btnId % 2 == 1) ? parseInt(btnId) + 1 : parseInt(btnId) - 1;
            if ($(this).hasClass('ygzc-da-unchecked')) {
                $(this).removeClass('ygzc-da-unchecked');
                $(this).addClass('ygzc-da-checked');
                $('#' + cascadeBtnId).removeClass('ygzc-da-checked');
                $('#' + cascadeBtnId).addClass('ygzc-da-unchecked');
            }
        });
    }
});
Callback.submitYgzc = function () {
    var hBsAgV = (parseInt($('#hBsAg .ygzc-da-checked').attr('id')) % 2 == 1) ? 1 : 2;
    var antiHBsV = (parseInt($('#antiHBs .ygzc-da-checked').attr('id')) % 2 == 1) ? 1 : 2;
    var hBeAgV = (parseInt($('#hBeAg .ygzc-da-checked').attr('id')) % 2 == 1) ? 1 : 2;
    var antiHBeV = (parseInt($('#antiHBe .ygzc-da-checked').attr('id')) % 2 == 1) ? 1 : 2;
    var antiHBcV = (parseInt($('#antiHBc .ygzc-da-checked').attr('id')) % 2 == 1) ? 1 : 2;
    var options = {
        data: {"hBsAg": hBsAgV, "antiHBs": antiHBsV, "hBeAg": hBeAgV, "antiHBe": antiHBeV, "antiHBc": antiHBcV}
    };

    function ajaxDoneHandle(json) {
        if (json.success) {
            Views.hepatitisBSelfTestResultView.showWithData(json);
        }
    };
    DataExchange.getYgzcResult(options).done(ajaxDoneHandle);
};
Views.hepatitisBSelfTestResultView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'hepatitisBSelfTestResultView',
        name: '乙肝自测'
    },
    willShow: function (ct) {
        this.render(ct, {ygzcResult: this.data});
    },
    showWithData: function (json) {
        this.data = json;
        StageManager.pushView(Views.hepatitisBSelfTestResultView);
    }
});
Views.babyBloodTypeTestView = $.extend({}, Views.PanelView, {
    bTypes: ['A', 'B', 'O', 'AB'],
    hiddenValues: ['1', '2', '3', '4'],
    options: {
        tmpl: 'babyBloodTypeTestView',
        name: '宝宝血型'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.baby-blood'));
    },
    bindEvent: function () {
        var self = this;
        $('.blood-type-div').click(function () {
            if (!$(this).find('input').attr('value')) {
                $(this).find('input').attr('value', self.bTypes[0]);
                $(this).find('input').attr('hidden-value', self.hiddenValues[0]);
            } else {
                var index = self.bTypes.indexOf($(this).find('input').attr('value'));
                if (index == 3) {
                    index = 0;
                } else {
                    index++;
                }
                $(this).find('input').attr('value', self.bTypes[index]);
                $(this).find('input').attr('hidden-value', self.hiddenValues[index]);
            }
        });
    }
});
Callback.changeBlood = function (btnId) {
    var self = Views.babyBloodTypeTestView, $btn = $('#' + btnId), input = $btn.find('input'), index = 0;
    if (input.attr('value')) {
        index = self.bTypes.indexOf(input.attr('value'));
        if (index == 3) {
            index = 0;
        } else {
            index++;
        }
    }
    input.attr('value', self.bTypes[index]);
    input.attr('hidden-value', self.hiddenValues[index]);
};
Callback.predictBabyBloodType = function () {
    var fatherBlood = $('#dad-blood-show').attr('hidden-value'), motherBlood = $('#mum-blood-show').attr('hidden-value');
    if (!fatherBlood || !motherBlood) {
        Widget.popupToast('父亲和母亲的血型都不能为空');
        return false;
    }

    function ajaxDoneHandle(json) {
        if (json.success === true) {
            $('#baby-maybe-type').text(json.data.possibleBlood);
            $('#baby-notbe-type').text(json.data.impossibleBlood);
            $('#baby-blood-type-block').css('display', 'block');
        }
    };

    var options = {
        data: {
            "fatherBlood": fatherBlood,
            "motherBlood": motherBlood
        }
    };
    DataExchange.getPredictedBabyBloodType(options).done(ajaxDoneHandle);

    $('.grn-btn').text('重新测试');
};
Views.tcmPhysicalTestView = $.extend({}, Views.PanelView, {
    testAnswer: [],
    options: {
        tmpl: 'tcmPhysicalTestView',
        name: '中医辨体'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('#scroller'));
        StageManager.fixPageBack(Views.healthToolView);
    }
});
Views.tcmPinghezhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A*', '03': 'A*', '04': 'A*', '05': 'A*', '06': 'A', '07': 'A*', '08': 'A*'},
    zhiSort: 'PINGHEZHI',
    options: {
        tmpl: 'tcmPinghezhiTestView',
        name: '平和质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn color-btn grn-btn step-next-sort-tcm-test" data-action="pingheToQiyu">进入气郁质测试</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didHide: function () {
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
Callback.toggleTcmXx = function (btnId) {
    var $ele = $('#' + btnId);
    var da = $ele.find('.hidden-tm-xx').text();
    $ele.parent().parent().parent().prev('.hidden-tm-da').text(da);
    $ele.find('div.tcm-tm-da-mark').removeClass('tcm-tm-da-unchecked-mark');
    $ele.find('div.tcm-tm-da-mark').addClass('tcm-tm-da-checked-mark');
    $ele.find('div.tcm-tm-da-word').removeClass('tcm-tm-da-unchecked-word');
    $ele.find('div.tcm-tm-da-word').addClass('tcm-tm-da-checked-word');
    $.each($ele.siblings(), function (i, val) {
        $(val).find('div.tcm-tm-da-mark').removeClass('tcm-tm-da-checked-mark');
        $(val).find('div.tcm-tm-da-mark').addClass('tcm-tm-da-unchecked-mark');
        $(val).find('div.tcm-tm-da-word').removeClass('tcm-tm-da-checked-word');
        $(val).find('div.tcm-tm-da-word').addClass('tcm-tm-da-unchecked-word');
    });
};
/***平和到气郁***/
Callback.pingheToQiyu = function (btnId) {
    //遍历题目
    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmPinghezhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    //进入气郁质测试页面
    StageManager.pushView(Views.tcmQiyuzhiTestView);
};
Views.tcmQiyuzhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A', '03': 'A', '04': 'A', '05': 'A', '06': 'A', '07': 'A'},
    zhiSort: 'QIYUZHI',
    options: {
        tmpl: 'tcmQiyuzhiTestView',
        name: '气郁质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn grn-btn color-btn step-next-sort-tcm-test" data-action="qiyuToTebing">进入特禀质测试</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
/***气郁到特禀质***/
Callback.qiyuToTebing = function (btnId) {
    //遍历题目
    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmQiyuzhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    //进入气郁质测试页面
    StageManager.pushView(Views.tcmTebingzhiTestView);
};
Views.tcmTebingzhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A', '03': 'A', '04': 'A', '05': 'A', '06': 'A', '07': 'A'},
    zhiSort: 'TEBINGZHI',
    options: {
        tmpl: 'tcmTebingzhiTestView',
        name: '特禀质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn grn-btn color-btn step-next-sort-tcm-test" data-action="tebingToXueyu">进入血瘀质测试</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
Callback.tebingToXueyu = function (btnId) {
    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmTebingzhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    StageManager.pushView(Views.tcmXueyuzhiTestView);
};
Views.tcmXueyuzhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A', '03': 'A', '04': 'A', '05': 'A', '06': 'A', '07': 'A'},
    zhiSort: 'XUEYUZHI',
    options: {
        tmpl: 'tcmXueyuzhiTestView',
        name: '血瘀质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn grn-btn color-btn step-next-sort-tcm-test" data-action="xueyuToShire">进入湿热质测试</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
Callback.xueyuToShire = function (btnId) {
    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmXueyuzhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    StageManager.pushView(Views.tcmShirezhiTestView);
};
Views.tcmShirezhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A', '03': 'A', '04': 'A', '05': 'A', '06': 'A', '07': 'A'},
    zhiSort: 'SHIREZHI',
    options: {
        tmpl: 'tcmShirezhiTestView',
        name: '湿热质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn color-btn grn-btn step-next-sort-tcm-test" data-action="shireToTanshi">进入痰湿质测试</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
Callback.shireToTanshi = function (btnId) {
    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmShirezhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    StageManager.pushView(Views.tcmTanshizhiTestView);
};
Views.tcmTanshizhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A', '03': 'A', '04': 'A', '05': 'A', '06': 'A', '07': 'A', '08': 'A'},
    zhiSort: 'TANSHIZHI',
    options: {
        tmpl: 'tcmTanshizhiTestView',
        name: '痰湿质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn color-btn grn-btn step-next-sort-tcm-test" data-action="tanshiToQixu">进入气虚质测试</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
Callback.tanshiToQixu = function (btnId) {
    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmTanshizhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    StageManager.pushView(Views.tcmQixuzhiTestView);
};
Views.tcmQixuzhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A', '03': 'A', '04': 'A', '05': 'A', '06': 'A', '07': 'A', '08': 'A'},
    zhiSort: 'QIXUZHI',
    options: {
        tmpl: 'tcmQixuzhiTestView',
        name: '气虚质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn color-btn grn-btn step-next-sort-tcm-test" data-action="qixuToYinxu">进入阴虚质测试</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
Callback.qixuToYinxu = function (btnId) {
    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmQixuzhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    StageManager.pushView(Views.tcmYinxuzhiTestView);
};
Views.tcmYinxuzhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A', '03': 'A', '04': 'A', '05': 'A', '06': 'A', '07': 'A', '08': 'A'},
    zhiSort: 'YINXUZHI',
    options: {
        tmpl: 'tcmYinxuzhiTestView',
        name: '阴虚质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn color-btn grn-btn step-next-sort-tcm-test" data-action="yinxuToYangxu">进入阳虚质测试</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
Callback.yinxuToYangxu = function (btnId) {
    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmYinxuzhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    StageManager.pushView(Views.tcmYangxuzhiTestView);
};
Views.tcmYangxuzhiTestView = $.extend({}, Views.PanelView, {
    testResult: {'01': 'A', '02': 'A', '03': 'A', '04': 'A', '05': 'A', '06': 'A', '07': 'A'},
    zhiSort: 'YANGXUZHI',
    options: {
        tmpl: 'tcmYangxuzhiTestView',
        name: '阳虚质'
    },
    prepareExamData: function () {
        var self = this;
        var examData;
        $.each(tcmStaticData.tcmPhysicalExam, function (i, val) {
            if (val.sysId === self.zhiSort) {
                examData = val;
                return;
            }
        });
        var htmlStr = '';
        $.each(examData.questList, function (i, iVal) {
            htmlStr += '<div class="tcm-physical-tm-content-repeat"><div class="ui-scroller"><div class="tcm-tm-tg">';
            htmlStr += iVal.questValue + '</div><table>';
            $.each(iVal.answerList, function (j, jVal) {
                htmlStr += '<tr class="ui-btn" data-action="toggleTcmXx"><td>';
                if (self.testResult[iVal.questId] == jVal.ansId) {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-checked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-checked-word">';
                } else {
                    htmlStr += '<div class="tcm-tm-da tcm-tm-da-mark tcm-tm-da-unchecked-mark" quest-id="' + iVal.questId + '" ans-id="' + jVal.ansId + '"></div><div class="tcm-tm-da tcm-tm-da-word tcm-tm-da-unchecked-word">';
                }
                htmlStr += jVal.ansValue + '</div></td></tr>';
            });
            htmlStr += '</table></div>';
            if (i == examData.questList.length - 1) {
                htmlStr += '<div class="ui-btn color-btn grn-btn step-next-sort-tcm-test" data-action="yangxuToSubmit">已做完所有题目，点击立即提交</div>';
            }
            htmlStr += '</div>';
        });
        $('.tcm-physical-sort-wrapper').append(htmlStr);
        var liHtml = '';
        for (var j = 0; j < examData.questList.length - 1; j++) {
            liHtml += '<li></li>'
        }
        $('#tcm-tm-navi ul').append(liHtml);
    },
    didShow: function (ct) {
        this.prepareExamData();
        this.jqRiskAssessDivs = $('div.tcm-physical-tm-content-repeat');
        this.currPageX = 0;
        var self = this;
        this.viewScrollerInit($('.tcm-physical-sort'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#tcm-tm-navi li.active').className = '';
                document.querySelector('#tcm-tm-navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
                self.initVerticalScroller(this.currPageX);
            }
        });
    },
    initVerticalScroller: function (index) {
        if (this.verticalScroller) {
            this.verticalScroller.destroy();
            this.verticalScroller = null;
        }
        var jqEl = this.jqRiskAssessDivs.eq(index);
        if (jqEl.find('div.ui-scroller').height() <= $('.tcm-physical-sort').height())
            return;
        this.verticalScroller = new iScroll(jqEl[0], {
            checkDOMChanges: false,
            snap: false,
            momentum: false,
            onBeforeScrollStart: function (e) {
                var target = e.target;
                while (target.nodeType !== 1)
                    target = target.parentNode;
                var _tagNameLc = target.tagName.toLowerCase();
                if (_tagNameLc !== 'select' && _tagNameLc !== 'input' && _tagNameLc !== 'textarea' && _tagNameLc !== 'option')
                    e.preventDefault();
            },
            onScrollMove: function (e) {
                Views.isPageScrolling = true;
            },
            onScrollEnd: function (e) {
                Views.isPageScrolling = false;
            }
        });
    }
});
Callback.yangxuToSubmit = function (btnId) {
    function ajaxDoneHandle() {
//        StageManager.pushView(Views.tcmPhysicalTestView);
        StageManager.pushView(Views.tcmPhysicalTestHistoryView);
    };

    $.each($('.tcm-tm-da-checked-mark'), function (i, dom) {
        Views.tcmYangxuzhiTestView.testResult[$(dom).attr('quest-id')] = $(dom).attr('ans-id');
    });
    var viewArr = [Views.tcmYinxuzhiTestView, Views.tcmPinghezhiTestView, Views.tcmQixuzhiTestView, Views.tcmQiyuzhiTestView, Views.tcmShirezhiTestView, Views.tcmTanshizhiTestView, Views.tcmYangxuzhiTestView, Views.tcmTebingzhiTestView, Views.tcmXueyuzhiTestView], medicalTests = '', viewLen = viewArr.length, i = 0, test, k, options;
    for (; i < viewLen; i++) {
        test = viewArr[i].zhiSort + ':';
        for (k in viewArr[i].testResult) {
            if (typeof viewArr[i].testResult[k] != "function") {
                test += k + '=' + viewArr[i].testResult[k] + ';';
            }
        }
        test = test.substring(0, test.length - 1) + ',';
        medicalTests += test;
    }
    medicalTests = medicalTests.substring(0, medicalTests.length - 1);
    options = {
        data: {"memberId": Util.data("current.member").memberId, "medicalTests": medicalTests}
    };
    DataExchange.addTcmPhysicalTest(options).done(ajaxDoneHandle);
};
Callback.showTcmPhysicalCenter = function () {
    if (!Util.loginSuggest()) {
        return;
    }
    StageManager.pushView(Views.tcmPhysicalTestView);
};

Views.tcmPhysicalTestHistoryView = $.extend({}, Views.PanelView, {
    pageNum: 1,
    isFirstPage: true,
    options: {
        tmpl: 'tcmPhysicalTestHistoryView',
        name: '中医辨体历史记录'
    },
    willShow: function (ct) {
        this.render(ct, {});
        StageManager.fixPageBack(Views.tcmPhysicalTestView);
    },
    didShow: function () {
        var self = this;
        Util.makeScrollableWithPullRefresh($('.ui-scroll'), self, {onPullDownRefresh: self.onPullDownRefresh, onPullUpRefresh: self.onPullUpRefresh});
    },
    onPullDownRefresh: function () {
        Views.tcmPhysicalTestHistoryView.pageNum = 1;
        Views.tcmPhysicalTestHistoryView.loadTestHistory(false);
    },
    onPullUpRefresh: function () {
        Views.tcmPhysicalTestHistoryView.pageNum += 1;
        Views.tcmPhysicalTestHistoryView.loadTestHistory(true);
    },
    loadTestHistory: function (isAppend) {
        var ajaxDoneHandle = function (json) {
            if (isAppend) {
                $('.ui-scroll table').append(Views.tmpl.tcmPhysicalTestHistorySubView({
                    datas: json.data
                }));
            } else {
                $('.ui-scroll table').html(Views.tmpl.tcmPhysicalTestHistorySubView({
                    datas: json.data
                }));
            }
        };
        var self = this;
        var options = {
            data: {
                familyId: UserProfile.getFamilyId(),
                pageNum: self.pageNum,
                pageSize: 5
            }
        };
        DataExchange.getTcmPhysicalTestHistory(options).done(ajaxDoneHandle);
    }

});
Callback.delTcmPhysicalTest = function (btnId) {
    var $this = $('#' + btnId)
};
Views.checkTestAnalysisView = $.extend({}, Views.PanelView, {
    checkTestSummaryItems: {},
    options: {
        tmpl: 'checkTestAnalysisView',
        name: '检验单解读列表'
    },
    prepareData: function () {
        var self = this;

        function ajaxDoneHandle(json) {
            if (json.success) {
                self.checkTestSummaryItems = json.data;
                $('#subContent').html(Views.tmpl.checkTestAnalysisSubView({
                    checkTestSummaryItems: self.checkTestSummaryItems
                }));
            }
        };
        DataExchange.getCheckTestItems({
            data: { companyId: COMPANYID }
        }).done(ajaxDoneHandle);
    },
    willShow: function (ct) {
        this.render(ct, {});
        this.viewScrollerInit($('#checkTestAnaly'));
        this.prepareData();
    }
});

Callback.showCtDetailItem = function (btnId) {
    var $btn = $('#' + btnId);
    var itemCode = $btn.attr('item-code');
    Views.checkTestAnalysisDetailView.itemCode = itemCode;
    StageManager.pushView(Views.checkTestAnalysisDetailView);
};
Callback.searchCtItemsByName = function (btnId) {
    var $btn = $('#' + btnId), searchItemName = $btn.next().val(),
	    self = Views.checkTestAnalysisView, options;

    function ajaxDoneHandle(json) {
        $('#subContent').html(Views.tmpl.checkTestAnalysisSubView({checkTestSummaryItems: json.data}));
    };
    if (searchItemName) {
        options = {
            data: {
                companyId: COMPANYID,
                keyWord: searchItemName
            }
        };
        DataExchange.getCheckTestItemsByName(options).done(ajaxDoneHandle);
    } else {
        self.prepareData();
    }
}
Views.checkTestAnalysisDetailView = $.extend({}, Views.PanelView, {
    checkTestDetailItem: {},
    itemCode: null,
    options: {
        tmpl: 'checkTestAnalysisDetailView',
        name: '检验具体项目解析'
    },
    prepareData: function (itemCode, ct) {
        function ajaxDoneHandle(json) {
            var checkTestAnalysisDetailView = Views.checkTestAnalysisDetailView;
            checkTestAnalysisDetailView.render(ct, {checkTestDetailItem: json.data || {}});
            checkTestAnalysisDetailView.viewScrollerInit($('#ct-ana-detail-wrapper-scroller'));
        };
        var options = {
            data: {itemCd: itemCode}
        };
        DataExchange.getCheckTestDetailItem(options).done(ajaxDoneHandle);
    },
    willShow: function (ct) {
        this.prepareData(this.itemCode, ct);
    }
});
