Views.footerNavView = $.extend({}, Views.PanelView, {

    willShow: function (ct) {
        delete Views.orderRegisterView.mode;
        var index = Util.data(this.indexAlias) || 0;
        Util.data(this.indexAlias, '');
        this.render(ct, { index: index });
        this.initLayout(index, this.subViews, this.animationType);
    },

    subViews: [],

    animationType: null,

    indexAlias: null,

    initLayout: function (index, subViews, animationType) {
        this.layout = new Layout.TabbedPanelLayout($('#' + this.options.tmpl + ' .ui-header-body'), animationType);

        for (var i = 0; i < subViews.length; i++) {
            if (subViews[i]) {
                this.layout.addTabView(Views[subViews[i]]);
            }
        }

        this.layout.showTabView(index);
    },

    getCurrentTabView: function () {
        return this.layout.getCurrentTabView();
    },

    switchTabView: function (index) {
        this.layout.showTabView(index);
    }
});

Callback.pageSwitchTabView = function (btnId) {

    if (Views.isAnyViewInTransition) {
        Util.log('Some view in transition, abort...');
        return;
    }

    var _btn = $('#' + btnId), index = _btn.attr('data-rel') - 0;
    // Modify CSS accordingly to show the selected status
    if (!_btn.hasClass('selected')) {
        _btn.addClass('selected');
        _btn.siblings('.ui-tab-item').removeClass('selected');
    }

    Util.data(StageManager.getCurrentView().indexAlias, '');
    Views[StageManager.getCurrentView().options.tmpl].switchTabView(index);
};

// ------------------------- 孕产保健
//
Views.maternalHealthCareView = $.extend({}, Views.footerNavView, {

    options: {
        tmpl: 'maternalHealthCareView',
        name: '孕产保健'
    },

    animationType: 'left-right',

    indexAlias: 'index.maternal',

    subViews: ['setMaternalTimeView', 'selfTestMaternalView', 'noticeMaternalView', 'checkTimeMaternalView', 'reportMaternalView', 'healthInfoView', 'reportDetailMaternalView', 'maternalProjectView'],
    /**
     * 查询本地的maternal模块数据
     * 如果没有memberId则跳到设置时间界面，用户可在该界面设置成员
     * 如果有memberId则通过此memberId获取服务器上的数据，并更新本地信息，
     *
     * */
    willShow: function (ct) {
        var maternal = LocalMode('maternal').get();
        this.index = 0;
        function ajaxDoneHandler(json) {
            if (json.success) {
                var _m = json.data;
                if (_m.lmpStr && _m.mc) {
                    LocalMode('maternal').update(_m);
                    StageManager.getCurrentView().index = 1;
                }
            }

        };
        function ajaxAlwaysHandler() {
            var page = StageManager.getCurrentView(), cacheIndex = Util.dataClear(page.indexAlias);
            if (cacheIndex) {
                page.index = cacheIndex;
            }
            page.render(ct, { index: page.index});
            page.initLayout(page.index, page.subViews, page.animationType);
        };
        if (!maternal.memberId) {
            this.render(ct, { index: this.index });
            this.initLayout(this.index, this.subViews, this.animationType);
        } else {
            DataExchange.getExpectConfinementDate({
                memberId: maternal.memberId
            }).done(ajaxDoneHandler).always(ajaxAlwaysHandler);
        }
    }
});

Callback.showSetOrSelf = function (btnId) {
    var maternal = LocalMode('maternal').get();
    $('#' + btnId).attr('data-rel', (maternal.mc && maternal.lmpStr) ? 1 : 0);
    this.pageSwitchTabView(btnId);
};
Callback.beforeShowKnowledge = function (btnId) {
    var healthInfoView = Views.healthInfoView;
    healthInfoView.catName = '妇幼保健';
    healthInfoView.showCategory = false;
    this.pageSwitchTabView(btnId);
};

Callback.layoutBack = function (btnId) {
    StageManager.getCurrentView().switchTabView($('#' + btnId).attr('data-rel'));
};

//-------------------孕妇保健  >时间设置
Views.setMaternalTimeView = $.extend({}, Views.PanelView, {

    options: {
        tmpl: 'setMaternalTimeView',
        name: '孕妇保健-时间设置'
    },
    mcSelect: function () {
        //月经周期选择
        var options = {
            onSelect: function (value, inst) {
                $('#mc').text(value);
            }
        };
        Util.mobiscrollSelect("#mcSelect", options);
    },
    lmpSelect: function () {
        //日期选择
        function onSelect(value, inst) {
            var selectDate = DateUtil.formatYYMMDD(new Date(value)), nowFormat = DateUtil.formatYYMMDD(new Date());
            if (selectDate - nowFormat > 0) {
                Widget.popupFailure("选择日期不能晚于今天");
                return false;
            }
            $('#lmp').text(value);
        };
        var now = new Date(), year = now.getFullYear(), lmp = $('#lmp').text(), defaultValue = $.trim(lmp) ? new Date(lmp) : new Date(), options = {
            startYear: year - 1,
            endYear: year,
            defaultValue: defaultValue,
            onSelect: onSelect
        };
        Util.mobiscrollDate('#lmp', options);
    },
    willHide: function () {
        $('#lmp').mobiscroll('destroy');
        $('#mcSelect').mobiscroll('destroy');
    },

    willShow: function (ct) {
        function preData() {
            var maternal = LocalMode('maternal').get(), _id = maternal.memberId, data = {
                time: Util.rtime(),
                src: _id ? (WEB_URL + '/resident/image/member/' + _id) : DEFAULT_USER_IMG
            };
            if (_id) {
                $.extend(data, {
                    lmp: maternal.lmpStr,
                    mc: maternal.mc,
                    memberId: _id,
                    name: maternal.name
                });
            }
            return data;
        }

        this.render(ct, { data: preData() });
        this.lmpSelect();
        this.mcSelect();
        StageManager.fixPageBack(Views.mainView);
    }
});
Callback.showDateSelect = function (btnId) {
    $('#lmp').mobiscroll('show');
    return false;
};
Callback.showDaySelect = function (btnId) {
    $('#mcSelect').mobiscroll('show');
    return false;
};
Callback.showselfTestMaternalView = function (btnId) {
    var options = {
        lmp: $('#lmp').text(),
        mc: $('#mc').text() - 0,
        memberId: $('#maternalUser').attr('memberId')
    };
    if (!Validator.validator(options)) {
        return false;
    }
    ;
    function ajaxDoneHandle(json) {
        if (json.success) {
            LocalMode('maternal').update(json.data);
            Views.maternalHealthCareView.switchTabView(1);
        }
    };
    DataExchange.addExpectConfinementDate(options).done(ajaxDoneHandle);
};

//-------------------孕妇保健  >产期自测
Views.selfTestMaternalView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'selfTestMaternalView',
        name: '孕妇保健-产期自测'
    },

    scrollRefresh: null,
    didShow: function (ct) {
        this.scrollRefresh = Util.makeScrollableWithPullRefresh($('#selfTestMaternal'), { onPullDownRefresh: this.renderPage });
    },
    willHide: function () {
        if (this.scrollRefresh) {
            $('#pullDown').remove();
            this.scrollRefresh.destroy();
        }
    },

    renderPage: function () {
        var maternal = LocalMode('maternal').get(), _edc = maternal.edcStr, _week = maternal.pregnantWeek, dateString;

        function ajaxDoneHandle(json) {
            if (json.success) {
                dateString = DateUtil.formatWithPatternDate('y,mm,dd', new Date(_edc)).split(',');
                $('#maternalContent').html(Views.tmpl.selfTestMaternalSubView({
                    week: _week,
                    content: json.data[0],
                    dataString: dateString
                }));
            }
        };
        DataExchange.getWeekSituations({week: _week}).done(ajaxDoneHandle);
    }
});

Callback.changeMaternalTime = function (btnId) {
    Views.maternalHealthCareView.switchTabView(0);
};

Callback.toggleMaternalTipRule = function (btnId) {
    var tempElement = $('#maternalTipRule'), title, action;
    if (tempElement.toggleClass('ui-hidden').hasClass('ui-hidden')) {
        title = "孕妇保健";
        action = "pageBack";
    } else {
        title = "预产期计算器";
        action = "toggleMaternalTipRule";
    }
    $('.header-right').toggle();
    $('.ui-header-title').eq(0).text(title);
    $('.ui-header .ui-btn').eq(0).attr('data-action', action);
};

//-------------------孕妇保健  >注意事项
Views.noticeMaternalView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'noticeMaternalView',
        name: '孕妇保健-注意事项'
    },
    dialScroll: null,
    didShow: function (ct) {
        var month = LocalMode('maternal').get().pregnantMonth;
        this.swipeDial();
        this.onRefresh(month);
    },
    swipe: 0,
    swipeDial: function () {
        $('#dial').motionTrack('start', {
            type: 'h',
            selector: '.ui-dial',
            delegate: {
                onTrackStart: function (target, pt) {
                    target.style.webkitTransitionDuration = 0;
                    target.lastTrackPt = pt;
                    if (typeof target.lastTrackDx === 'undefined') target.lastTrackDx = 0;
                    this.lastTarget = target;
                },
                onTrackMove: function (target, pt) {
                    var dx = target.lastTrackDx + (pt.x - target.lastTrackPt.x)
                    if (dx < -30) {
                        Views.noticeMaternalView.swipe = -1;
                    } else if (dx > 30) {
                        Views.noticeMaternalView.swipe = 1;
                    }
                },
                onTrackEnd: function (target) {
                    var dx = Views.noticeMaternalView.swipe, $target = $(target), $ele = $target.find('.selected'), willSwipe = false, marginLeft, anchor, nextEle;
                    if (dx === -1) {
                        if ($ele.next().text()) {
                            willSwipe = true;
                            marginLeft = $target.offset().left - 45;
                            nextEle = $ele.removeClass('selected').next();
                        }
                    } else if (dx === 1) {
                        if ($ele.prev().text()) {
                            willSwipe = true;
                            marginLeft = $target.offset().left + 45;
                            nextEle = $ele.removeClass('selected').prev();
                        }
                    } else {
                        target.lastTrackDx = 0;
                    }
                    if (willSwipe) {
                        anchor = nextEle.addClass('selected').attr('data-anchor');
                        Views.noticeMaternalView._viewScroller.scrollToElement('#' + anchor, 300);
                        $target.css('margin-left', marginLeft + 'px');
                    }
                }
            }
        });
    },

    monthsInit: function () {
        Util.mobiscrollSelect('#monthsSelect', {
            onSelect: function (value, inst) {
                Views.noticeMaternalView.onRefresh(inst.temp[0]);
            }
        });
    },
    willHide: function () {
        this.subHide();
        $('#dial').motionTrack('stop');
    },
    subHide: function () {
        $('#monthsSelect').hide().mobiscroll('destroy');
    },
    onRefresh: function (month) {
        var self = Views.noticeMaternalView;
        month = month || 1;
        function initRefresh() {
            self.monthsInit();
            self.viewScrollerInit($('#noticeMaternal'));
        };
        function restore() {
            $('.ui-dial-item.selected').removeClass('selected');
            var first = $('.ui-dial-item.notice').eq(3);
            if (!first.hasClass('selected')) {
                first.addClass('selected');
            }
            first.parent().css({
                'margin-left': '-12px'
            });
        };
        DataExchange.getMonthSituations({month: month}).done(function (json) {
            if (json.success) {
                //清空添加的事件
                self.subHide();
                $('#noticeMaternalContent').html(Views.tmpl.noticeMaternalSubView({
                    content: json.data[0],
                    month: month
                }));
                initRefresh();
                // 还原页面
                restore();
            }
        }).fail(function () {
                $('#noticeMaternalContent').html("<p style='padding-bottom: 100%'></p>");
            });
    }
});
Callback.showMonthScroll = function (btnId) {
    $('#monthsSelect').mobiscroll('show');
    return false;
};

Callback.innerPageJump = function (btnId) {
    $('.ui-dial-item.selected').removeClass('selected');
    var _btn = $('#' + btnId).addClass('selected'), anchor = _btn.attr('data-anchor'), index = _btn.attr('data-rel');
    $('.ui-dial').css('margin-left', ( -45 * index - 12 ) + 'px');
    Views.noticeMaternalView._viewScroller.scrollToElement('#' + anchor, 1000);
};
//-------------------孕妇保健  >产检时间
Views.checkTimeMaternalView = $.extend({}, Views.PanelView, {

    options: {
        tmpl: 'checkTimeMaternalView',
        name: '孕妇保健-产检时间'
    },

    didShow: function (ct) {
        this.contentRefresh();
    },
    contentRefresh: function () {
        var Maternal = LocalMode('maternal'), maternal = Maternal.get(), memberId = maternal.memberId;
        if (!Validator.memberId(memberId)) {
            return;
        }
        Maternal.update({ queryDate: null });
        this.getContent(maternal);
    },
    getContent: function (maternal) {
        var queryDate = maternal.queryDate || new Date(), memberId = maternal.memberId;

        function ajaxDoneHandle(json) {
            if (json.success) {
                var data = json.data, i = 0, time;
                for (i; i < data.length; i++) {
                    time = new Date(data[i].date);
                    data[i].showDate = time.getDate();
                    if (i === 3) {
                        var DayEn = ["SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT"];
                        data[3].showDay = DayEn[time.getDay()];
                        data[3].isChecked = Util.data(memberId + DateUtil.formatDate(new Date(data[3].date)).substring(0, 10));
                    }
                }
                $('#checkTimeMaternalContent').html(Views.tmpl.checkTimeMaternalSubView({ data: data }));
                Views.checkTimeMaternalView.viewScrollerInit($('#scroll'));
            }
        };
        DataExchange.getCheckTimeMaternal({
            queryDate: new Date(queryDate),
            memberId: memberId
        }).done(ajaxDoneHandle);
    }
});
Callback.chooseCheckTime = function (btnId) {
    var queryDate = $('#' + btnId).attr('data-rel') - 0;
    LocalMode('maternal').update({ queryDate: queryDate });
    Views.checkTimeMaternalView.contentRefresh();
};

Callback.selectCheckTime = function (btnId) {
    var _btn = $('#' + btnId), flag = _btn.hasClass('no'), _checked = $('.ui-dial-item.selected.check-time').attr('data-rel') - 0, time = DateUtil.formatDate(new Date(_checked)).substring(0, 10), memberId = LocalMode('maternal').get().memberId, checkTime, btnText;
    checkTime = memberId + "" + time;
    if (flag) {
        btnText = "已检";
    } else {
        btnText = "未检";
    }
    $('#isCheckedBg').toggleClass('no');
    _btn.toggleClass('no').text(btnText);
    Util.data(checkTime, flag);
};

//-------------------孕妇保健  >孕检报告
Views.reportMaternalView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'reportMaternalView',
        name: '孕妇保健-孕检报告'
    },
    didShow: function (ct) {
        $('#pageBody').html(Views.tmpl.reportMaternalSubView({
            data: {},
            noMessage: true
        }));
        this.viewScrollerInit($('#pageBody'));
    }
});
Callback.showReportDetail = function (btnId) {
    var _btn = $('#' + btnId);
    var title = _btn.find('span').first().text();
    LocalMode('maternal').update({reportDetailTitle: title});
    Views.maternalHealthCareView.switchTabView(6);
};
Callback.reportMaternalHelp = function (btnId) {
    Views.maternalHealthCareView.switchTabView(7);
};
//-------------------孕妇保健   >孕检报告   >详细信息
Views.reportDetailMaternalView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'reportDetailMaternalView',
        name: '孕妇保健-孕检报告-详细信息'
    },
    willShow: function (ct) {
    }
});

//-------------------孕妇保健  >孕检项目解析
Views.maternalProjectView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'maternalProjectView',
        name: '孕妇保健-孕检项目解析'
    },
    parseIndex: -1,

    willShow: function (ct) {
        this.render(ct, {
            data: maternalProject.projects
        });
        this.viewScrollerInit($('#maternalProject'));
    },
    willHide: function () {
        this.parseIndex = -1;
    }
});
Callback.projectShowParse = function (btnId) {
    var maternalProjectView = Views.maternalProjectView, _btn = $('#' + btnId), current = _btn.attr('data-rel'), older = maternalProjectView.parseIndex, parseClass = 'maternal-project-parse', arrowBottom = 'icon-arrow-bottom', viewScroller = maternalProjectView._viewScroller;
    if (older != -1) {
        //删除上一个数据
        var oldEle = $('.maternal-project-item').eq(older);
        oldEle.next().text("").toggleClass(parseClass);
        oldEle.children().addClass('icon-arrow-right').removeClass(arrowBottom);
        if (older == current) {
            maternalProjectView.parseIndex = -1;
            return;
        }
    }
    _btn.next().text(maternalProject.parses[current]).toggleClass(parseClass);
    _btn.children().addClass(arrowBottom);
    maternalProjectView.parseIndex = current;
    //触发重新计算
    viewScroller.refresh();
    //滚动生效
    viewScroller.scrollToElement('#' + btnId, 100);
};

//------knowledgeMaternalView
Views.knowledgeMaternalView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'knowledgeMaternalView',
        name: '保健知识'
    }
});