Callback.showRecordsView = function (btnId) {
    if (!Util.loginSuggest()) {
        return;
    }
    var _btn = $('#' + btnId), pageName = _btn.attr('data-rel');
    StageManager.pushView(Views[pageName]);
};

Callback.showOrderRegisterView = function (btnId) {
    if (!Util.loginSuggest()) {
        return;
    }
    var $btn = $('#' + btnId),
        regType = $btn.attr('data-rel'),
        mode = $btn.attr('data-mode'),
        aboutPage;
    Views.orderRegisterView.mode = mode;
    if (regType === 'order') {
        aboutPage = {
            "title": '预约挂号',
            "btnText": '去预约',
            "btnEnsure": '确认预约',
            "regFlag": 0//预约
        };
    } else {
        aboutPage = {
            "title": '实时挂号',
            "btnText": '去挂号',
            "btnEnsure": '确认挂号',
            "regFlag": 1//预约
        };
    }
    aboutPage.regType = regType;
    var OrderReg = LocalMode('orderReg');
    OrderReg.remove();
    OrderReg.update(aboutPage);
    StageManager.pushView(Views.orderRegisterView);
};
//--------------
Views.orderRegisterView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'orderRegisterView',
        name: '预约挂号'
    },
    willShow: function (ct) {
        var mode = this.mode;
        if (mode === "maternal") {
            Util.data(Views.maternalHealthCareView.indexAlias, 3);
        } else if (mode === "baby") {
            Util.data(Views.babyHealthCareView.indexAlias, 2);
        }
        if (!mode) {
            Util.data('index.mainView', 1);
        }
        var OrderReg = LocalMode('orderReg');
        OrderReg.update({
            scheduleId: "",
            regTime: "",
            regDate: "",
            orderDate: "",
            num: "",
            numStr: "",
            fee: ""
        });
        this.render(ct, OrderReg.get());
    }
});

Callback.orderRegSelect = function (btnId) {
    var OrderReg = LocalMode('orderReg'), orderReg = OrderReg.get(), hosId = $('#hos').attr('data-id'), deptId = $('#dept').attr('data-id');
    if (btnId === 'hos') {
        StageManager.pushView(Views.hosListView);
        return;
    }
    if (!Validator.hosId(hosId)) {
        return;
    }
    if (btnId === 'dept') {
        StageManager.pushView(Views.deptListView);
        return;
    }
    if (!Validator.deptId(deptId)) {
        return;
    }
    if (btnId === 'doc') {
        StageManager.pushView(Views.docListView);
        return;
    }
};

Callback.orderRegisterFirst = function (btnId) {
    var hosId = $('#hos').attr('data-id'), docId = $('#doc').attr('data-id'), deptId = $('#dept').attr('data-id'), validator = Validator.validator({
        hosId: hosId,
        deptId: deptId
    });
    if (!validator) {
        return;
    }
    if (docId) {
        StageManager.pushView(Views.docDetailView);
    } else {
        StageManager.pushView(Views.deptDetailView);
    }
};
//---------

Views.hosListView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'hosListView',
        name: '医院列表'
    },
    mode: "orderReg",
    willShow: function (ct) {
        var Mode = LocalMode(this.mode), newHosId = Mode.get().newHosId, self = this;
        DataExchange.getHospitalList().done(function (json) {
            if (json.success) {
                self.render(ct, {
                    newHosId: newHosId,
                    data: json.data,
                    callback: self.mode === "orderReg" ? "selectHos" : "applySelectHos"
                });
                self.viewScrollerInit($('.common-scroller'));
            }
        }).fail(function () {
                self.render(ct, {
                    newHosId: newHosId, data: {}
                })
            });
    },
    willHide: function () {
        this.mode = "orderReg";
    }
});

Callback.selectHos = function (btnId) {
    var _btn = $('#' + btnId), hosId = $.trim(_btn.attr('data-id')), hos = $.trim(_btn.text().replace("√", "")), OrderReg = LocalMode('orderReg'), orderReg = OrderReg.get();
    if (orderReg.newHosId != hosId) {
        OrderReg.update({
            newDeptId: "",
            newDept: "",
            newDocId: "",
            newDoc: "",
            newHosId: hosId,
            newHos: hos
        });
    }
    StageManager.popView();
};

//---------------
Views.deptListView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'deptListView',
        name: '科室列表'
    },
    willShow: function (ct) {
        var OrderReg = LocalMode('orderReg'), orderReg = OrderReg.get(), self = this;

        function unGetInfo() {
            self.render(ct, {
                noDept: true })
        };
        DataExchange.getDeptList({
            hospitalId: orderReg.newHosId,
            data: {
                regType: orderReg.regFlag
            }
        }).done(function (json) {
            if (json.success) {
                var depts = json.data, j = 0, len = depts.length, temp = {};
                if (len) {
                    for (; j < len; j++) {
                        var short = depts[j].shortPinyin.toUpperCase(), first = short.substr(0, 1);
                        if (!(first in temp)) {
                            temp[first] = [];
                        }
                        temp[first].push(depts[j]);
                    }
                    self.render(ct, {data: temp,orderReg: orderReg});
                    self.viewScrollerInit($('#deptList'));
                    self.eventDeal();
                } else {
                    unGetInfo();
                }
            }
        }).fail(unGetInfo);
    },

    willHide: function () {
        $("#search").unbind();
        $('#cancel').unbind();
    },

    eventDeal: function () {
        $("#search").focus(function () {
            $(this).parent().css("margin-right", "70px").end().next().show();
        });
        //click cancel ,search restore
        $('#cancel').click(function () {
            $("#search").val(null).parent().css("margin-right", "12px");
            $(this).hide();
            $('.commonDept,.sort').show();
        });
        //listener search
        $('#search').bind('input onpropertychange', function () {
            // first search dept then search sort,If sort searched ,then depts will show
            var _target = $(this).val().toUpperCase();

            function sort() {
                var that = $(this);
                if (!_target) {
                    that.show();
                } else {
                    if (that.text().toUpperCase().indexOf(_target) === -1) {
                        that.hide();
                    } else {
                        that.show();
                        if ($(arguments[1]).hasClass("sort")) {
                            var next = that.next();
                            while (!next.hasClass("sort")) {
                                next.show();
                                next = next.next();
                            }
                        }
                    }
                }
            };
            $('.commonDept').each(sort);
            // search sort
            $('.sort').each(sort);
        });
    }
});

Callback.selectDept = function (btnId) {
    var _btn = $('#' + btnId), deptId = $.trim(_btn.attr('data-id')), dept = $.trim(_btn.text()), OrderReg = LocalMode('orderReg'), orderReg = OrderReg.get();
    if (orderReg.newDeptId != deptId) {
        OrderReg.update({
            newDeptId: deptId,
            newDept: dept,
            newDocId: "",
            newDoc: ""
        });
    }
    StageManager.popView();
};

//-----

Callback.prepareData = function (orderReg, regDate, date) {
    function tranTime(regTime) {
        if (regTime === "MORNING") {
            return  "上午";
        } else if (regTime === "AFTERNOON") {
            return "下午";
        }
    };
    var len = regDate.length, i = 0, value, key, showDate;
    for (; i < len; i++) {
        value = regDate[i].regDate + " " + regDate[i].weekDay + " " + tranTime(regDate[i].regTime);
        key = regDate[i].scheduleId + "+" + regDate[i].regDate + "+" + regDate[i].regTime + '+' + regDate[i].price;
        date[ key ] = value;
        if (!i) {
            showDate = orderReg.orderDate ? orderReg.orderDate : value;
        }
    }
    return showDate;
};
Views.deptDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'deptDetailView',
        name: '科室详细信息'
    },
    //TODO
    willShow: function (ct) {
        this.cache = false;
        var OrderReg = LocalMode('orderReg'), orderReg, options;
        orderReg = OrderReg.get();
        OrderReg.update({
            medicalCardNo: "",
            name: "",
            patientsId: "",
            accountId: "",
            mobile: ""
        });
        /**
         *
         *   fetchType = "SCHEDULE_RESERVATION"; //预约排班
         *   fetchType = "SCHEDULE_REALTIME"; //实际排班
         *
         * */
        options = {
            hospitalId: orderReg.newHosId,
            deptId: orderReg.newDeptId,
            fetchType: orderReg.regType === 'order' ? "SCHEDULE_RESERVATION" : "SCHEDULE_REALTIME"
        };

        this.ajax(options, ct, orderReg);
    },
    ajax: function (options, ct, orderReg) {
        Widget.popupLoading("正在获取科室详情");
        var self = this;

        function ajaxFailHandler() {
            self.render(ct, {
                data: orderReg,
                info: {},
                noInfo: true
            });
        };

        function ajaxDoneHandler(deptClass, deptInfo, indexDate, cache) {
            console.log(arguments);
            Widget.popupLoadingClose();
            //第一个ajax请求
            var deptClassData = deptClass[0], regDate = deptClassData.data, date = {}, deptInfoDate = deptInfo[0], showRegDate, prepareData;
            if (deptClassData.success) {
                prepareData = Callback.prepareData(orderReg, regDate, date);
                showRegDate = regDate[0] || {};
                if (!orderReg.scheduleId) {
                    LocalMode('orderReg').update({
                        scheduleId: showRegDate.scheduleId,
                        regDate: showRegDate.regDate,
                        regTime: showRegDate.regTime,
                        fee: showRegDate.price
                    });
                }
                LocalMode('orderReg').update({
                    visitTime: "",
                    orderDate: prepareData
                });
            }
            if (!cache) {
                self.json = {
                    deptClass: deptClass,
                    deptInfo: deptInfo,
                    indexDate: indexDate
                };
            }
            //第二个ajax请求
            self.render(ct, {
                data: orderReg,
                info: deptInfoDate.data,
                date: prepareData,
                wheel: date
            });
            self.scrollInit();
        };
        var json = this.json;
        if (json) {
            ajaxDoneHandler(json.deptClass, json.deptInfo, json.indexDate, true);
            return;
        }
        function postByType(){
            return  orderReg.regType === 'order' ?
                $.when(
                    DataExchange.getDeptClass(options, true),
                    DataExchange.getDeptInfo(options, true),
                    DataExchange.getIndexDate($.extend(options, {
                        hospitalId: COMPANYID,
                        regType: "RESERVATION"
                    }), true)
                ) :
                $.when(
                    DataExchange.getDeptClass(options, true),
                    DataExchange.getDeptInfo(options, true)
                );
        }
        postByType().done(ajaxDoneHandler).fail(ajaxFailHandler);
    },
    scrollInit: function () {
        this.viewScrollerInit($('.common-scroller'));
        Util.mobiscrollSelect('#dateScroll', {
            onSelect: function (value, inst) {
                var arr = inst.temp[0].split('+'), orderDate = value;
                $('#regDate').text(value);
                $('#indexDate').empty();
                LocalMode('orderReg').update({
                    scheduleId: arr[0],
                    regDate: arr[1],
                    regTime: arr[2],
                    visitTime: "",
                    fee: arr[3],
                    orderDate: orderDate,
                    num: "",
                    numStr: ""
                });
            }
        });
    },
    willHide: function () {
        if (!this.cache) {
            this.json = null;
            delete this.cache;
        }
        $('#dateScroll').mobiscroll('destroy');
    }
});

Callback.orderRegisterSecond = function (btnId) {
    Views.deptDetailView.cache = true;
    var orderReg = LocalMode('orderReg').get(), date = $.trim($('#regDate').text());
    if (!orderReg.scheduleId || !date) {
        Widget.popupFailure("请选择时间");
        return false;
    }
    if ($('#indexDate').length) {
        if (!orderReg.num || orderReg.num <= 0) {
            Widget.popupFailure("请选择接诊序号");
            return false;
        }
    }
    StageManager.pushView(Views.enSureOrderView);

};

Callback.showOrderRegDate = function (btnId) {
    $('#dateScroll').mobiscroll('show');
    return false;
};
Callback.showIndexDate = function (btnId) {
    Views.deptDetailView.cache = true;
    var orderReg = LocalMode('orderReg').get(), date = $.trim($('#regDate').text());
    console.log(orderReg.scheduleId , date);
    if (orderReg.scheduleId && date) {
        StageManager.pushView(Views.medServiceIndexDateView);
    } else {
        Widget.popupFailure("请选择时间");
    }

};
//-----
Views.medServiceIndexDateView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'medServiceIndexDateView',
        name: '接诊序号'
    },
    willShow: function (ct) {
        var indexDate = Views.deptDetailView.json.indexDate[0].data,
            orderReg = LocalMode('orderReg').get(),
            data = [],
            i = 0 ,
            j = 0,
            k = 0,
            indexDateLen = indexDate.length,
            temp = [],
            indexDateItem,
            scheduleDate,
            dataLen;
        //筛选目标日期
        for (; i < indexDateLen; i++) {
            indexDateItem = indexDate[i];
            scheduleDate = DateUtil.formatYY_MM_DD(new Date(indexDateItem.scheduleDate));
            if (orderReg.regDate === scheduleDate && indexDateItem.time === orderReg.regTime) {
                data = indexDateItem.noList;
                break;
            }
        }
        dataLen = data.length;
        var oldNumArea, oldNumAreaLen, numArea;
        //将类似"1,2,3"oldNumArea，打散成"1","2","3"
        for (; j < dataLen; j++) {
            oldNumArea = data[j].oldNumArea ? data[j].oldNumArea.split(',') : [];
            numArea = data[j].numArea ? data[j].numArea.split(',') : [];
            oldNumAreaLen = oldNumArea.length;
            if (oldNumAreaLen > 1) {
                temp.push(j);
                for(; k < oldNumAreaLen; k++) {
                    data.push($.extend({}, data[j], {
                        oldNumArea: oldNumArea[k],
                        numArea: numArea.indexOf(oldNumAreaLen[k]) === -1 ? "" : oldNumAreaLen[k]
                    }));
                }
            }
        }
        while (temp.length) {
            data.splice(temp.pop(), 1);
        }
        console.log(data);
        this.render(ct, {
            data: data,
            num: orderReg.num
        });
        this.viewScrollerInit($('#indexData'));
    }
});

Callback.selectIndexDate = function (btnId) {
    var _btn = $('#' + btnId), numStr = _btn.find('.left').text(), num = _btn.attr('data-rel');
    LocalMode('orderReg').update({
        num: num,
        numStr: numStr,
        visitTime: numStr
    });
    StageManager.popView();
};
//--
Views.docListView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'docListView',
        name: "专家选择"
    },

    willShow: function (ct) {
        var OrderReg = LocalMode('orderReg'), orderReg = OrderReg.get(), self = this, options = {
            hospitalId: orderReg.newHosId,
            deptId: orderReg.newDeptId
        };
        DataExchange.getDocList(options).done(function (json) {
            if (json.success) {
                var data = json.data, len = !!data.length;
                self.render(ct, {
                    data: orderReg,
                    docs: len ? data : {},
                    noDoc: !len
                });
                self.viewScrollerInit($('#scroll'));
            }
        }).fail(function () {
                self.render(ct, {
                    data: orderReg,
                    noDoc: true,
                    docs: {}
                });
            });
    }
});

Callback.selectDoc = function (btnId) {
    var _btn = $('#' + btnId), docId = _btn.attr('data-id'), OrderReg = LocalMode('orderReg'), orderReg = OrderReg.get(), position = _btn.find('.doc-pos').eq(0).text(), doc = _btn.find('.doc-name').eq(0).text();
    OrderReg.update({
        newDocId: $.trim(docId),
        newDoc: $.trim(doc),
        docPos: $.trim(position)
    });
    StageManager.popView();
};

//------
Views.docDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'docDetailView',
        name: '专家简介'
    },
    //TODO
    willShow: function (ct) {
        var OrderReg = LocalMode('orderReg'), orderReg = OrderReg.get(), options = {
            hospitalId: orderReg.newHosId,
            deptId: orderReg.newDeptId,
            expertId: orderReg.newDocId
        }, self = this;
        Widget.popupLoading("正在获取专家信息");
        $.when(DataExchange.getDocClass(options, true), DataExchange.getDocInfo(options, true)).done(function (json1, json2) {
            Widget.popupLoadingClose();
            var regDate = json1[0].data, date = {}, date0;
            if (json1[0].success) {
                date0 = Callback.prepareData(orderReg, regDate, date);
            }
            //第二个ajax请求
            self.render(ct, {
                data: orderReg,
                info: json2[0].data,
                date: date0,
                wheel: date
            });
            Views.deptDetailView.scrollInit.call(self);
        });
    },
    willHide: function () {
        $('#dateScroll').mobiscroll('destroy');
    }
});

//---
Views.enSureOrderView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'enSureOrderView',
        name: '确认挂号信息'
    },
    willShow: function (ct) {
        this.render(ct, { data: LocalMode('orderReg').get() });
        this.viewScrollerInit($('#enSureOrder'));
    }
});

Callback.choosePainPosition = function(btnId){
	var btn = $('#'+btnId);
	if(btn.hasClass('selected')){
		btn.removeClass('selected');
	}else{
		btn.addClass('selected');
	}
};

Callback.choosePainLevel = function(btnId){
	var btn = $('#'+btnId);
	if(btn.hasClass('selected')){
		btn.removeClass('selected');
	}else{
		btn.addClass('selected');
	}
};

Callback.medCardSelect = function (btnId) {
    StageManager.pushView(Views.medCardSelectView);
};

Callback.orderRegister = function (btnId) {
    var OrderReg = LocalMode('orderReg'), orderReg = OrderReg.get(), flag = true, options = {
        "accountId": orderReg.accountId,
        "patientsId": orderReg.patientsId,
        "medicalCardNo": orderReg.medicalCardNo,
        "mobile": orderReg.mobile,
        "scheduleId": orderReg.scheduleId,
        "expertId": orderReg.newDocId || 0,
        "hospitalId": orderReg.newHosId,
        "deptId": orderReg.newDeptId,
        "regDate": orderReg.regDate,
        "regTime": orderReg.regTime,
        "visitTime": orderReg.visitTime || orderReg.numStr || "",
        "fee": orderReg.fee,
        "num": orderReg.num || "",
        regFlag: orderReg.regFlag,
        message: $('#diseaseContent').val()
    };
	var painPosition = $('#painPosition .check-box-outer.selected'),
		positionStr = '疼痛部位：';
	for(var i = 0; i < painPosition.length; i++){
		var position = $('.info',painPosition[i]).html() + ',';
		positionStr = positionStr + position;
	}
	var painLevel = $('#painLevel .check-box-outer.selected'),
		levelStr = '疼痛等级：';
	for(var i = 0; i < painLevel.length; i++){
		var level = $('.info',painLevel[i]).html() + ',';
		levelStr = levelStr + level;
	}
	options.message = levelStr + ';'+ options.message;
	options.message = positionStr + ';'+ options.message;
    $('span').slice(1).each(function () {
        if (!$(this).text()) {
            Widget.popupFailure("信息不完整");
            flag = false;
            return false;
        }
    });
    if (flag) {
        DataExchange.reg(options).done(function (json) {
            var msg;
            if (json.success) {
                function callback() {
                    StageManager.pushView(Views.mainView);
                }
                Views.deptDetailView.json = null;
                if (orderReg.regType === "order") {
                    msg = "预约成功，短信稍后会发往您的手机上,您也可以前往门诊服务-预约记录查询去查看预约状态";
                } else {
                    msg = "挂号成功，短信稍后会发往您的手机上";
                }
                Util.alert(msg, callback);
            }
        }).fail(function () {
                Widget.popupFailure("挂号失败，请稍后再试");
            });
    }
};
//-----------
Views.medCardSelectView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'medCardSelectView',
        name: '就诊卡选择'
    },
    willShow: function (ct) {
        var self = this;
        Util.data('addMedCardNo', '');
        DataExchange.getMedCard({accountId: UserProfile.id}).done(function (json) {
            if (json.success) {
                self.render(ct, {data: json.data});
                self.viewScrollerInit($('#scroll'));
            } else {
                self.render(ct, {
                    data: {}
                });
            }
        });
    }
});

Callback.getSelectMedCard = function (btnId) {
    var _btn = $('#' + btnId), cardNo = _btn.attr('data-no'), name = _btn.attr('data-name'), patientId = _btn.attr('data-patientId'), OrderReg = LocalMode('orderReg'), member = UserProfile.getMemberById(patientId);
    OrderReg.update({
        medicalCardNo: cardNo,
        name: name,
        patientsId: patientId,
        accountId: UserProfile.id,
        mobile: member.mobileNo
    });
    StageManager.popView();
};
//-----------
Views.realTimeView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'realTimeView',
        name: '实时叫号'
    }
});
///-----------------记录类抽象
Views.recordView = $.extend({}, Views.PanelView, {
    pageIndex: null,
    isRefreshing: false,
    scrollRefresh: null,
    isInit: true,
    subView: null,
    title: null,
    ajax: null,

    didShow: function (ct) {
        this.scrollRefresh = Util.makeScrollableWithPullRefresh($('#scrollRefresh'), {
            onPullDownRefresh: this.onPullDownRefresh,
            onPullUpRefresh: this.onPullUpRefresh})
    },
    //当加载成功时，设置下一次取值
    setPageIndex: function (pageIndex) {
        this.pageIndex = pageIndex;
    },
    //当下拉刷新时，恢复页面默认值
    restorePageIndex: function () {
        this.setPageIndex(null);
    },
    didHide: function () {
        this.restorePageIndex();
        this.scrollRefresh.destroy();
        this.isRefreshing = false;
    },

    isLoadEnd: function () {
        return this.pageIndex === false;
    },
    //下拉刷新时
    onPullDownRefresh: function () {
        var page = StageManager.getCurrentView();
        if (!page.isRefreshing) {
            page.isRefreshing = true;
            page.isInit = true;
            page.restorePageIndex();
            page.beforePageLoad();
        }
    },
    //上拉加载
    onPullUpRefresh: function () {
        var page = StageManager.getCurrentView();
        if (!page.isRefreshing) {
            page.isRefreshing = true;
            page.isInit = false;
            page.beforePageLoad();
        }
    },
    //向后台请求数据
    beforePageLoad: function () {
        if (this.isLoadEnd()) {
            this.isRefreshing = false;
            return;
        }
        this.dataLoad();
    },
    willShow: function (ct) {
        this.render(ct, {
            iconURL: MEMBER_ICON_URL,
            member: Util.data('current.member'),
            title: this.title
        });
    },
    getAjaxOps: function () {
        return  {
            data: {
                yearMonth: this.pageIndex || ""
            }
        };
    },
    dataLoad: function () {
        var page = StageManager.getCurrentView(), options = page.getAjaxOps();
        DataExchange[ page.ajax ](options).done(page.ajaxDoneHandler).done(page.ajaxDoneFailHandler);
    },
    ajaxDoneSetIndex: function (page, json) {
        var data, monthData;
        if (json.success) {
            data = json.data;
            monthData = data[0] || data;
            page.setPageIndex(monthData.monthName || monthData.monthName);
        }
    },
    //向子页面渲染数据
    ajaxDoneHandler: function (json) {
        var page = StageManager.getCurrentView(), content = $('#refreshContent'), data = [], html;
        if (json.success) {
            data = json.data;
        }
        page.ajaxDoneSetIndex(page, json);
        if (page.ajaxDoneCallback) {
            page.ajaxDoneCallback(page, json);
        }
        html = Views.tmpl[ page.subView ]({
            data: data
        });
        if (page.isInit) {
            content.html(html);
        } else {
            content.append(html);
        }
        page.isRefreshing = false;
    },
    ajaxDoneFailHandler: function (json) {
        var page = StageManager.getCurrentView();
        if (!json.success) {
            page.setPageIndex(false);
            if (json.errMsg.indexOf("有效就诊卡") !== -1) {
                Util.confirm(json.errMsg, function (index) {
                    if (index === 2) {
                        Views.addMedicalCardView.initArgs(Util.data('current.member').memberId);
//                        StageManager.pushView(Views.addMedicalCardView);
                    }
                });
            }
        }
    }
});

Views.recipeRecordView = $.extend({}, Views.recordView, {
    options: {
        tmpl: 'medicalRecordView',
        name: '处方记录'
    },
    subView: 'recipeRecordSubView',
    title: '处方记录',
    ajax: 'getRecipeList'
});

Callback.showRecipeRecordDetailView = function (btnId) {
    var hisRegId = $('#' + btnId).attr('data-rel');
    Views.recipeRecordDetailView.show(hisRegId);
};

Views.recipeRecordDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'recipeRecordDetailView',
        name: '处方详情'
    },
    hisRegId: null,
    show: function (hisRegId) {
        this.hisRegId = hisRegId;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        if (!this.hisRegId) {
            this.render(ct, { data: {} });
            this.viewScrollerInit($('#scroller'));
            return;
        }
        DataExchange.getRecipeDetail({
            hisRegId: this.hisRegId
        }).done(function (json) {
                if (json.success) {
                    var page = StageManager.getCurrentView();
                    page.render(ct, {data: json.data});
                    page.viewScrollerInit($('#scroller'));
                }
            });
    },
    willHide: function () {
        this.hisRegId = null;
    }
});

Views.feeRecordView = $.extend({}, Views.recordView, {
    options: {
        tmpl: 'medicalRecordView',
        name: '费用记录查询'
    },
    subView: 'feeRecordSubView',
    title: '费用记录',
    ajax: 'getFeeRecord'
});
Callback.showFeeRecordDetailView = function (btnId) {
    var baseId = $('#' + btnId).attr('data-rel');
    Views.feeRecordDetailView.show(baseId);
};

Views.feeRecordDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "feeRecordDetailView",
        name: "费用记录详情"
    },
    baseId: null,
    show: function (baseId) {
        this.baseId = baseId;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        if (!this.baseId) {
            this.render(ct, {data: {}});
            this.viewScrollerInit($('#scroller'));
            return;
        }
        DataExchange.getFeeDetail({
            baseId: this.baseId
        }).done(function (json) {
                if (json.success) {
                    var page = StageManager.getCurrentView();
                    page.render(ct, {data: json.data});
                    page.viewScrollerInit($('#scroller'));
                }
            });
    },
    willHide: function () {
        this.baseId = null;
    }
});

Views.medicalRecordView = $.extend({}, Views.recordView, {
    options: {
        tmpl: 'medicalRecordView',
        name: '诊后满意评价'
    },
    subView: 'medicalRecordSubView',
    title: '诊后满意评价',
    ajax: 'getMedicalTreatRecords'
});
Callback.showMedicalTreatRecordDetailView = function (btnId) {
    var recordId = $('#' + btnId).attr('record-id');
    Views.medicalRecordDetailView.show(recordId);
};

Views.medicalRecordDetailView = $.extend({}, Views.PanelView, {
    data: {},
    options: {
        tmpl: "medicalRecordDetailView",
        name: "诊后满意评价详情"
    },
    willShow: function (ct) {
        var self = this, options = {
            treatRecordId: this.treatRecordId
        };
        DataExchange.getMedialTreatRecordDetail(options).done(function (json) {
            if (json.success) {
                var data = json.data;
                self.data = data;
                self.render(ct, {data: data});
            }
        });
    },
    show: function (args) {
        this.treatRecordId = args;
        StageManager.pushView(this);
    }
});
Callback.showTreatmentEvaluateView = function (btnId) {
    var treatRecordId = $('#' + btnId).attr('detail-id');
    //TODO
    DataExchange.getMedialTreatRecordDetail({
        treatRecordId: treatRecordId
    }).done(function (json) {
            if (json.success) {
                if (!json.data.surveyId) {
                    var extraOptions = {}, data = Views.medicalRecordDetailView.data;
                    $.extend(extraOptions, data, {
                        subjectId: 0,
                        visitDoctorId: data.id
                    });
                    delete extraOptions.id;
                    Views.treatmentEvaluateView.showWithSurveyId(0, extraOptions);
                } else {
                    Views.treatmentEvaluateResultView.showWithData(treatRecordId);
                }
            }
        });
};

Views.treatmentEvaluateView = $.extend({}, Views.PanelView, {
    extraData: {},
    tmId: null,
    options: {
        tmpl: 'treatmentEvaluateView',
        name: '诊疗评价'
    },
    initArgs: function () {
        this.tmId = 1000;
    },
    populateHtml: function (isAppend, $currEle) {
        var self = this;
        DataExchange.getTreatEvaluateSurvey({tmId: self.tmId}).done(function (json) {
            if (json.success) {
                var htmlStr = '<div class="medical-treatment-announcement"><div class="medical-treatment-announcement-left-nail medical-treatment-announcement-nail"></div>' + '<div class="medical-treatment-announcement-right-nail medical-treatment-announcement-nail"></div>';
                htmlStr += '<div tm-id="' + json.data.id + '" class="clearfix treatment-evaluate-title">' + json.data.title + '</div>';
                for (var i = 0; i < json.data.option.length; i++) {
                    htmlStr += '<div xx-id="' + json.data.option[i].id + '" next-tm-id="' + json.data.option[i].nextSubjectId + '" class="ui-btn treatment-evaluate-content treatment-evaluate-unchecked-content" data-action="treatEvalToggle">';
                    htmlStr += json.data.option[i].title + '</div>'
                }
                if (isAppend) {
                    //删除它之后的选择题
                    while ($currEle.next().length) {
                        $currEle.next().remove();
                    }
                    $('.concrete-tool-content #select-area').append(htmlStr);
                } else {
                    $('.concrete-tool-content #select-area').html(htmlStr);
                }
            }

        });
    },
    didShow: function (ct) {
        this.initArgs();
        this.populateHtml(false);
        this.viewScrollerInit($('.ui-scroll'));
    },
    showWithSurveyId: function (surveyId, extraOptions) {
        if (!surveyId) {
            StageManager.pushView(Views.treatmentEvaluateView);
            this.extraData = extraOptions;
        } else {
            StageManager.pushView(Views.treatmentEvaluateResultView);
        }
        $('.te-submit-btn').attr('survey-id', surveyId);
    }
});
Views.treatmentEvaluateResultView = $.extend({}, Views.PanelView, {
    data: {},
    options: {
        tmpl: 'treatmentEvaluateResultView',
        name: '诊疗评价'
    },
    willShow: function (ct) {
        this.render(ct, {data: this.data});
    },
    showWithData: function (treatRecordId) {
        var options = {
            visitDoctorId: treatRecordId
        };
        DataExchange.getTreatEvaluateSurveyResult(options).done(function (json) {
            Views.treatmentEvaluateResultView.data = json.data;
            StageManager.pushView(Views.treatmentEvaluateResultView);
        });
    }
});
Callback.treatEvalToggle = function (btnId) {
    var $ele = $('#' + btnId), unchecked = 'treatment-evaluate-unchecked-content', check = 'treatment-evaluate-checked-content';
    if ($ele.hasClass(unchecked)) {
        $ele.siblings('.' + check).removeClass(check).addClass(unchecked).end().addClass(check).removeClass(unchecked);
    }
    var currView = StageManager.getCurrentView();
    currView.tmId = $ele.attr('next-tm-id');
    if (currView.tmId != '0') {
        currView.populateHtml(true, $ele.parent('.medical-treatment-announcement'));
    }
};
Callback.submitTreatEvalResult = function (btnId) {
    var answer = '', remark = '', flag = true;
    $('#select-area').find('.medical-treatment-announcement').each(function (i, dom) {
        var $dom = $(dom), $checked = $dom.find('.treatment-evaluate-checked-content');
        if (!$checked.length) {
            Widget.popupToast('请进行选择');
            return flag = false;
        }
        answer += $dom.find('.treatment-evaluate-title').attr('tm-id') + ':' + $checked.attr('xx-id') + ';';
    });
    if (flag) {
        remark = $('.medical-treatment-tm-textarea').val();
        var options = {
            answer: answer.substring(0, answer.length - 1),
            remark: remark
        };
        $.extend(options, Views.treatmentEvaluateView.extraData);
        DataExchange.addTreatEvaluateSurvey(options).done(function (json) {
            StageManager.popView();
        });
    }
};

Views.orgRecordView = $.extend({}, Views.recordView, {
    options: {
        tmpl: 'medicalRecordView',
        name: '预约挂号记录'
    },
    subView: 'orgRecordView',
    title: '预约挂号记录',
    cacheData: {},
    ajax: "getOrgRecord",

    willHide: function () {
    },
    ajaxDoneCallback: function (page, json) {
        var data;
        if (json.success) {
            data = json.data;
            page.cacheData[ data[ 0 ].monthName ] = data;
        }
    }
});
Views.orgRealTimeRecordView = $.extend({}, Views.recordView, {
    options: {
        tmpl: 'medicalRecordView',
        name: '实时挂号记录'
    },
    subView: 'orgRecordView',
    title: '实时挂号记录',
    cacheData: {},
    ajax: "getRealTimeOrgRecord",

    willHide: function () {
    },
    ajaxDoneCallback: function (page, json) {
        var data;
        if (json.success) {
            data = json.data;
            page.cacheData[ data[ 0 ].monthName ] = data;
        }
    }
});
Callback.showOrgRecordDetailView = function (btnId) {
    var _btn = $('#' + btnId), orgId = _btn.attr('data-rel'), month = _btn.attr("data-month"), page = StageManager.getCurrentView(), cacheData = page.cacheData, monthRecords = cacheData[month] ? cacheData[month][0].regRecords : null, i = 0, len, show;
    if (!monthRecords) {
        return;
    }
    len = monthRecords.length;
    for (; i < len; i++) {
        var monthRecord = monthRecords[i];
        if (monthRecord.id + "" === orgId) {
            show = StageManager.getCurrentView().ajax === "getOrgRecord";
            setTimeout(function () {
                monthRecord.name = Util.data('current.member').name;
                Views.orgRecordDetailView.show({data: monthRecord, show: show});
            }, 0);
            return;
        }
    }
};

Views.orgRecordDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "orgRecordDetailView",
        name: "预约记录详情"
    },
    show: function (args) {
        this.orgRecord = args;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct, this.orgRecord);
        this.viewScrollerInit($('#scroller'));
    },
    willHide: function () {
        this.orgRecord = null;
    }
});

Callback.cancelOrg = function (btnId) {
    var _btn = $('#' + btnId), applyId = _btn.attr("data-rel"), options = {
        applyId: applyId
    };
    DataExchange.updateOrg(options).done(function (json) {
        if (json.success) {
            Widget.popupSuccess("取消预约成功");
            StageManager.popView();
        }
    });
};
//--------------------------检查检验 开始-----------------------------
Views.testRecordView = $.extend({}, Views.recordView, {
    options: {
        tmpl: 'medicalRecordView',
        name: '检验报告'
    },
    subView: 'healthExaminationTestSubView',
    title: '检验报告',
    ajax: 'getHealthExaminationTest'
});
Views.checkRecordView = $.extend({}, Views.recordView, {
    options: {
        tmpl: 'medicalRecordView',
        name: '体检报告'
    },
    subView: 'healthExaminationCheckSubView',
    title: '体检报告',
    ajax: 'getHealthExaminationCheck'
});
Views.healthExaminationCheckDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'healthExaminationCheckDetailView',
        name: '首页-门诊服务-体检报告-体检详情'
    },
    show: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct, {data: this.data});
    },
    didShow: function (ct) {
        var self = this;
        this.viewScrollerInit($('#healthExaminationCheckDetailView .ui-scroll'), {
            bounce: false,
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function (e) {
                Views.isAnyViewScrolling = false;
                if (self.currPageX === this.currPageX)
                    return;
                self.currPageX = this.currPageX;
                document.querySelector('#bp_risk_assess_questionnaire_navi li.active').className = '';
                document.querySelector('#bp_risk_assess_questionnaire_navi li:nth-child(' + (this.currPageX + 1) + ')').className = 'active';
            }
        });
        this.pullArr = this.pullArr || [];
        $.each($("#healthExaminationCheckDetailView .tab"), function (idx, obj) {
            var $obj = $(obj);
            if ($obj.find(".fake-wrapper").height() <= $('.ui-scroll').height()) return;
            self.pullArr.push(Util.makeScrollable($obj));
        });
    },
    didHide: function () {
        this.currPageX = 0;
        this.$super().didHide();
        if (this.pullArr.length) {
            for (var i = 0, len = this.pullArr.length; i < len; i++) {
                this.pullArr[i].destroy();
            }
            this.pullArr = [];
        }
    }
});
Callback.showHealthExaminationCheckDetailView = function (btnId) {
    var $ele = $("#" + btnId);
    DataExchange.getHealthExaminationCheckDetail({
        checkDetailId: $ele.attr("data-rel")
    }).done(function (json) {
            if (json.success) {
                Views.healthExaminationCheckDetailView.show(json.data);
            }
        });
};
Views.healthExaminationTestDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'healthExaminationTestDetailView',
        name: '首页-门诊服务-体检报告-检验详情'
    },
    show: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct, {data: this.data});
    },
    didShow: function (ct) {
        this.viewScrollerInit($('#healthExaminationTestDetailView .ui-scroll'));
    }
});
Callback.showHealthExaminationTestDetailView = function (btnId) {
    var $ele = $("#" + btnId);
    DataExchange.getHealthExaminationTestDetail({
        testDetailId: $ele.attr("data-rel")
    }).done(function (json) {
            if (json.success) {
                Views.healthExaminationTestDetailView.show(json.data);
            }
        });
};

//--------------------------检查检验 结束-----------------------------

Views.offlineRecordView = $.extend({}, Views.recordView, {
    options: {
        tmpl: 'medicalRecordView',
        name: '线下记录查询'
    },
    subView: 'orgRecordView',
    title: '线下记录查询',
    cacheData: {},
    ajax: "getOfflineRecord",

    willHide: function () {
    },
    ajaxDoneCallback: function (page, json) {
        var data;
        if (json.success) {
            data = json.data;
            page.cacheData[ data[ 0 ].monthName ] = data;
        }
    }
});

