Views.mrHomeView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "mrHomeView",
        name: "医疗资源"
    },
    didShow: function () {
        StageManager.fixPageBack(Views.mainView);
    }
});
///------医疗机构
Callback.showMedOrg = function (btnId) {
    var MR = LocalMode("mr"), mr = MR.get();
    MR.update({
        page: "orgDetailView"
    });
    //看存储的是否有机构id，
    if (mr.org) {
        //如果有则直接显示详细信息
        StageManager.pushView(Views.orgDetailView);
    } else {
        //让用户选取
        StageManager.pushView(Views.orgListView);
    }

};
//--------------机构列表
Views.orgListView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "orgListView",
        name: "机构列表"
    },
    mode: "mr",
    willShow: function (ct) {
        var self = this, mode = LocalMode(this.mode).get();
        DataExchange.getHospitalList().done(function (json) {
            if (json.success) {
                self.render(ct, {
                    data: json.data,
                    newHosId: mode.selectHos || mode.org
                });
                self.viewScrollerInit($('.ui-page-body'));
            }
        }).fail(function () {
            self.render(ct, {data: {}})
        });
    },
    willHide: function () {
        this.mode = "mr";
    }
});

Callback.showOrgDetail = function (btnId) {
    var _btn = $('#' + btnId), hosId = _btn.attr('data-id'), hosName = _btn.text(), MR = LocalMode("mr"), page;
    MR.update({ org: hosId, hosName: $.trim(hosName.replace("√", ""))});
    page = MR.get().page;
    if (page === "floorNavView") {
        Callback.showFloorNav(btnId, true);
    } else {
        StageManager.pushView(Views[page]);
    }
};
Views.orgDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "orgDetailView",
        name: "机构详情"
    },
    cacheServiceDate: null,
    willShow: function (ct) {
        var MR = LocalMode("mr");
        var options = {
            hosId: MR.get().org
        };
        DataExchange.getOrgDetail(options).done(function (json) {
            if (json.success) {
                var page = StageManager.getCurrentView(), data = json.data;
                page.render(ct, {data: data, url: WEB_URL});
                LocalMode("mr").update({orgAddress: data.addressDetail});
                page.cacheServiceDate = data.serviceTime;
                page.viewScrollerInit($('#orgDetail'));
                StageManager.fixPageBack(Views.mrHomeView);
            }
        });
    },
    willHide: function () {
        this.cacheServiceDate = null;
    }
});

Callback.orgServiceView = function (btnId) {
    Views.orgServiceView.initArgs(Views.orgDetailView.cacheServiceDate);
};

Views.orgServiceView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "orgServiceView",
        name: "机构提供服务"
    },
    initArgs: function (args) {
        this.serviceDate = args || "";
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var data = this.serviceDate.split('；'), mr = LocalMode("mr").get();
        this.render(ct, { data: data, hosName: mr.hosName });
        this.viewScrollerInit($('#orgService'));
    }
});

Views.underServiceStationView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "underServiceStationView",
        name: "机构辖下服务站"
    },
    willShow: function (ct) {
        var options = {
            agencyId: LocalMode("mr").get().org
        };
        DataExchange.getStationList(options).done(function (json) {
            var page = StageManager.getCurrentView();
            if (json.success) {
                page.render(ct, {data: json.data, url: WEB_URL, station: Views.stationDetailView.station});
                page.viewScrollerInit($('.common-scroller'));
            } else {
                page.render(ct, {data: []});
            }
        }).fail(function () {
                StageManager.getCurrentView().render(ct, { data: [] });
            });
    }
});

Callback.showStationDetail = function (btnId) {
    var station = $.trim($('#' + btnId).attr('data-rel'));
    Views.stationDetailView.initArgs(station);
};

//-------------------服务站详情
Views.stationDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "stationDetailView",
        name: "服务站详情"
    },
    station: null,
    initArgs: function (args) {
        this.station = args;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var options = {
            id: this.station
        };
        DataExchange.getStationDetail(options).done(function (json) {
            if (json.success) {
                var page = StageManager.getCurrentView();
                page.render(ct, { data: json.data, url: WEB_URL });
                page.viewScrollerInit($('#stationDetail'));
                StageManager.fixPageBack(Views.orgDetailView);
            }
        });
    }
});
//--医疗费用项目 --继承自med-service.js的recordView
Views.mrFeeItemView = $.extend({}, Views.recordView, {
    options: {
        tmpl: "mrFeeItemView",
        name: "医疗费用项目"
    },
    restorePageIndex: function () {
        this.setPageIndex(1);
        this.isInit = true;
    },
    willHide: function () {
        this.searchVaule = null;
        this.type = 0;
    },
    searchVaule: null,
    pageSize: 10,
    subView: "mrFeeItemSubView",
    type: 0,
    ajax: 'getMedicalExpenses',

    ajaxDoneSetIndex: function (page, json) {
        if (json.success) {
            page.setPageIndex(page.pageIndex + 1);
        }
    },
    getAjaxOps: function () {
        return {
            itemName: this.searchVaule||"",
            pageNum: this.pageIndex,
            pageSize: this.pageSize,
            type: this.type
        };
    },
    ajaxDoneFailHandler: function () {

    }
});
Callback.searchMrFeeItem = function (btnId) {
    var mrFeeItemView = Views.mrFeeItemView;
    mrFeeItemView.restorePageIndex();
    mrFeeItemView.searchVaule = $.trim($('#search').val());
    mrFeeItemView.type = $('.tab.highlight').first().attr('data-rel') - 0;
    mrFeeItemView.dataLoad();
};
Callback.choseMRFee = function (btnId) {
    var _btn = $('#' + btnId), type = _btn.attr('data-rel') - 0, className = "highlight", flag = _btn.hasClass(className), mrFeeItemView = Views.mrFeeItemView;
    if (flag) {
        return;
    } else {
        $('.tab.highlight').eq(0).removeClass(className);
        _btn.addClass(className);
    }
    mrFeeItemView.restorePageIndex();
    mrFeeItemView.searchVaule = $.trim($('#search').val()) || null;
    mrFeeItemView.type = type;
    mrFeeItemView.dataLoad();
};
Views.pathNavView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "pathNavView",
        name: "路线导航"
    },
    didShow: function (ct) {
        var success = "success";

        function ajaxDoneHandler() {
            $('#allmap').text('');
            var map = new BMap.Map("allmap"), mr = LocalMode("mrNav").get(), local, orgAddress;            // 创建Map实例
            console.log(mr);
            map.centerAndZoom("杭州下城区", 15);
            map.addControl(new BMap.NavigationControl());
            map.addControl(new BMap.ScaleControl());
            map.addControl(new BMap.OverviewMapControl());
            local = new BMap.LocalSearch(map, {
                renderOptions: { map: map }
            });
            console.log(mr.orgAddress);
            orgAddress = (mr.orgAddress) || "杭州下城区";
            local.search(orgAddress);
        };
        if (typeof BMap !== "undefined") {
            ajaxDoneHandler();
        } else {
            //获取地图的script标签
            $.ajax({
                url: 'http://api.map.baidu.com/api?v=1.4',
                type: 'get',
                dataType: 'text'
            }).done(function (res, status) {
                if (status === success) {
                    //解析地图script
                    var reg = new RegExp("http://([\\w-]+\\.)+[\\w-]+(/[\\w- ./?%&=]*)?", "g"), urls = res.match(reg);
                    //获取地图所需的script
                    $.getScript(urls[0]).done(function (json) {
                        if (arguments[1] === success) {
                            ajaxDoneHandler();
                        }
                    }).fail(function () {
                        $('#allmap').text("百度地图获取失败");
                    });
                }
            });
        }
    }
});

//--------
Callback.showFloorNav = function (btnId, flag) {
    var MR = LocalMode("mrNav"), mr = MR.get();
    MR.update({
        page: "floorNavView"
    });
    if (mr.org) {
        DataExchange.commonJson('json/floorNav.json').done(function(json){
            var hospitals = json.hospitals,
                len = hospitals.length,
                i = 0,
                hospital,
                builds;
            for (; i< len; i++) {
                hospital = hospitals[i];
                if (hospital.id === Number(mr.org)) {
                    break;
                }
            }

            if (i === len) {
                delete Views.floorNavView.commonPageback;
                Views.floorNavView.init({});
                Widget.popupFailure("该医院数据尚未收录");
            } else {
                builds = hospital.builds;
                if (builds.length === 1) {
                    Views.showImgView.buildId = 1;
                    delete Views.floorNavView.commonPageback;
                    Views.floorNavView.init(builds[0]);
                } else {
                    Views.buildSelectView.init(builds);
                }
            }
        });
    } else {
        if (flag) {
            StageManager.pushView(Views.orgListView);
        } else {
            StageManager.pushView(Views.orgListAllView);
        }

    }
};
Callback.showFloorNavView = function (btnId) {
    var _btn = $('#' + btnId),
        id = _btn.attr('data-rel'),
        i = 0,
        data = Views.buildSelectView.data,
        len = data.length;
    for (; i < len; i++) {
        if (data[i].id == id) {
            Views.showImgView.buildId = id;
            Views.floorNavView.init(data[i]);
            return;
        }
    }

};

Views.buildSelectView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "buildSelectView",
        name: "建筑选择"
    },
    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        //
        Views.floorNavView.commonPageback = true;
        this.render(ct, {
            data: this.data
        });
        StageManager.fixPageBack(Views.mrHomeView);
    }
});

Views.floorNavView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "floorNavView",
        name: "楼层导航"
    },


    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },

    willShow: function (ct) {
        this.render(ct, {
            data: this.data
        });
        this.viewScrollerInit($('#floorNavView'));
        var floorNavView = Views.floorNavView;
        if (floorNavView.commonPageback) {
            StageManager.fixPageBack(Views.buildSelectView);
        } else {
            StageManager.fixPageBack(Views.mrHomeView);
        }
    }
});

Callback.showFloorImg = function (btnId) {
    var _btn = $('#' + btnId),
        imgId = _btn.attr('data-rel'),
        len = _btn.attr('data-len');
    Views.showImgView.init({
        imgId: imgId - 0,
        len: len
    });
};
Views.showImgView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: "showImgView",
        name: "显示图片"
    },
    buildId: 1,
    init: function (data) {
        this.data = data;
        StageManager.pushView(this);
    },
    getImgUrl: function () {
        return "themes/images/floorNav/" + LocalMode("mrNav").get().org + "/" + (this.buildId * 100 + this.data.imgId) + ".png"
    },
    willShow: function (ct) {
        this.render(ct, {
            img: this.getImgUrl(),
            title: "平面图",
            data: this.data,
            buildId: this.buildId
        });
        this.viewScrollerInit($('#showImgView'),{
            vScroll: true,
            hScroll: true,
            onScrollEnd: function () {
                var showImgView = Views.showImgView,
                    data = showImgView.data,
                    dirX = this.dirX,
                    temp;
                if (dirX) {
                    temp =  + data.imgId + dirX;
                    if (temp >=1 && temp <= data.len) {
                        data.imgId = temp;
                        $('#imgView').hide();
                        $('.icon-circle.grn').removeClass("grn");
                        setTimeout(function(){
                            $('.icon-circle').eq(temp-1).addClass('grn');
                            $('#imgView').attr('src', showImgView.getImgUrl()).show();
                        },0);
                    }

                }
            }
        });
    },
    willHide: function () {
        delete this.data;
    }
});

////////////////////////////////////////////////////////////

Callback.showFdViewDepend = function (btnId) {
    var view;
    var MR = LocalMode('mr');
    if (MR.get().org) {
        view = "familyDoctorView";
    } else {
        view = "orgListView";
    }
    MR.update({
        page: "familyDoctorView"
    });
    StageManager.pushView(Views[view]);
};


Views.familyDoctorView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'familyDoctorView',
        name: '家庭医生'
    },

    didShow: function (ct) {
        this.viewScrollerInit($('.ui-scroll'), {
            bounceLock: true
        });
        this.showWithData(1);
        StageManager.fixPageBack(Views.mrHomeView);
    },
    showWithData: function (type, name) {
        var self = this, options = {data: {agencyId: LocalMode("mr").get().org, pageNum: 1, pageSize: 30}}, ajaxName, subView;

        if (type == 1) {
            ajaxName = "getDoctorTeams";
            subView = "fdDoctorTeamSubView";
        } else {
            options.data.name = name || "";
            ajaxName = "getCommunityDoctors";
            subView = "fdCommunityDoctorSubView";
        }
        function done(json) {
            var datas;
            if (json.success) {
                datas = json.data;
                self.communityDoctors = datas;
                $('#fd-concrete-content').html(Views.tmpl[subView]({
                    datas: datas,
	                DOCTOR_ICON_URL: DOCTOR_ICON_URL,
	                t: new Date().getTime()
                }));
            }
        };
        DataExchange[ajaxName](options).done(done);
    }

});
Callback.familyDoctorToggle = function (btnId) {
    var $ele = $("#" + btnId), index = Number($ele.attr("data-rel")), highlight = "highlight";
    if ($ele.hasClass(highlight)) {
        return;
    }
    $('#fd-search-expert-area').toggle();
    $(".horizon-tabs .tab").siblings('.highlight').removeClass(highlight).end().eq(index - 1).addClass(highlight);
    Views.familyDoctorView.showWithData(index);
};
Callback.toggleDisplayDctTeamInfo = function (btnId) {
    var id = "#" + btnId, $btn = $(id), $next = $btn.next(), display = $next.css('display'), viewScroller;
    if (display === "block") {
        $next.hide();
    } else {
        $('.dct-team-body').hide();
        $next.show();
        viewScroller = StageManager.getCurrentView()._viewScroller;
        //触发重新计算高度
        viewScroller.refresh();
        //滑动到所按的元素
        viewScroller.scrollToElement(id, 100);
    }
};
Callback.searchCommunityDctsByName = function (btnId) {
    console.log(btnId);
    var input = $("#" + btnId).next(),
        currView = StageManager.getCurrentView(),
        searchContent = $.trim(input.val()),
        items = $('.community-dct-info-area');
    if (!items.length) {
        currView.showWithData(2, searchContent);
    } else {
        if (searchContent === "") {
            items.show();
        }
        items.forEach(function (value, index, arr) {
            var _ = $(value);
            if (_.find('.dct-name').text().indexOf(searchContent) === -1) {
                _.hide();
            } else{
                _.show();
            }
        });
        input.text(searchContent);
    }
};

Callback.showOrgListAllView = function (btnId) {
    var _btn = $('#' + btnId);
    Views.orgListAllView.init(_btn.attr('data-rel'));
};

Views.orgListAllView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'orgListAllView',
        name: '医院列表'
    },
    init: function (page) {
        this.callback = page;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var Mode = LocalMode("mrNav"), newHosId = Mode.get().org, self = this;
        DataExchange.getHospitalAllList().done(function (json) {
            if (json.success) {
                self.render(ct, {
                    newHosId: newHosId,
                    data: json.data,
                    callback: self.callback
                });
                self.viewScrollerInit($('.common-scroller'));
            }
        }).fail(function () {
                self.render(ct, {
                    newHosId: newHosId, data: {}
                })
            });
    }
});

Callback.showAllOrgDetail = function (btnId) {
    var _btn = $('#' + btnId), hosId = _btn.attr('data-id'), hosName = _btn.text(), MRNav = LocalMode("mrNav");
    MRNav.update({ org: hosId, hosName: $.trim(hosName.replace("√", "")), orgAddress: _btn.attr('data-addressDetail')});
    if (Views.orgListAllView.callback === "pathNavView") {
        StageManager.popView();
    } else {
        Callback.showFloorNav();
    }

};