// ------------------------------------------------------------------------
// AppManager
// 
var AppManager = {
    // 打开app后的初始化
    initialize: function () {
        Util.data('index.mainView', '');
        StageManager.initialize();
        if (Util.data("account")) {
            Views.loginView.loginAjax(Util.data("account"), Util.data("pwd"), true);
        } else {
            Util.data('current.member', "");
        }
        StageManager.pushView(Views.mainView);
//        StageManager.pushView(Views.treatementEvaluateView);
        Util.checkVersionUpdate(true);
    }
};

//------------------------- common method
//表单提交
/*Callback.formSubmitTransfer = function(btnId) {
 formSubmitTransfer($('#'+btnId).attr('data-submit'));

 };*/
function formSubmitTransfer(submitMethod) {
    $('input').blur();
    if (submitMethod && Callback[submitMethod])
        Callback[submitMethod]();
    return false;
}

function loadDefaultImg(img) {
    var type = $(img).attr('type'), sex = $(img).attr('sex');
    switch (type) {
        case "member" :
            if (sex === 'MALE' || sex === '先生')
                img.src = './themes/images/default/male.png';
            if (sex === 'FEMALE' || sex === '女士')
                img.src = './themes/images/default/female.png';
            break;
        case "news":
            img.src = './themes/images/default/newsPic.png';
            break;
        case "doctor":
            img.src = './themes/images/default/doctor.png';
            break;
    }
}
Callback.emptyInput = function (btnId) {
    $('#' + btnId).prev('input').val('').focus();
};
// ------------------------- mainView
//
Views.mainView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'mainView',
        name: '首页'
    },

    willShow: function (ct) {
        StageManager.clearViewStack();
        var index = Util.data('index.mainView') || 0;
        Util.data('index.mainView', '');
        this.render(ct, { index: index });
        this.initLayout(index);
    },

    onPageBack: function (transitionEndCallback) {
        if (APPVERSION !== 'wechat' && mobile_system === 'android') {
            // 在android系统上，首页按“回退”键退出系统
            Util.confirm('您确定要退出' + APPNAME + '吗？', function (index) {
                if (index === 2) {
                    if (Util.statisticEnabled) Util.statistic.onAppExit();
//					UserProfile.setUserLogout();
                    navigator.app.exitApp();
                }
            });
        }
    },

    initLayout: function (index) {
        this.layout = new Layout.TabbedPanelLayout($('#mainView .ui-page-body'), 'left-right');
        this.layout.addTabView(Views.homeView);
        this.layout.addTabView(Views.medicalServiceView);
        this.layout.addTabView(Views.healthInfoView);
        this.layout.showTabView(index);
    },

    getCurrentTabView: function () {
        return this.layout.getCurrentTabView();
    },

    switchTabView: function (index) {
        this.layout.showTabView(index);
    }
});
Callback.mainViewSwitchTabView = function (btnId) {
    if (Views.isAnyViewInTransition) {
        Util.log('Some view in transition, abort...');
        return;
    }
    var _btn = $('#' + btnId), index = _btn.attr('data-rel') - 0;
    // Modify CSS accordingly to show the selected status
    if (!_btn.hasClass('selected')) {
        _btn.addClass('selected');
        _btn.siblings('.ui-tab-item').removeClass('selected');
    }
    //缓存清理
    Util.data('index.mainView', '');
    Util.data("consult.tab.index", 1);
    Views.mainView.switchTabView(index);
};

// ------------------------- 首页 > 主页
//
Views.homeView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'homeView',
        name: '首页-主页'
    }
});
Callback.showMaternalHealthCareView = function (btnId) {
    UserProfile.checkMaternal();
};

// ------------------------- 首页 > 医疗服务
//
Views.medicalServiceView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'medicalServiceView',
        name: '首页-医疗服务'
    },

    didShow: function (ct) {
        this.viewScrollerInit($('#medicalService'));
        Util.data('index.mainView', 1);
        LocalMode('orderReg').remove();
    }
});

// ------------------------- 首页 > 健康资讯
Views.healthInfoView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'newsView',
        name: '首页-健康资讯'
    },
    pageNum: 1,
    isFirstPage: true,
    categoryIndex: 0,
    catName: null,
    showCategory: true,
    needCategoriesRefresh: function () {
        if (!Util.data('news.categories.timeStamp')) {
            return true;
        }
        if ((new Date().getTime() - Util.data('news.categories.timeStamp')) > 600000) {
            return true;
        }
        return false;
    },
    confirmCatagory: function () {
        var cats = Util.data('news.categories'),
            catName = this.catName;
        if (catName) {
            for (var i = 0, len = cats.length; i < len; i++) {
                if (cats[i].name === catName) {
                    this.categoryIndex = i;
                    break;
                }
            }
        }
        $('.news-wrapper > li.active').removeClass("active");
        $('.news-wrapper > li').eq(this.categoryIndex).addClass("active");
    },
    init: function () {
        this.pageNum = 1;
        this.isFirstPage = true;
        $("#a_pullUp").remove();
    },

    isShowCategory: function () {
        var stageView = StageManager.getCurrentView().options.tmpl;
    console.log(stageView);
        Util.data('newsStageView', stageView);
        if (stageView === 'maternalHealthCareView' || stageView === 'babyHealthCareView') {
            this.showCategory = false;
            this.catName = '妇幼保健';
        } else if (stageView === "newsView") {
            this.showCategory = false;
            this.catName = '慢病资讯';
        } else {
            if (!this.showCategory) {
                this.catName = null;
                this.categoryIndex = 0;
                this.showCategory = true;
            }
        }
    },
    willShow: function (ct) {
        $('.ui-scroll').remove();
        this.isShowCategory();
        var self = this;
        Util.data('index.mainView', '');
        if (this.needCategoriesRefresh) {
            DataExchange.getHealthNewsCategories({}).done(function (json) {
                if (json.success) {
                    Util.data('news.categories', json.data);
                    Util.data('news.categories.timeStamp', new Date().getTime());
                    self.render(ct, {categories: json.data, showCategory: Views.healthInfoView.showCategory,
                        catName: self.catName});
                    self.confirmCatagory();
                    setTimeout(function () {
                        self.viewScrollerInit($('#horizontalScroll'), {bounce: false});
                    }, 500);
                    if (!self.pullRefresher) self.pullRefresher =
                                             Util.makeScrollableWithPullRefresh($("#newsView .ui-pull-to-refresh"), self);
                }
            });
        } else {
            this.render(ct, {categories: Util.data('news.categories'),catName: self.catName});
            setTimeout(function () {
                self.viewScrollerInit($('#horizontalScroll'), {bounce: false});
            }, 500);
            if (!this.pullRefresher) this.pullRefresher = Util.makeScrollableWithPullRefresh($("#newsView .ui-pull-to-refresh"), this);
        }
    },
    willHide: function () {
        if (this.pullRefresher) {
            this.pullRefresher.destroy();
            this.pullRefresher = null;
        }
    },
    newsRender: function (isAppend) {
        var self = this;
        DataExchange.getHealthNews({
            "data": {pageNum: self.pageNum, pageSize: 5},
            "catalogId": $('.news-wrapper > li').eq(this.categoryIndex).attr("data-catalog-id")
        }).done(function (json) {
                if (json.success) {
                    if (json.data.length) {
                        var dt = new Date();
                        dt.setHours(0);
                        dt.setMinutes(0);
                        dt.setSeconds(0);
                        dt.setMilliseconds(0);
                        for (var i = 0, l = json.data.length; i < l; i++) {
                            var d = new Date(json.data[i].addTime);
                            d.setHours(0);
                            d.setMinutes(0);
                            d.setSeconds(0);
                            d.setMilliseconds(0);
                            json.data[i].newFlag = (dt.getTime() - d.getTime()) < 86400000 ? true : false;
                        }
                        self.deployNewsAsHtml("json", json.data, isAppend);
                    } else {
                        if (self.isFirstPage) {
                            self.deployNewsAsHtml("html", '<div class="corver-page    reportMaternal"><div class="no-report-bg reportMaternal"></div><div class="f-14-adadad tac text">暂无该类资讯</div></div>');
                        }
                        $("#a_pullUp").remove();
                    }
                }
            });
    },
    deployNewsAsHtml: function (contentType, content, isAppend) {
        if (contentType === "html") {
            $('.news-contents').html(content);
            return;
        }
        if (isAppend) {
            $('.news-contents').append(Views.tmpl.newsSubView({WEB_URL: WEB_URL, news: content, isAppend: true}));
            this.pullRefresher.topOffset = -38;
            return;
        }
        $('.news-contents').html(Views.tmpl.newsSubView({WEB_URL: WEB_URL, news: content}));
        $('.news-contents').after('<a id="a_pullUp" class="ui-btn a-pullup" data-action="loadMoreNews">点击加载更多</a>');

    },
    onPullDownRefresh: function () {
        this.init();
        this.newsRender(false);
    }
});
Callback.showNewsViewByCatalogName = function (btnId) {
    Views.healthInfoView.catName = $.trim($("#" + btnId).attr("data-rel"));
    Util.data('index.mainView', 2);
    StageManager.pushView(Views.mainView);


};


Callback.newsCatalogChange = function (btnId) {
    var $ele = $("#" + btnId), attr = $ele.attr("data-rel");
    $(".news-wrapper>.active").removeClass("active");
    $('.news-wrapper>li').eq(attr).addClass("active");
    Views.healthInfoView.categoryIndex = attr;
    Views.healthInfoView.catName = $.trim($ele.text());
    Views.healthInfoView.init();
    Views.healthInfoView.newsRender(false);
}
Callback.loadMoreNews = function () {
    $('.corver-page').remove();
    Views.healthInfoView.pageNum = Views.healthInfoView.pageNum + 1;
    Views.healthInfoView.isFirstPage = false;
    Views.healthInfoView.newsRender(true);
}

Views.newsDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'newsDetailView',
        name: '资讯-新闻详情'
    },
    show: function (data) {
        this.initArgs = data;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        var data = this.initArgs, newsId = data.newsId, imgUrl = data.imgUrl, self = this;

        DataExchange.getHealthNewsDetail({
            "data": { familyId: UserProfile.isUserLoggedIn() ? UserProfile.getFamilyId() : 0 },
            "newsId": newsId
        }).done(function (json) {
                if (json.success) {
                    Util.data("news.detail.id", newsId);
                    json.data.publishTime = DateUtil.formatWithPatternDate('yyyy-mm-dd HH:ii', new Date(json.data.addTime));
                    self.render(ct, {
                        newsDetail: json.data,
                        WEB_URL: WEB_URL,
                        picUrl: imgUrl.replace("/0/",'/1/')
                    });
                    self.viewScrollerInit($(".news-comment-view"));
                    //获取新闻成功之后再获取最多三条的最新评论 TODO
                    Views.newsCommentView.ajax({pageNum: 1, pageSize: 3}, function (result) {
                        if (result.success) {
                            if (result.data.length) {
                                for (var i = 0, l = result.data.length; i < l; i++) {
                                    result.data[i].commentTimeStr = DateUtil.formatWithPatternDate('yyyy-mm-dd HH:ii', new Date(result.data[i].addTime));
                                }
                                Views.newsDetailView.deployCommentAsHtml('json', {memberPicUrlPrefix: MEMBER_ICON_URL, newsComments: result.data});
                            } else {
                                Views.newsDetailView.deployCommentAsHtml('html', {memberPicUrlPrefix: MEMBER_ICON_URL, newsComments: '<div style=\"font-size:12px;\">暂无评论:-(</div>'});
                            }
                        }
                    });
                }
            });
    },
    deployCommentAsHtml: function (contentType, content) {
        if (contentType === "html") {
            $('.new-comment-wrapper .content-wrapper').html(content.newsComments);
            return;
        }
        $(".new-comment-wrapper .content-wrapper").html(Views.tmpl.newsCommentSubView(content));
    }
});
Callback.showNewsDetailView = function (btnId) {
    var btn = $("#" + btnId), stageView = Util.data('newsStageView'), imgUrl;
    if (stageView === 'babyHealthCareView') {
        Util.data(Views.babyHealthCareView.indexAlias, 18);
    }
    if (stageView === 'maternalHealthCareView') {
        Util.data(Views.maternalHealthCareView.indexAlias, 5);
    } else {
        Util.data('index.mainView', 2);
    }
    if (btn.attr('src')) {
        imgUrl = btn.attr('src');
    } else {
        imgUrl = btn.find('img').attr('src');
    }
    if (imgUrl.indexOf('defaultNewsPic') > -1) {
        imgUrl = '';
    }
    Util.data('news.detail.imgUrl', imgUrl);

    var newsId = $("#" + btnId).attr("data-rel-id");
    Views.newsDetailView.show({
        newsId: newsId,
        imgUrl: imgUrl
    });

};
function commentSubmit(successCallback) {
    if (!Util.loginSuggest()) {
        return;
    }
    var $input = $("#news_comment_input");
    $input.val($input.val().replace(Validator.emoji, ""));
    if (!Util.trim($input.val())) {
        Widget.popupToast('评论不能为空哟:-(');
        $input.val("");
        return;
    }
    DataExchange.addHealthNewsComment({
        "data": {commentContent: $input.val()},
        "newsDetailId": Util.data("news.detail.id"),
        "familyId": UserProfile.getFamilyId(),
        "memberId": Util.data('current.member').memberId
    }).done(function (json) {
            if (json.success) {
                $input.val("");
                if (typeof successCallback === "function") successCallback();
            }
        });
}
Callback.newsViewCommentSubmit = function () {
    commentSubmit(function () {
        StageManager.pushView(Views.newsCommentView);
    });
};
Callback.addOrCancelFavorite = function (btnId) {
    if (!Util.loginSuggest()) {
        return;
    }
    var $ele = $("#" + btnId), iconEle = $ele.find('.favorite');
    if (iconEle.hasClass("active")) {
        DataExchange.removeHealthNewsCollect({
            "familyId": UserProfile.getFamilyId(),
            "newsDetailId": Util.data("news.detail.id")
        }).done(function (json) {
                if (json.success) {
                    iconEle.removeClass("active");
                }
            });
    } else {
        DataExchange.addHealthNewsCollect({
            "familyId": UserProfile.getFamilyId(),
            "newsDetailId": Util.data("news.detail.id")
        }).done(function (json) {
                if (json.success) {
                    iconEle.addClass("active");
                }
            });
    }
};
Callback.newsShare = function () {
    DataExchange.getHealthNewsShareInfo({
        "newsDetailId": Util.data("news.detail.id")
    }).done(function (json) {
            if (json.success) {
                var uri = encodeURI(Util.data('news.detail.imgUrl'));
                Util.data('newsShare.temp', json.data);
                FSManager.download({
                    url: uri,
                    file: FSManager.getRootPath() + '/shareNews.png',
                    onSuccess: "newsPicDownloaded",
                    onError: "newsPicDownloadFailed",
                    onProgress: "uploadOrDlProgress"
                }, true);
            }
        });
};
Callback.newsPicDownloaded = function (f, url) {
    Widget.popupLoadingClose();
    cordova.exec(function () {
        },//回调的success方法
        function () {
        },//回调的fail方法
        "SocialShare", "shareNews", [
            Util.data('newsShare.temp'), f.toURL()
        ]);
}
Callback.newsPicDownloadFailed = function (f, url) {
    Widget.popupLoadingClose();
    Widget.popupToast("download error");
//	cordova.exec(
//		function(){},//回调的success方法
//		function(){},//回调的fail方法
//		"SocialShare",
//		"shareNews",
//		[
//			Util.data('newsShare.temp'),
//			f.toURL()
//		]
//	);
}

Views.newsCommentView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'newsCommentView',
        name: '资讯-新闻详情-评论'
    },
    pageNum: 1,
    isFirstPage: true,
    init: function () {
        this.pageNum = 1;
        this.isFirstPage = true;
        $("#a_pullUp").remove();
    },
    didShow: function (ct) {
        this.commentRender(false);
        if (!this.pullRefresher) this.pullRefresher = Util.makeScrollableWithPullRefresh($("#newsCommentView .ui-pull-to-refresh"), this);
    },
    didHide: function () {
        this.$super().didHide();
        this.pageNum = 1;
        if (this.pullRefresher) {
            this.pullRefresher.destroy();
            this.pullRefresher = null;
        }
    },
    ajax: function (queryData, doneCallback) {
        DataExchange.getHealthNewsComments({
            "data": queryData,
            "newsDetailId": Util.data("news.detail.id")
        }).done(function (json) {
                doneCallback(json);
            });
    },
    commentRender: function (isAppend) {
        var self = this;
        this.ajax({pageNum: self.pageNum, pageSize: 5}, function (json) {
            if (json.success) {
                if (json.data.length) {
                    for (var i = 0, l = json.data.length; i < l; i++) {
                        json.data[i].commentTimeStr = DateUtil.formatWithPatternDate('yyyy-mm-dd HH:ii', new Date(json.data[i].addTime));
                    }
                    self.deployCommentAsHtml("json", {memberPicUrlPrefix: MEMBER_ICON_URL, newsComments: json.data}, isAppend);
                } else {
                    if (self.isFirstPage) {
                        self.deployCommentAsHtml("html", '<div style=\"font-size:12px;\">暂无评论:-(</div>');
                    }
                    $("#a_pullUp").remove();
                }
            }
        });
    },
    deployCommentAsHtml: function (contentType, content, isAppend) {
        var $newsCommentView = $("#newsCommentView .new-comment-wrapper .content-wrapper");
        if (contentType === "html") {
            $newsCommentView.html(content);
            return;
        }
        if (isAppend) {
            $newsCommentView.append(Views.tmpl.newsCommentSubView(content));
            this.pullRefresher.topOffset = -38;
            return;
        }
        $newsCommentView.html(Views.tmpl.newsCommentSubView(content));
        $newsCommentView.after('<a id="a_pullUp" class="ui-btn a-pullup" data-action="loadMoreNewsComment">点击加载更多</a>');
    },
    onPullDownRefresh: function () {
        this.init();
        this.commentRender(false);
    }
});
Callback.loadMoreNewsComment = function () {
    $("#a_pullUp").remove();
    Views.newsCommentView.pageNum = Views.newsCommentView.pageNum + 1;
    Views.newsCommentView.isFirstPage = false;
    Views.newsCommentView.commentRender(true);
}
Callback.commentViewSubmit = function () {
    commentSubmit(function () {
        Views.newsCommentView.init();
        Views.newsCommentView.commentRender(false);
    });
}
//------------------------- 登录
Views.loginView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'loginView',
        name: '登录'
    },
    willShow: function (ct) {
        var accounts = Util.data("login.account");
        if (!accounts) accounts = [];
        this.render(ct, {accounts: accounts});
    },
    loginAjax: function (account, pwd, isDeamon) {
        if (!isDeamon) {
            Widget.popupLoading('正在登录');
        }
        $.ajax({
            type: 'POST',
            url: WEB_URL + "/resident/user/login",
            dataType: 'json',
            data: {mobileNo: account, password: pwd}
        }).done(function (json) {
                if (!isDeamon) {
                    Widget.popupLoadingClose();
                }
                if (json.success) {
                    $.extend(UserProfile, json.data);
                    Util.data('members.lastGet', (new Date()).getTime());
                    var member = json.data.patients[0];
                    Util.data('current.member', member);
                    UserProfile.setUserLoggedIn();
                    // loginSuccess();
                    if (isDeamon) {
                        return;
                    }
                    Util.data("account", account);
                    Util.data("pwd", pwd);
                    //跳转至首页
                    var accounts = Util.data("login.account");
                    if (!accounts) accounts = [];
                    if (!isAccountExsit(account)) {
                        accounts.unshift(account);
                        Util.data("login.account", accounts);
                    }
                    StageManager.pushView(Views.mainView, function () {
                        Util.checkVersionUpdate();
                    });
                    //UserProfile.setUserRemindPassword({code:params.mobileNo,password:params.password});
                } else {
                    if ("用户名密码不正确" === json.errMsg) {
                        UserProfile.setUserRemindPassword({code: '', password: ''});
                    }
                    Widget.popupToast(json.errMsg);
                }
            }).fail(function (jqXHR, textStatus, errorThrown) {
                Util.data('current.member', "");
                if (!isDeamon) {
                    Widget.popupLoadingClose();
                }
                Widget.popupToast('网络异常，请重试:-(');
            });
    }
});
Callback.accountToggle = function (btnId) {
    var $ele = $("#" + btnId);
    var input = $("#account");
    if ($ele.attr('data-rel') !== 'open') {
        input.val($ele.text());
    }
    var icon = $('.right-icon');
    if (icon.hasClass("collapse")) {
        icon.removeClass("collapse");
        icon.addClass("expand");
    } else {
        icon.removeClass("expand");
        icon.addClass("collapse");
    }
    $(".submit-form .account-container").toggle();
}
Callback.loginSubmit = function () {
    var $account = $("#account");
    var account = $account.val();
    var $pwd = $("#password");
    var pwd = $pwd.val();
    if (!account) {
        Widget.popupToast('请输入账号');
        $account.focus();
        return false;
    }
    if (!Validator.mobileNo.test(account)) {
        Widget.popupToast('账号不是手机号:-(');
        return false;
    }
    if (!pwd) {
        Widget.popupToast('请输入密码');
        $pwd.focus();
        return false;
    }
    if (!Validator.password.test(pwd)) {
        Widget.popupToast('密码请控制在6-16位:-(');
        return false;
    }
    Views.loginView.loginAjax(account, pwd);
    return false;
}
function isAccountExsit(account) {
    var accounts = Util.data("login.account");
    if (accounts) {
        for (var i = 0, len = accounts.length; i < len; i++) {
            if (accounts[i] === account) {
                accounts.splice(i, 1);
                accounts.unshift(account);
                Util.data("login.account", accounts);
                return true;
            }
        }
    }
    return false;
}
/*
 *启动app和登陆成功后，进行一些查询.如果是在app从后台重新唤起，需要编写原生代码支持.
 */
function loginSuccess() {
    //判断是否需要绑定推送
//	if( !Util.data('pushDevice') ) {
    cordova.exec(function (result) {
        console.log("success");
    }, function () {
        console.log("fail");
    }, 'PushRegister', 'bindChannel', [
        WEB_URL + '/resident/push/bind', UserProfile.id, UserProfile.getFamilyId(), device.uuid
    ]);
    Util.log(">>>>>>>>>>>exec end<<<<<<<<<<<<<<<<<");
//	}
}
//------------------------- 找回密码
Views.findpwdView = $.extend({}, Views.PanelView, {
    isSecuritycodeBtnEnable: true,
    options: {
        tmpl: 'findpwdView',
        name: '找回密码'
    },
    show: function (questions, account) {
        this.questions = questions;
        this.account = account;
        StageManager.pushView(this);
    },
    willShow: function (ct) {
        this.render(ct, {data: this.questions, account: this.account});
        this.bindEvents();
    },
    bindEvents: function () {
        $(".submit-form .ui-input-wrapper .right-icon.arrow").click(function () {
            var $ele = $(this);
            if ($ele.hasClass("collapse")) {
                $ele.removeClass("collapse");
                $ele.addClass("expand");
            } else {
                $ele.removeClass("expand");
                $ele.addClass("collapse");
            }
            $(".submit-form .account-container").toggle();
        });
        $("#question").click(function () {
            $(".submit-form .ui-input-wrapper .right-icon.arrow").click();
        });
    }
});
Callback.showFindpwdView = function () {
    var $account = $("#account");
    var account = $account.val();
    if (!account) {
        Widget.popupToast('请输入账号');
        $account.focus();
        return;
    }
    if (!Validator.mobileNo.test(account)) {
        Widget.popupToast('账号不是手机号:-(');
        return;
    }
    DataExchange.getSecurityQuestions({
        "account": account
    }).done(function (json) {
        if (json.success) {
            Views.findpwdView.show(json.data, account);
        }
    });
}
Callback.questionToggle = function (btnId) {
    var $ele = $("#" + btnId);
    var input = $("#question");
    input.val($ele.text());
    input.attr("data-rel", $ele.attr("data-rel"));
    $(".submit-form .ui-input-wrapper .right-icon.arrow").click();
}
Callback.findpwdSubmit = function () {
    var $phone = $("#phone");
    var phone = $phone.val();
    var $pwd = $("#pwd");
    var pwd = $pwd.val();
    var $pwdAgain = $("#pwdAgain");
    var pwdAgain = $pwdAgain.val();
    var $securitycode = $("#securitycode")
    var securitycode = $securitycode.val();
    if (!phone) {
        Widget.popupToast('请输入账号:-(');
        $phone.focus();
        return false;
    }
    if (!pwd) {
        Widget.popupToast('请输入密码:-(');
        $pwd.focus();
        return false;
    }
    if (!Validator.password.test(pwd)) {
        Widget.popupToast('密码请控制在6-16位:-(');
        return false;
    }
    if (!pwdAgain) {
        Widget.popupToast('请输入确认密码:-(');
        $pwdAgain.focus();
        return false;
    }
    if (pwd !== pwdAgain) {
        Widget.popupToast('两次密码输入不一致:-(');
        $pwdAgain.focus();
        return false;
    }
    if (!securitycode) {
        Widget.popupToast('请输入验证码:-(');
        $securitycode.focus();
        return false;
    }
    DataExchange.resetAccount({
        "data": {
            mobileNo: phone,
            newPassword: pwd,
            confirmPassword: pwdAgain,
            verifyCode: securitycode,
            questionId: $("#question").attr("data-rel"),
            answer: $("#answer").val()
        }
    }).done(function (json) {
            if (json.success) {
                Views.loginView.loginAjax(phone, pwd);
            }
        });
    return false;
}
Callback.getForgetPwdSecuritycode = function (btnId) {
    if (!Views.findpwdView.isSecuritycodeBtnEnable) {
        return;
    }
    var $btn = $("#" + btnId);
    var $phone = $("#phone");
    var phone = $phone.val();
    if (!phone || !Validator.mobileNo.test(phone)) {
        Widget.popupToast('请先输入合法的账号(手机号):-(');
        $phone.focus();
        return;
    }
    Views.findpwdView.isSecuritycodeBtnEnable = false;
    DataExchange.getForgetPwdSecuritycode({
        "phone": phone
    }).done(function (json) {
            if (json.success) {
            Widget.popupSuccess("验证码已发送，请注意查收");
                countdown($btn);
            } else {
                Views.findpwdView.isSecuritycodeBtnEnable = true;
            }
        }).fail(function (jqXHR, textStatus, errorThrown) {
            Views.findpwdView.isSecuritycodeBtnEnable = true;
        });
}
//------------------------- 注册
Views.registerView = $.extend({}, Views.PanelView, {
    isSecuritycodeBtnEnable: true,
    options: {
        tmpl: 'registerView',
        name: '注册'
    }
});
Callback.getSecuritycode = function (btnId) {
    if (!Views.registerView.isSecuritycodeBtnEnable) {
        return;
    }
    var $btn = $("#" + btnId);
    var $phone = $("#phone");
    var phone = $phone.val();
    if (!phone || !Validator.mobileNo.test(phone)) {
        Widget.popupToast('请先输入合法的账号(手机号):-(');
        $phone.focus();
        return;
    }
    Views.registerView.isSecuritycodeBtnEnable = false;
    DataExchange.getRegisterSecuritycode({
        "phone": phone
    }).done(function (json) {
            if (json.success) {
            Widget.popupSuccess("验证码已发送，请注意查收");
                countdown($btn);
            } else {
                Views.registerView.isSecuritycodeBtnEnable = true;
            }
        }).fail(function (jqXHR, textStatus, errorThrown) {
            Views.registerView.isSecuritycodeBtnEnable = true;
        });
}
function countdown($ele) {
    var $countdown = $ele;
    var second = 60;
    $countdown.text(second + "秒后重试");
    var step = function () {
        var $countdown = $('.securitycode');
        if (second == 0) {
            Views.registerView.isSecuritycodeBtnEnable = true;
            Views.findpwdView.isSecuritycodeBtnEnable = true;
            $countdown.text("重新获取");
            return;
        }
        second = second - 1;
        $countdown.text(second + "秒后重试");
        setTimeout(step, 1000);
    };
    setTimeout(step, 1000);
}
Callback.registerSubmit = function () {
    var $phone = $("#phone"), phone = $phone.val(), $pwd = $("#password"), pwd = $pwd.val(), $pwdAgain = $("#passwordAgain"), pwdAgain = $pwdAgain.val(), $securitycode = $("#securitycode"), securitycode = $securitycode.val();
    if (!phone) {
        Widget.popupToast('请输入账号:-(');
        $phone.focus();
        return false;
    }
    if (!Validator.mobileNo.test(phone)) {
        Widget.popupToast('账号不是手机号:-(');
        return false;
    }
    if (!pwd) {
        Widget.popupToast('请输入密码:-(');
        $pwd.focus();
        return false;
    }
    if (!Validator.password.test(pwd)) {
        Widget.popupToast('密码请控制在6-16位:-(');
        return false;
    }
    if (!pwdAgain) {
        Widget.popupToast('请输入确认密码:-(');
        $pwdAgain.focus();
        return false;
    }
    if (pwd !== pwdAgain) {
        Widget.popupToast('两次输入密码不一致:-(');
        $pwdAgain.focus();
        return false;
    }
    if (!securitycode) {
        Widget.popupToast('请输入验证码:-(');
        $securitycode.focus();
        return false;
    }
    DataExchange.registerSubmit({
        "data": {
            mobileNo: phone,
            password: pwd,
            confirmPassword: pwdAgain,
            verifyCode: securitycode,
            heraCode: HERACODE
        }
    }).done(function (json) {
            if (json.success) {
                UserProfile.setUserLogout();
                $.extend(UserProfile, json.data);
                UserProfile.setUserLoggedIn();
                Views.loginView.loginAjax(phone, pwd);
            }
        });
    return false;
};
//------------------------- 注册协议
Views.registerProtocolView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'registerProtocolView',
        name: '注册协议'
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.ui-scroll'));
    }
});

function pushBindSuccess(arr) {
    Util.log(arr);
}

Views.contactsView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'contactsView',
        name: '家庭医生'
    },
    data: [
        {
            name:'下城区天水武林街道社区卫生服务中心',
            address: '下城区耶稣堂弄4号',
            mobile: '18958059603'
        },
        {
            name:'胭脂新村社区卫生服务站',
            address: '下城区胭脂新村8幢底层',
            mobile: '85173791'
        },
        {
            name:'灯芯巷社区卫生服务站',
            address: '下城区灯芯巷14—8号',
            mobile: '85175231'
        },
        {
            name:'皇亲苑社区卫生服务站',
            address: '下城区茶叶弄3号1单元105室',
            mobile: '85069863'
        },
        {
            name:'环北社区卫生服务站',
            address: '下城区环北新村5幢101-102室',
            mobile: '85060972'
        },
        {
            name:'仓桥社区卫生服务站',
            address: '下城区三华园4幢',
            mobile: '85779163'
        },
        {
            name:'中北社区卫生服务站',
            address: '下城区孩儿巷44号',
            mobile: '87039036'
        },
        {
            name:'环西社区卫生服务站',
            address: '下城区环西新村9幢旁',
            mobile: '85176722'
        },
        {
            name:'长寿社区卫生服务站',
            address: '下城区凤起路519号',
            mobile: '87017285'
        },
        {
            name:'下城区文晖街道社区卫生服务中心',
            address: '下城区绍兴支路25号',
            mobile: '85455364'
        },
        {
            name:'和平苑社区卫生服务站',
            address: '下城区打铁关新村12幢旁',
            mobile: '85342397'
        },
        {
            name:'现代城社区卫生服务站',
            address: '下城区现代雅苑23幢底层',
            mobile: '85815087'
        },
        {
            name:'三里家园社区卫生服务站',
            address: '下城区水岸雅苑9幢3号',
            mobile: '86781962'
        },
        {
            name:'胜利社区卫生服务站',
            address: '下城区香积寺东路82号',
            mobile: '85158839'
        },
        {
            name:'下城区长庆潮鸣街道社区卫生服务中心',
            address: '下城区新华路86号',
            mobile: '85976351'
        },
        {
            name:'浙大御跸社区卫生服务站',
            address: '下城区大营盘26号',
            mobile: '85199614'
        },
        {
            name:'十五家园社区卫生服务站',
            address: '下城区十五家园79号',
            mobile: '85069557'
        },
        {
            name:'所巷社区卫生服务站',
            address: '下城区锦园13-6号',
            mobile: '85185188'
        },
        {
            name:'体东社区卫生服务站',
            address: '下城区体育场路20号',
            mobile: '85184169'
        },
        {
            name:'小天竺社区卫生服务站',
            address: '下城区刀茅巷107号',
            mobile: '87044266'
        },
        {
            name:'下城区朝晖街道社区卫生服务中心',
            address: '下城区朝晖七区12号',
            mobile: '85239941'
        },
        {
            name:'大木桥社区卫生服务站',
            address: '下城区朝晖六区菜场北侧',
            mobile: '85330656'
        },
        {
            name:'应家桥社区卫生服务站',
            address: '下城区应家桥社区老人公寓内',
            mobile: '85335993'
        },
        {
            name:'青园社区卫生服务站',
            address: '下城区青园小区2幢',
            mobile: '85303116'
        },
        {
            name:'施家花园社区卫生服务站',
            address: '下城区施家花园10幢8号',
            mobile: '85455771'
        },
        {
            name:'玉公桥社区卫生服务站',
            address: '下城区朝晖二区14幢底层西侧',
            mobile: '85132659'
        },
        {
            name:'塘北社区卫生服务站',
            address: '下城区河东路176号',
            mobile: '85332170'
        },
        {
            name:'下城区东新街道社区卫生服务中心',
            address: '下城区东新路白兔墩1号',
            mobile: '15397195570'
        },
        {
            name:'沁园社区卫生服务站',
            address: '下城区香积寺路177号',
            mobile: '85354402'
        },
        {
            name:'三塘社区卫生服务站',
            address: '下城区绍兴路461号',
            mobile: '85359328'
        },
        {
            name:'东新园社区卫生服务站',
            address: '下城区香积寺路东新园社区办公楼北一楼',
            mobile: '85083956'
        },
        {
            name:'中舟社区卫生服务站',
            address: '下城区德胜路3号',
            mobile: '85342023'
        },
        {
            name:'新颜苑社区卫生服务站',
            address: '下城区东新路重机宿舍16-101-102',
            mobile: '85811885'
        },
        {
            name:'水漾苑社区卫生服务站',
            address: '下城区白石路漾河公寓43号',
            mobile: '85269488'
        },
        {
            name:'长青苑社区卫生服务站',
            address: '下城区三塘汶苑11幢1单元1楼',
            mobile: '85057319'
        },
        {
            name:'富春园社区卫生服务站',
            address: '下城区德胜东村37幢底楼',
            mobile: '85380060'
        },
        {
            name:'下城区石桥街道社区卫生服务中心',
            address: '下城区石桥路316号',
            mobile: '17767077950'
        },
        {
            name:'北景园社区卫生服务站',
            address: '下城区北景园永清路86号',
            mobile: '88352737'
        },
        {
            name:'石桥社区卫生服务站',
            address: '下城区甘长东苑7-2号',
            mobile: '88354502'
        },
        {
            name:'永丰社区卫生服务站',
            address: '下城区永佳苑永丰社区卫生活动中心',
            mobile: '85081410'
        },
        {
            name:'华丰社区卫生服务站',
            address: '下城区华丰南苑2幢1号',
            mobile: '85816507'
        },
        {
            name:'华中社区卫生服务站',
            address: '下城区下城区人才公寓4-1幢1-5号',
            mobile: '88134101'
        }
    ],
    willShow: function (ct) {
        this.render(ct, {data: this.data});
    },
    didShow: function (ct) {
        this.viewScrollerInit($('.ui-page-body'));
    }
});